// Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:47 PM CET 2011
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  
// Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.



/*--------------------------------------------------
 * File: pprint.cc
 *
 * Description:
 * Pretty Printer for a test suite.
 *
 */



#include		<stdio.h>
#include		<strings.h> // For strcmp et al
#include		<time.h>
#include		<access.hh>


/* Declarations */
extern void init_pprint_pre_post();
void init_application();



/* Definitions */


int main(int argc, char **argv)
{
  AccessSuite suite;
  char *argv0 = argv[0];
  char *asn1modulelistfile = NULL;

  /* Switches. */
  if ( argc > 2 && strcmp(argv[1], "-A") == 0 )
    {
      argc -= 2;
      argv += 2;
      asn1modulelistfile = argv[0];
    }

  /* Soundness of arguments. */
  if ( argc < 2 )
    {
      fprintf( stderr, "Usage: %s [-A listfile] suitename {id}\n", argv0 );
      return 1;
    }

  if ( ! suite->open( argv[1], asn1modulelistfile ) )
    {
      fprintf( stderr, "Initiator failed!\n" );
      return 1;
    }

  /* initialise the user defined pre post functions */
  init_application();


  if ( argc == 2 )
    {
      suite->trav_root();
    }
  else
    for ( int i = 2 ; i < argc ; i++ )
      {
	if ( ! suite->trav_reference( argv[i] ))
	  fprintf( stderr, "%s could not be found.\n",
		   argv[i] );
      }
  
  fprintf( stdout, "DONE!\n" );
  
  suite->close();
  
  return 0;
}


void init_application()
{
  init_pprint_pre_post();
}
