// Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:47 PM CET 2011
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 1993, 2011.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  
// Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
/*
 * Name: access.hh
 *
 * Description:
 *
 *  Compatibility include file for ITEX Access of versions earlier than 3.3.
 *  In order to use this file, the type time_t must be defined, normally 
 *  found in <time.h>
 *
 *  See the notes below for a better solution than including this file.
 *
 *  See also ITEXAccessVisitor.hh for an alternative (smaller,
 *  faster and reentrant) traverser API.
 *
 */

#ifndef ITEXACCESS_HH
# define ITEXACCESS_HH

#ifndef ITEXACCESS_DEREF
/* For backwards compatibility and better performance: */
#define ITEXACCESS_DEREF(c) const c* operator->() const { return this; };
#endif

#include <ITEXAccessClasses.hh>
#include <ITEXAccessTraverser.hh>

/*
 *  Notes: 
 *
 *   In order to use the alternative traverser API include
 *   ITEXAccessClasses.hh and ITEXAccessVisitor.hh instead of this
 *   file.
 * 
 *   In order to use ITEX Access without traversal classes, only
 *   include the file ITEXAccessClasses.hh.  
 */

#endif

