/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mt_deb.h
+------------------------------------------------------------------------------+
*/
/*-MHDR*/

#ifndef __MT_DEB_H_
#define __MT_DEB_H_

#ifdef XSYSID
  /*
  ** If partitioning is used, then redefine function names and global vars
  ** to make them unique in the whole system (over
  ** all partitions)
  */
  #define xmk_SystemState                     XMAKENAME(XSYSID,SystemState)

  #define xmk_DebugInit                       XMAKENAME(XSYSID,Init)
  #define xmk_SystemSuspend                   XMAKENAME(XSYSID,SystemSuspend)
  #define xmk_SystemResume                    XMAKENAME(XSYSID,SystemResume)
  #define xmk_SystemReInit                    XMAKENAME(XSYSID,SystemReInit)
  #define xmk_SystemShutdown                  XMAKENAME(XSYSID,SystemShutdown)
  #define xmk_SingleStep                      XMAKENAME(XSYSID,SingleStep)
  #define xmk_DisableTimer                    XMAKENAME(XSYSID,DisableTimer)
  #define xmk_EnableTimer                     XMAKENAME(XSYSID,EnableTimer)
  #define xmk_NextStep                        XMAKENAME(XSYSID,NextStep)
  #define xmk_SystemContinue                  XMAKENAME(XSYSID,SystemContinue)
  #define xmk_SetBreakpoint                   XMAKENAME(XSYSID,SetBreakpoint)
  #define xmk_ClearBreakpointIndex            XMAKENAME(XSYSID,ClearBreakpointIndex)
  #define xmk_BackupXPDTBL                    XMAKENAME(XSYSID,BackupXPDTBL)
  #define xmk_RestoreXPDTBL                   XMAKENAME(XSYSID,RestoreXPDTBL)
  #define xmk_ClearBackupXPDTBL               XMAKENAME(XSYSID,ClearBackupXPDTBL)
  #define xmk_ClearAllBreakpoints             XMAKENAME(XSYSID,ClearAllBreakpoints)
  #define xmk_CheckIfBreakpointTrue           XMAKENAME(XSYSID,CheckIfBreakpointTrue)
  #define xmk_QueryBreakpoint                 XMAKENAME(XSYSID,QueryBreakpoint)
#endif /* ... XSYSID */


  #define  XMK_NO_CMD_SET        0x0000
  #define  XMK_SYSTEM_SUSPENDED  0x0001
  #define  XMK_REINIT_SYSTEM     0x0002
  #define  XMK_TIMER_DISABLED    0x0004
  #define  XMK_BREAKPOINT_SET    0x0008
  #define  XMK_SINGLE_STEPPING   0x0010
  #define  XMK_SYSTEM_SHUTDOWN   0x0020
  #define  XMK_SYSTEM_NEXT_STEP  0x0040
  #define  XMK_BREAKPOINT_HIT    0x0080
  #define  XMK_BP_WAS_STATE      0x0100
  #define  XMK_BP_WAS_INPUT      0x0200
  #define  XMK_BP_WAS_INPINSTATE 0x0300

  extern   unsigned int xmk_SystemState;

  extern   void          xmk_DebugInit              (void);
  extern   unsigned char xmk_SystemSuspend          (void);
  extern   unsigned char xmk_SystemResume           (void);
  extern   unsigned char xmk_SystemReInit           (void);
  extern   unsigned char xmk_SystemShutdown         (void);
  extern   unsigned char xmk_SingleStep             (void);
  extern   unsigned char xmk_DisableTimer           (void);
  extern   unsigned char xmk_EnableTimer            (void);
  extern   unsigned char xmk_NextStep               (void);
  extern   unsigned char xmk_SystemContinue         (void);
  extern   unsigned char xmk_SetBreakpoint          (xPID, xmk_T_SIGNAL, xmk_T_STATE);
  extern   unsigned char xmk_ClearBreakpointIndex   (int);

  #if defined(XMK_ADD_CREINIT)
    extern void xmk_BackupXPDTBL      (void);
    extern void xmk_RestoreXPDTBL     (void);
    extern void xmk_ClearBackupXPDTBL (void);
  #endif

  extern unsigned char xmk_ClearAllBreakpoints    (void);
  extern xmk_T_BOOL    xmk_CheckIfBreakpointTrue  (xPID, xmk_T_SIGNAL, xmk_T_STATE);
  extern xmk_T_CMD_QUERY_BREAKPOINT_CNF* xmk_QueryBreakpoint ( unsigned char );

#endif
