/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __vms_vr_ttcn_h
#define __vms_vr_ttcn_h

/**************************************************************************************************/

#define VR_BOOLEAN(typeinfo) NOTHING
#define VR_NULL(typeinfo) NOTHING
#define VR_OBJECT_IDENTIFIER(typeinfo) NOTHING
#define VR_REAL(typeinfo) NOTHING
#define VR_INTEGER(typeinfo) NOTHING
#define VR_BIT_STRING(typeinfo) NOTHING
#define VR_OCTET_STRING(typeinfo) NOTHING
#define VR_NumericString(typeinfo) NOTHING
#define VR_PrintableString(typeinfo) NOTHING
#define VR_IA5String(typeinfo) NOTHING
#define VR_VisibleString(typeinfo) NOTHING
#define VR_UTCTime(typeinfo) NOTHING
#define VR_GeneralizedTime(typeinfo) NOTHING
#define VR_ENUMERATED(typeinfo) NOTHING
#define VR_SEQUENCE(typeinfo) NOTHING
#define VR_SET(typeinfo) NOTHING
#define VR_SEQUENCE_OF(typeinfo) NOTHING
#define VR_SET_OF(typeinfo) NOTHING
#define VR_CHOICE(typeinfo) NOTHING
#define VR_DEFINED(typeinfo) NOTHING
#define VR_TAGGED(typeinfo) NOTHING
#define VR_OPEN_ID(typeinfo) NOTHING
#define VR_OPEN(typeinfo) NOTHING

/**************************************************************************************************/
/**************************************************************************************************/

#define VMSGetValue(Coder, InVal, Type, OutVal) \
  OutVal = (void*)EGciMkValueFromTypeName(((tASN1TypeInfo*)Type)->TypeName + 6)

#define VMSSetValue(Coder, OutVal, Type, InVal) \
  *(GciValue**)OutVal = (GciValue*)InVal

/**************************************************************************************************/

#define VMSGetBOOLEAN(Coder, InVal, Type, OutBool) \
  OutBool = (tVMSBoolean)GciGetBOOLEAN((GciValue*)InVal)

#define VMSSetBOOLEAN(Coder, OutVal, Type, InBool) \
  if(InBool > 0) EGciSetBOOLEAN((GciValue*)OutVal, GcTRUE); \
  else EGciSetBOOLEAN((GciValue*)OutVal, GcFALSE)

/**************************************************************************************************/

#define VMSGetNULL(Coder, InVal, Type, OutNull) \
   OutNull = NULL

#define VMSSetNULL(Coder, OutVal, Type, InNull) \
  EGciSetNULL((GciValue*)OutVal);

/**************************************************************************************************/

#define VMSInitOBJECT_IDENTIFIER(Coder, OutVal, Type)

#define VMSGetSizeOBJECT_IDENTIFIER(Coder, InVal, Type, OutSize) \
  OutSize = (tVMSULong)GciOBJECT_IDENTIFIERSize((GciValue*)InVal);

#define VMSGetComponentOBJECT_IDENTIFIER(Coder, InVal, Type, InIndex, OutComponent) \
  OutComponent = GciGetOBJECT_IDENTIFIERComponent((GciValue*)InVal, (int)InIndex);

#define VMSSetComponentOBJECT_IDENTIFIER(Coder, OutVal, Type, InComponent) \
  (GciValue*)OutVal = GciAddOBJECT_IDENTIFIERComponent((GciValue*)OutVal, (int)InComponent);

/**************************************************************************************************/

#define VMSGetREAL(Coder, InVal, Type, OutReal) \
 INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, \
                        ERR_ARG(__FILE__) ERR_ARG(__LINE__));

#define VMSSetREAL(Coder, OutVal, Type, InReal) \
 INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, \
                        ERR_ARG(__FILE__) ERR_ARG(__LINE__));

/**************************************************************************************************/

#define VMSGetINTEGER(Coder, InVal, Type, OutInt) \
TTCNGetIntegerValue(Coder, Type, (GciValue*)InVal, &OutInt)

#define VMSSetINTEGER(Coder, OutVal, Type, InInt) \
TTCNSetIntegerValue(Coder, Type, &InInt, (GciValue*)OutVal)

/**************************************************************************************************/

#define VMSAllocBIT_STRING(Coder, IOString, OCurrPtr, ILength) \
if (IOString.Value == NULL) \
  { \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(ILength + 1, 0); \
    IOString.Length = ILength; \
    OCurrPtr = IOString.Value; \
  } \
else \
  { \
    tVMSString_Value __tmp_val; \
    __tmp_val = (tVMSString_Value)CUCF_ALLOC(IOString.Length + ILength, 0); \
    memcpy(__tmp_val, IOString.Value, IOString.Length); \
    CUCF_FREE(IOString.Value, IOString.Length, 0); \
    IOString.Value = __tmp_val; \
    OCurrPtr = IOString.Value + IOString.Length; \
    IOString.Length += ILength; \
  }

#define VMSGetLengthBIT_STRING(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetBIT_STRING((GciValue*)InVal));

#define VMSGetOctetBIT_STRING(Coder, IOStringVal, InRealSize, OutByte) \
  { \
    unsigned char __i; \
    (OutByte) = 0; \
    for (__i = 0; __i < InRealSize; __i++, IOStringVal++) \
      (OutByte) |= (unsigned char)((*IOStringVal - '0') << (7 - __i)); \
  }

#define VMSPutOctetBIT_STRING(Coder, IOCurrPtr, IByte, ISize) \
{ \
  unsigned char __i; \
  for (__i = 0; __i < ISize; __i++, IOCurrPtr++) \
    *IOCurrPtr = (unsigned char)(((IByte) >> (7 - __i)) & 0x1) + '0'; \
}

#define VMSGetBIT_STRING(Coder, InVal, TypeInfo, OutString) \
  { \
    OutString.Value = (tVMSString_Value)GciGetBIT_STRING((GciValue*)InVal); \
    OutString.Length = (tVMSULong)strlen((char*)(OutString.Value)); \
    OutString.IsAssigned = 1; \
  }

#define VMSSetBIT_STRING(Coder, OutVal, Type, InString) \
InString.IsAssigned = 0; \
if (InString.Length != 0) \
  { \
    *(InString.Value + InString.Length) = '\0'; \
    EGciSetSTRING((GciValue*)OutVal, (char*)(InString.Value)); \
  } \
else \
  EGciSetSTRING((GciValue*)OutVal, "\0");

#define VMSFreeBitString(Coder, IString) \
  if (IString.IsAssigned == 0 && IString.Length > 0) \
      CUCF_FREE(IString.Value, IString.Length + 1, 0)

/**************************************************************************************************/

#define VMSAllocOCTET_STRING(Coder, IOString, OCurrPtr, ILength) \
if (IOString.Value == NULL) \
  { \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC((ILength << 1) + 1 , 0); \
    IOString.Length = ILength; \
    OCurrPtr = IOString.Value; \
  } \
else \
  { \
    tVMSString_Value __tmp_val; \
    __tmp_val = (tVMSString_Value)CUCF_ALLOC(((IOString.Length + ILength) << 1) + 1, 0); \
    memcpy(__tmp_val, IOString.Value, IOString.Length); \
    CUCF_FREE(IOString.Value, IOString.Length, 0); \
    IOString.Value = __tmp_val; \
    OCurrPtr = IOString.Value + IOString.Length; \
    IOString.Length += ILength; \
  }

#define VMSGetLengthOCTET_STRING(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)((strlen((char*)GciGetOCTET_STRING((GciValue*)InVal)) + 1) >> 1);

#define VMSGetOCTET_STRING(Coder, InVal, Type, OutString) \
{ \
  tVMSString_Value __curr_symb = (tVMSString_Value)GciGetOCTET_STRING((GciValue*)InVal); \
  if (__curr_symb != NULL) \
    { \
      tVMSULong __curr_len = strlen((char*)__curr_symb); \
      if (__curr_len != 0) \
        { \
          tVMSULong __i; \
          tVMSString_Value __curr_new; \
          OutString.IsAssigned = 0; \
          OutString.Length = (__curr_len + 1) >> 1; \
          OutString.Value = (tVMSString_Value)CUCF_ALLOC((OutString.Length << 1) + 1 , 0); \
          __curr_new = OutString.Value; \
          for (*__curr_new = 0, __i = 0; __i < __curr_len; __i++, __curr_symb++) \
            { \
              if (!(__i & 0x1) && (__i != 0)) \
                { __curr_new++; *__curr_new = 0; } \
              if (('0' <= *__curr_symb) && (*__curr_symb <= '9')) \
                *__curr_new |= ((*__curr_symb - '0') << ((__i & 0x1) ? 0 : 4)); \
              else \
              if (('A' <= *__curr_symb) && (*__curr_symb <= 'F')) \
                *__curr_new |= ((*__curr_symb - 'A' + 10) << ((__i & 0x1) ? 0 : 4)); \
              else \
              if (('a' <= *__curr_symb) && (*__curr_symb <= 'f')) \
                *__curr_new |= ((*__curr_symb - 'a' + 10) << ((__i & 0x1) ? 0 : 4)); \
            } \
        } \
      else \
        { \
          OutString.IsAssigned = 1; \
          OutString.Length = 0; \
          OutString.Value = NULL; \
        } \
    } \
  else \
    { \
      OutString.IsAssigned = 1; \
      OutString.Value = NULL; \
      OutString.Length = 0; \
    } \
}

#define VMSSetOCTET_STRING(Coder, OutVal, Type, InString) \
InString.IsAssigned = 0; \
if (InString.Length != 0) \
  { \
    tVMSULong __i; \
    tVMSString_Value __curr_str_end = InString.Value + (InString.Length - 1); \
    tVMSString_Value __curr_str_bgn = InString.Value + (InString.Length << 1); \
    *__curr_str_bgn = '\0'; \
    __curr_str_bgn--; \
    for (__i = InString.Length; __i > 0; __i--, __curr_str_bgn -= 2, __curr_str_end--) \
      { \
        char __half = (*__curr_str_end & 0x0F); \
        if (__half < 10) *__curr_str_bgn = __half + '0'; \
        else *__curr_str_bgn = 'A' + (__half  - 10); \
        __half = (*__curr_str_end >> 4); \
        if (__half < 10) *(__curr_str_bgn - 1) = __half + '0'; \
        else *(__curr_str_bgn - 1) = 'A' + (__half  - 10); \
      } \
    EGciSetSTRING((GciValue*)OutVal, (char*)(InString.Value)); \
  } \
else \
  EGciSetSTRING((GciValue*)OutVal, "\0");

#define VMSFreeOctetString(Coder, IString) \
  if (IString.IsAssigned == 0 && IString.Length > 0) \
      CUCF_FREE(IString.Value, (IString.Length << 1) + 1, 0)

/**************************************************************************************************/

#define VMSAllocCHARACTER_STRING(Coder, IOString, OCurrPtr, ILength) \
if (IOString.Value == NULL) \
  { \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(ILength + 1 , 0); \
    IOString.Length = ILength; \
    OCurrPtr = (tVMSString_Value)(IOString.Value); \
  } \
else \
  { \
    tVMSString_Value __tmp_val; \
    __tmp_val = (tVMSString_Value)CUCF_ALLOC(IOString.Length + ILength + 1, 0); \
    memcpy(__tmp_val, (tVMSString_Value)(IOString.Value), IOString.Length); \
    CUCF_FREE(IOString.Value, IOString.Length, 0); \
    IOString.Value = (tVMSString_Value)__tmp_val; \
    OCurrPtr = (tVMSString_Value)(IOString.Value) + IOString.Length; \
    IOString.Length += ILength; \
  }

#define VMSFreeCharString(Coder, IString) \
  if (IString.IsAssigned == 0 && IString.Length > 0) \
      CUCF_FREE(IString.Value, IString.Length + 1, 0)

/**************************************************************************************************/

#define VMSGetLengthNumericString(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetNumericString((GciValue*)InVal));

#define VMSGetNumericString(Coder, InVal, Type, OutString) \
{ \
  OutString.Value = (tVMSString_Value)GciGetNumericString((GciValue*)InVal); \
  OutString.Length = strlen((char*)(OutString.Value)); \
  OutString.IsAssigned = 1; \
}

#define VMSSetNumericString(Coder, OutVal, Type, InString) \
InString.IsAssigned = 0; \
if (InString.Length > 0) \
  { \
    *(InString.Value + InString.Length) = '\0'; \
    EGciSetSTRING((GciValue*)OutVal, (char*)(InString.Value)); \
  } \
else \
  EGciSetSTRING((GciValue*)OutVal, "\0");

/**************************************************************************************************/

#define VMSGetLengthPrintableString(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetPrintableString((GciValue*)InVal));

#define VMSGetPrintableString(Coder, InVal, Type, OutString) \
{ \
  OutString.Value = (tVMSString_Value)GciGetPrintableString((GciValue*)InVal); \
  OutString.Length = strlen((char*)(OutString.Value)); \
  OutString.IsAssigned = 1; \
}

#define VMSSetPrintableString(Coder, OutVal, Type, InString) \
  VMSSetNumericString(Coder, OutVal, Type, InString)

/**************************************************************************************************/

#define VMSGetLengthIA5String(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetIA5String((GciValue*)InVal));

#define VMSGetIA5String(Coder, InVal, Type, OutString) \
{ \
  OutString.Value = (tVMSString_Value)GciGetIA5StringWithNULL((GciValue*)InVal, &(OutString.Length)); \
  OutString.IsAssigned = 1; \
}

#define VMSSetIA5String(Coder, OutVal, Type, InString) \
InString.IsAssigned = 0; \
if (InString.Length > 0) \
  EGciSetSTRINGWithNULL((GciValue*)OutVal, (const char*)(InString.Value), InString.Length); \
else \
  EGciSetSTRING((GciValue*)OutVal, "\0");

/**************************************************************************************************/

#define VMSGetLengthVisibleString(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetVisibleString((GciValue*)InVal));

#define VMSGetVisibleString(Coder, InVal, Type, OutString) \
{ \
  OutString.Value = (tVMSString_Value)GciGetVisibleString((GciValue*)InVal); \
  OutString.Length = strlen((char*)(OutString.Value)); \
  OutString.IsAssigned = 1; \
}

#define VMSSetVisibleString(Coder, OutVal, Type, InString) \
  VMSSetNumericString(Coder, OutVal, Type, InString)

/**************************************************************************************************/

#define VMSGetLengthUTCTime(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetUTCTime((GciValue*)InVal));

#define VMSGetUTCTime(Coder, InVal, Type, OutString) \
{ \
  OutString.Value = (tVMSString_Value)GciGetUTCTime((GciValue*)InVal); \
  OutString.Length = strlen((char*)(OutString.Value)); \
  OutString.IsAssigned = 1; \
}

#define VMSSetUTCTime(Coder, OutVal, Type, InString) \
  VMSSetNumericString(Coder, OutVal, Type, InString)

/**************************************************************************************************/

#define VMSGetLengthGeneralizedTime(Coder, InVal, Type, OutString) \
  OutString.Length = (tVMSULong)strlen((char*)GciGetGeneralizedTime((GciValue*)InVal));

#define VMSGetGeneralizedTime(Coder, InVal, Type, OutString) \
{ \
  OutString.Value = (tVMSString_Value)GciGetGeneralizedTime((GciValue*)InVal); \
  OutString.Length = strlen((char*)(OutString.Value)); \
  OutString.IsAssigned = 1; \
}

#define VMSSetGeneralizedTime(Coder, OutVal, Type, InString) \
  VMSSetNumericString(Coder, OutVal, Type, InString)

/**************************************************************************************************/

#define VMSGetIndexENUMERATED(Coder, InVal, Type, OutIndex) \
{ \
  tVMSUInteger __value; \
  TTCNGetIntegerValue(Coder, Type, (GciValue*)InVal, &__value); \
  if (Type->TypeClass == type_ASN1_ENUMERATED) \
    { \
      tASN1Item*  __curr_item = ((tASN1Enumerated*)Type)->Items; \
      for((OutIndex) = 0; (OutIndex) < ((tASN1Enumerated*)Type)->NumOfItems; (OutIndex)++, __curr_item++) \
        if((int)(__curr_item->Value) == (__value.Sign ? -(int)(__value.Number) : (int)(__value.Number))) break; \
    } \
  else \
    { \
      tASN1BItem*  __curr_item = ((tASN1BEnumerated*)Type)->Items; \
      for((OutIndex) = 0; (OutIndex) < ((tASN1BEnumerated*)Type)->NumOfItems; (OutIndex)++, __curr_item++) \
        if ((__curr_item->Sign == __value.Sign) && (__curr_item->Number == __value.Number)) break; \
    } \
}

#define VMSSetIndexENUMERATED(Coder, OutVal, Type, InIndex) \
{ \
  tASN1Item* __items = ((tASN1Enumerated*)Type)->Items; \
  (GciValue*)OutVal = EGciSetENUMERATEDByName((GciValue*)OutVal, __items[InIndex].Name); \
}

#define VMSGetValueENUMERATED(Coder, InVal, Type, OutVal) \
TTCNGetIntegerValue(Coder, Type, (GciValue*)InVal, &OutVal)

#define VMSSetValueENUMERATED(Coder, OutVal, Type, InValue) \
{ \
  char* __name; \
  unsigned int __i; \
  if (Type->TypeClass == type_ASN1_ENUMERATED) \
    { \
      tASN1Item*  __curr_item = ((tASN1Enumerated*)Type)->Items; \
      for(__i = 0; __i < ((tASN1Enumerated*)Type)->NumOfItems; __i++, __curr_item++) \
        if ((int)(__curr_item->Value) == (InValue.Sign ? -(int)(InValue.Number) : (int)(InValue.Number))) \
          { \
            __name = __curr_item->Name; \
            break; \
          } \
    } \
  else \
    { \
      tASN1BItem*  __curr_item = ((tASN1BEnumerated*)Type)->Items; \
      for(__i = 0; __i < ((tASN1BEnumerated*)Type)->NumOfItems; __i++, __curr_item++) \
        if ((__curr_item->Sign == InValue.Sign) && (__curr_item->Number == InValue.Number)) \
          { \
            __name = __curr_item->Name; \
            break; \
          } \
    } \
  (GciValue*)OutVal = EGciSetENUMERATEDByName((GciValue*)OutVal, __name); \
}

/**************************************************************************************************/

#define VMSGetComponentSEQUENCE(Coder, InVal, Type, InCompInfo, OutComponent) \
  OutComponent = (void*)GciGetField((GciValue*)InVal, InCompInfo->Index + 1)

#define VMSGetOptionalComponentSEQUENCE(Coder, InVal, Type, InCompInfo, OutComponent) \
  { \
    OutComponent = (void*)GciGetField((GciValue*)InVal, InCompInfo->Index + 1); \
    if (GciGetOMIT((GciValue*)OutComponent) == GcTRUE) \
      OutComponent = NULL; \
  }

#define VMSGetDefaultComponentSEQUENCE(Coder, InVal, Type, InCompInfo, OutComponent) \
  { \
    OutComponent = (void*)GciGetField((GciValue*)InVal, InCompInfo->Index + 1); \
    if (GciGetOMIT((GciValue*)OutComponent) == GcTRUE) \
      OutComponent = NULL; \
  }

#define VMSInitSEQUENCE(Coder, OutVal, Type)

#define VMSInitPresentOptionalComponentSEQUENCE(Coder, OutVal, Type, InCompInfo)                \
  {                                                                                             \
    GciValue* __PresentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciResetOMIT(__PresentComp);                                                               \
  }

#define VMSInitAbsentOptionalComponentSEQUENCE(Coder, OutVal, Type, InCompInfo) \
  { \
    GciValue* __AbsentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciSetOMIT(__AbsentComp); \
  }

#define VMSInitPresentDefaultComponentSEQUENCE(Coder, OutVal, Type, InCompInfo)                 \
  {                                                                                             \
    GciValue* __PresentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciResetOMIT(__PresentComp);                                                               \
  }


#define VMSInitAbsentDefaultComponentSEQUENCE(Coder, OutVal, Type, InCompInfo) \
  { \
    GciValue* __AbsentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciSetOMIT(__AbsentComp); \
  }

/**************************************************************************************************/

#define VMSGetComponentSET(Coder, InVal, Type, InCompInfo, OutComponent) \
  OutComponent = (void*)GciGetField((GciValue*)InVal, InCompInfo->Index + 1)

#define VMSGetOptionalComponentSET(Coder, InVal, Type, InCompInfo, OutComponent) \
  { \
    OutComponent = (void*)GciGetField((GciValue*)InVal, InCompInfo->Index + 1); \
    if (GciGetOMIT((GciValue*)OutComponent) == GcTRUE) \
      OutComponent = NULL; \
  }

#define VMSGetDefaultComponentSET(Coder, InVal, Type, InCompInfo, OutComponent) \
  { \
    OutComponent = (void*)GciGetField((GciValue*)InVal, InCompInfo->Index + 1); \
    if (GciGetOMIT((GciValue*)OutComponent) == GcTRUE) \
      OutComponent = NULL; \
  }

#define VMSInitSET(Coder, OutVal, Type)

#define VMSInitPresentOptionalComponentSET(Coder, OutVal, Type, InCompInfo)                     \
  {                                                                                             \
    GciValue* __PresentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciResetOMIT(__PresentComp);                                                               \
  }

#define VMSInitAbsentOptionalComponentSET(Coder, OutVal, Type, InCompInfo) \
  { \
    GciValue* __AbsentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciSetOMIT(__AbsentComp); \
  }

#define VMSInitPresentDefaultComponentSET(Coder, OutVal, Type, InCompInfo)                      \
  {                                                                                             \
    GciValue* __PresentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciResetOMIT(__PresentComp);                                                               \
  }

#define VMSInitAbsentDefaultComponentSET(Coder, OutVal, Type, InCompInfo) \
  { \
    GciValue* __AbsentComp = (GciValue*)GciGetField((GciValue*)OutVal, InCompInfo->Index + 1); \
    EGciSetOMIT(__AbsentComp); \
  }

/**************************************************************************************************/

#define VMSInitSEQUENCE_OF(Coder, OutVal, Type) \
  EGciSetEmptySEQUENCE_OF((GciValue*)OutVal);

#define VMSInitComponentSEQUENCE_OF(Coder, InVal, Type, InIndex, OutComponent) \
  OutComponent = (void*)EGciGetSEQUENCE_OFElement((GciValue*)InVal)

#define VMSGetSizeSEQUENCE_OF(Coder, InVal, Type, OutSize) \
  OutSize = (tVMSULong)GciSeqOfSize((GciValue*)InVal)

#define VMSGetComponentSEQUENCE_OF(Coder, InVal, Type, InIndex, OutComponent) \
  OutComponent = (void*)GciGetElem((GciValue*)InVal, InIndex)

#define VMSSetComponentSEQUENCE_OF(Coder, OutVal, Type, InIndex, InComponent) \
  OutVal = (void*)GciAddElem((GciValue*)OutVal, (GciValue*)InComponent)

/**************************************************************************************************/

#define VMSInitSET_OF(Coder, OutVal, Type) \
  EGciSetEmptySET_OF((GciValue*)OutVal);

#define VMSInitComponentSET_OF(Coder, InVal, Type, OutComponent) \
  OutComponent = (void*)EGciGetSET_OFElement((GciValue*)InVal)

#define VMSGetSizeSET_OF(Coder, InVal, Type, OutSize) \
  OutSize = (tVMSULong)GciSeqOfSize((GciValue*)InVal)

#define VMSGetComponentSET_OF(Coder, InVal, Type, InIndex, OutComponent) \
  OutComponent = (void*)GciGetElem((GciValue*)InVal, InIndex)

#define VMSSetComponentSET_OF(Coder, OutVal, Type, InComponent) \
  OutVal = (void*)GciAddElem((GciValue*)OutVal, (GciValue*)InComponent)

/**************************************************************************************************/

#define VMSInitCHOICE(Coder, OutVal, Type)

#define VMSGetAlternativeCHOICE(Coder, InVal, InType, OutAltInfo, OutAlternative) \
{ \
  char* __alt_name = (char*)GciGetCHOICEName((GciValue*)InVal); \
  CODER_NumOf_TYPE __num_of_alts = ((tASN1Choice*)InType)->NumOfAlts; \
  OutAltInfo = ((tASN1Choice*)InType)->Alternatives; \
  while (__num_of_alts > 0) \
    { \
      if ((OutAltInfo->Type != ct_Absent) && (strcmp(OutAltInfo->Name, __alt_name) == 0)) break; \
      OutAltInfo++; \
      __num_of_alts--; \
    } \
  OutAlternative = (void*)GciGetCHOICE((GciValue*)InVal); \
}

#define VMSSetAlternativeCHOICE(Coder, OutVal, Type, InAltInfo, OutAlternative) \
  OutAlternative = EGciGetChoiceMemberByName((GciValue*)OutVal, InAltInfo->Name)

/**************************************************************************************************/

#define VMSInitOPEN(Coder, OutVal, Type)

#define VMSGetObjectOPEN(Coder, InVal, Type, OutObjInfo, OutObject) \
{ \
  char* __obj_name = (char*)GciGetCHOICEName((GciValue*)InVal); \
  tASN1Object* __curr_obj = ((tASN1Open*)Type)->Objects; \
  CODER_NumOf_TYPE __curr_index; \
 \
  for (__curr_index = 0; __curr_index < ((tASN1Open*)Type)->NumOfObjects; __curr_index++, __curr_obj++) \
    if (strcmp(__curr_obj->Name, __obj_name) == 0) break; \
  OutObjInfo = __curr_obj; \
  OutObject = (void*)GciGetCHOICE((GciValue*)InVal); \
}

#define VMSSetObjectOPEN(Coder, OutVal, Type, InObjInfo, OutObject) \
  OutObject = EGciGetChoiceMemberByName((GciValue*)OutVal, InObjInfo->Name);

#endif /* __vms_vr_ttcn_h */
