/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/*====================================================================
	
	parser.c    included in tlayer.c if used with -DHOST

			Version: 1.0	July 12, 1996
					
	containes following routines:
	Load and analyze syntax of configurationfile "tarsim.cfg"
	Shell for SDT SIMUI started with giving the command ":" (colon)
		and exited with command EXIT
	Debug and log facilities for PostMaster signals to and from target.
	Note: Unix only! No debug/log/grep on Windows.
	Error messages etc.

======================================================================*/

#ifdef JUSTPARSER
/*#include "sp.h"
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/socket.h> */
#include "tlayer.h"
#endif
#ifndef TARGET


FILE *SearchConfigFile(char **FileSearchlist, int *ListIndex)
{
	int i = 1;
	FILE *tmp = NULL;
	char *pathptr;
	pathptr = getenv(FileSearchlist[0]);
	if(pathptr != NULL)
		if( pathptr[0]!=0){
		     *ListIndex = 0;
			return((FILE *)CheckConfigFile(pathptr));

		}
	
	while( i < SearchListItems ){
	*ListIndex = i;
		pathptr = getenv(FileSearchlist[i]);
		if(pathptr != NULL)
			if( pathptr[0]!=0)
				if((tmp = (FILE *)CheckConfigFile(pathptr)) != NULL)
					break;
	i++;
	}
	return tmp;
}
				
FILE *CheckConfigFile(char *pathptr)
{
	char ABSCONFIGPATH[100], *conpath = ABSCONFIGPATH;
	int k;
	strcpy(conpath,pathptr);
	k = strlen(conpath);
		if(conpath[k-1]!=PATHSEPARATOR){
		conpath[k]=PATHSEPARATOR;
		k++;		
	}
	conpath[k] = 0;
	strcat(conpath,CON_FILE);
	strcpy(TriedToOpen,conpath);
	return(fopen(conpath,"r"));
}


/*---+---------------------------------------------------------------
     LoadConfigFile (local)
-------------------------------------------------------------------*/
int LoadConfigFile() {
	FILE *fp,*tmplp;
#ifndef WINDOWS
	FILE *lp = NULL;
	int lpwarning=FALSE, logsetline = 0;
#ifndef fpos_t
	typedef long fpos_t;
#endif  /*fpos_t*/
	fpos_t	curpos;
#endif  /*!WINDOWS*/
	char cfgline[100];
	char service[20];
	char argument[3][30];
	char TIMEBUF[100];
	int i,j,k=0;
   int targetsetline=0, hostsetline=0, pathsetline=0, Index=-1;
	struct tm *tnow;
	time_t	curtime;

#ifdef WINDOWS
	WSADATA wsaData;
   int ret;
#endif
/* stderr doesn't work on Windows, but cause no harm either */
STARTUP_HOST
	if((fp = SearchConfigFile( (char **)&SearchList, &Index ) )==(FILE*)NULL ) {
          sprintf(globuf,"================================================\n");
          CFG_ERROR(globuf);
	    sprintf(globuf,"Fatal:   Missing configuration file: %s\n",CON_FILE);
          CFG_ERROR(globuf);
	    sprintf(globuf,"         File searched in path %s\n",
			getenv(SearchList[Index]));
          CFG_ERROR(globuf);
	    sprintf(globuf,"         as specified in env variable $%s\n",
			SearchList[Index]);
          CFG_ERROR(globuf);
#ifndef WINDOWS
	    sprintf(globuf,"         Copy this file to the current directory: %s\n",
			getenv("PWD"));
          CFG_ERROR(globuf);
	    sprintf(globuf,"         or to your home directory: %s\n",
			getenv("HOME"));
          CFG_ERROR(globuf);

	    sprintf(globuf,"         When done, restart host simulator\n");
          CFG_ERROR(globuf);
#endif
#ifndef JUSTPARSER
          xReleaseUI(0);
#endif
 	    return 0;
       }

	 while( fgets(cfgline,100,fp) != NULL ){
	 	cfgline[strlen(cfgline)-1]='\0';
	 	k++;
	 	if(cfgline[0]!='#'){
	 		argument[0][0]='\0';
	 		argument[1][0]='\0';
	 		argument[2][0]='\0';
	 		service[0]='\0';
	 		sscanf(cfgline,"%s",service);
               for (i=0; i < strlen(service); i++)
                    service[i] = (char) toupper(service[i]);
               service[strlen(service)]='\0';
			if(!strcmp(service,"END")) break;
                  else if(!strcmp(service,"FORCEIP")){
                	sscanf(cfgline,"%s%s",service,argument[0]);
  				for (i=0; i < strlen((char*)argument[0]); i++)
                        	argument[0][i] = (char) toupper(argument[0][i]);
               	argument[0][strlen((char*)argument[0])]='\0';
                	if(!strcmp(argument[0],"ON"))
                		FORCEIP = TRUE;
                	else
                		FORCEIP = FALSE;
                  }
			else if(!strcmp(service,"TARGET")){
				sscanf(cfgline,"%s %s %d %s",service,TARGETIPNR,
					&TARGETPORT,TARGETNAME);
				if(targetsetline>0){
					sprintf(globuf,
					"%s%s\n%s\n%s %s line %d and %d\n%s",
              			"================================================\n",
              			"Error:   multiple TARGETS specified",
              			"         please remove (or uncomment with #) one",
                		      "         see config-file",CON_FILE,targetsetline,k,
              			"================================================\n");
                              CFG_ERROR(globuf);
#ifndef JUSTPARSER
                              xReleaseUI(0);
#endif
                		return(0);
                	}
                	if(convertIP(TARGETIPNR)==(struct hostent *)NULL){
                     if(FORCEIP == FALSE){
					sprintf(globuf,
					"%s%s %s %s\n%s %s line %d\n%s",
              			"================================================\n",
              			"Error:   IP-address", TARGETIPNR,"is invalid.",
                	       	"         see config-file",CON_FILE,k,
              			"================================================\n");
                              CFG_ERROR(globuf);
#ifndef JUSTPARSER
                              xReleaseUI(0);
#endif
                	      	return(0);
                      }else{
#ifdef JUSTPARSER
					sprintf(globuf,
					"%s%s %s %s\n%s %s line %d\n%s\n%s",
              			"================================================\n",
              			"Warning:   IP-address", TARGETIPNR,"seems invalid.",
                		      "         see config-file",CON_FILE,k,
                              "FORCEIP mode used, target address will be used as is.",
              			"================================================\n");
                              CFG_ERROR(globuf);
#endif
                      } /* if FORCEIP */
                	}                	
                	targetsetline = k;
			}
			else if(!strcmp(service,"HOST")){
				sscanf(cfgline,"%s%s%d%s",service,HOSTIPNR,
					&HOSTPORT,HOSTNAME);
				if(hostsetline>0){
#ifdef JUSTPARSER
					sprintf(globuf,
					"%s%s\n%s %s %d %s\n%s\n%s %s line %d and %d\n",
              			"================================================\n",
              			"Warning: multiple HOSTS specified",
              			"         last one,",HOSTIPNR,HOSTPORT,"will be used",
              			"         (Host's address is not crusial for functionality)",
                	      	"         see config-file",CON_FILE,hostsetline,k);
                              CFG_ERROR(globuf);
#endif
                	}
                	if(convertIP(HOSTIPNR)==(struct hostent *)NULL){
#ifdef JUSTPARSER
					sprintf(globuf,
					"%s%s %s %s\n%s\n%s %s line %d\n",
              			"================================================\n",
              			"Warning: IP-address", HOSTIPNR,"is invalid.",
              			"         (Host's address is not crusial for functionality)",
                	      	"         see config-file",CON_FILE,k);
                              CFG_ERROR(globuf);
#endif
              			strcpy(HOSTIPNR,"?");
              			HOSTPORT = 0;
                	}                	
                	hostsetline = k;
               }
			else if(!strcmp(service,"COM")){
				sscanf(cfgline,"%s %s %s",service,argument[0],argument[1]);
				for(j=0;j<2;j++){
					for (i=0; i < strlen((char*)argument[j]); i++)
                        		argument[j][i] = (char) toupper(argument[j][i]);
                		argument[j][strlen((char*)argument[j])]='\0';
				}
				if(!strcmp(argument[0],"TARGET")){
					if(!strcmp(argument[1],"TCP")){ /* || here to accepted stuff */
						strcpy(TARGETCOMSTRING,argument[1]); /* change to predef int*/
					}
					else{
                			sprintf(globuf,"================================================\n");
					CFG_ERROR(globuf);
					sprintf(globuf,"Error:   communication via %s not supported\n",
							argument[1]);
					CFG_ERROR(globuf);
					sprintf(globuf,"         see config-file %s line %d\n",CON_FILE,k);
					CFG_ERROR(globuf);
                			sprintf(globuf,"================================================\n");
					CFG_ERROR(globuf);
#ifndef JUSTPARSER
					xReleaseUI(0);
#endif		
					return 0;
					}
				}
                }
#ifndef WINDOWS
                else if(!strcmp(service,"DEBUG")){
                	sscanf(cfgline,"%s%s",service,argument[0]);
  						for (i=0; i < strlen((char*)argument[0]); i++)
                        	argument[0][i] = (char) toupper(argument[0][i]);
               	argument[0][strlen((char*)argument[0])]='\0';
                	if(!strcmp(argument[0],"ON"))
                		DEBUG = TRUE;
                	else
                		DEBUG = FALSE;
                }
#endif  /*!WINDOWS*/
                else if(!strcmp(service,"USETIMEOUT")){
					sscanf(cfgline,"%s%s",service,argument[0]);
					for (i=0; i < strlen((char*)argument[0]); i++)
                        	argument[0][i] = (char) toupper(argument[0][i]);
					argument[0][strlen((char*)argument[0])]='\0';
              		if(!strcmp(argument[0],"OFF") || !strcmp(argument[0],"FALSE")
              		 		|| !strcmp(argument[0],"NO"))
                		UseTimeout = FALSE;
                	else
                		UseTimeout = TRUE; /*default*/
                }
                else if(!strcmp(service,"SDLPATH")){
                	sscanf(cfgline,"%s%s",service,argument[0]);
                	if(argument[0][strlen((char*)argument[0])-1]==PATHSEPARATOR)
                		argument[0][strlen((char*)argument[0])-1]='\0';
                	sprintf(argument[1],"%s%c.",argument[0],PATHSEPARATOR);
                	if(pathsetline){
 					sprintf(globuf,
					"%s%s\n%s %s %s\n%s %s %s\n%s %s line %d and %d\n",
              			"================================================\n",
              			"Warning: multiple SDL sourcepaths specified",
              			"         previous,",SDLSOURCEPATH,"will not be used",
              			"         current,",argument[0],"will be used instead",
                			"         see config-file",CON_FILE,pathsetline,k);
					CFG_ERROR(globuf);
#ifndef JUSTPARSER
					xReleaseUI(0);
#endif
                	}
#ifndef __BORLANDC__
                	if((tmplp = fopen(argument[1],"r"))==(FILE*)NULL){
#else
                 {
                  int drive =  getdisk();
                 	getcurdir(drive ,argument[2]);
                  drive += (int) 'A';
                  i = chdir (argument[1]);
                  argument[1][0] = (char) drive;
                  argument[1][1] = ':';
                  argument[1][2] = '\\';
                  argument[1][3] = 0;
                  strcat(argument[1],argument[2]);
                  (void) chdir (argument[1]);
                 }
                 if (i == -1){
#endif /*__BORLANDC__*/

				sprintf(globuf,"================================================\n");
				CFG_ERROR(globuf);
				sprintf(globuf,"Error:   SDL source directory %s does not exist\n",
							argument[0]);
				CFG_ERROR(globuf);
				sprintf(globuf,"         no changing of source directories will be made\n");
				CFG_ERROR(globuf);
				sprintf(globuf,"         or previous setup persists\n");
				CFG_ERROR(globuf);
				sprintf(globuf,"         see config-file %s line %d\n",CON_FILE,k);
				CFG_ERROR(globuf);
#ifndef JUSTPARSER
				xReleaseUI(0);
#endif
				}
				else{
					strcpy(SDLSOURCEPATH,argument[0]);
					CHANGEPATH = TRUE;
					pathsetline = k;
				}
#ifndef WINDOWS
            fclose(tmplp);
#endif
			 }	 
#ifndef WINDOWS
                else if(!strcmp(service,"LOG")){
                	sscanf(cfgline,"%s %s",service,argument[0]);
                	if(strlen(argument[0])>0){
                	strcpy(argument[1],LOGFILESTRING);
                	if(lp!=NULL || logsetline>0){
                		if(!(LOGFILE == stderr || LOGFILE == stdout)){
				  /* j = fgetpos(lp,&curpos); Not on SunOS 4 */
				  curpos = (long)ftell(lp);
                			fclose(lp);
                			if(curpos==0)remove(LOGFILESTRING);
                			lp = NULL;
                		}
                		lpwarning = TRUE;
                	}
                	if(!strcmp(argument[0],"stderr")){
                		strcpy(LOGFILESTRING,argument[0]);
                		LOGFILE = stderr;
                	}
                	else if(!strcmp(argument[0],"stdout")){
                		strcpy(LOGFILESTRING,argument[0]);
                		LOGFILE = stdout;
                	}
                	else if(!strcmp(argument[0],"stdin") ||
                	 		!strcmp(argument[0],CON_FILE) ||
                	 		!strcmp(argument[0],"host.sct") ||
					!strcmp(argument[0],"host.exe") ){
                		sprintf(globuf,"================================================\n");
				CFG_ERROR(globuf);
                	 	sprintf(globuf,"Error:   %s is not a valid log-file\n",argument[0]);
				CFG_ERROR(globuf);
                	 	sprintf(globuf,"         stderr will be used as log device instead\n");
				CFG_ERROR(globuf);
 				sprintf(globuf,"         see config-file %s line %d\n",CON_FILE,k);
				CFG_ERROR(globuf);
#ifndef JUSTPARSER
				xReleaseUI(0);
#endif
                	 	strcpy(LOGFILESTRING,"stderr");
                	 	if(lpwarning){strcat(argument[0],">");strcat(argument[0],"stderr");}
                		LOGFILE = stderr;
                	}
                	else if((lp = fopen(argument[0],"a") )==(FILE*)NULL){
                		sprintf(globuf,"================================================\n");
				CFG_ERROR(globuf);
 				sprintf(globuf,
 					"Error:   Cannot open log-file %s (see %s line %d) ",
 					argument[0],CON_FILE,k);
				CFG_ERROR(globuf);
#ifdef JUSTPARSER
 				perror("         error");
#endif
#ifndef JUSTPARSER
				xReleaseUI(0);
#endif
 				fclose(lp);
 				strcpy(LOGFILESTRING,"stderr");
                		LOGFILE = stderr;
                		lp = NULL;
 				}	
 				else{
 					strcpy(LOGFILESTRING,argument[0]);
                		LOGFILE = lp;

 				} /* file could be opened */
 				if(lpwarning){ /* yes, it only warns for the two last ones! */
              			sprintf(globuf,
              			"%s\n%s\n%s %s, %s\n%s %s, %s\n%s %s line %d and %d\n",
              			"================================================",
              			"Warning: multiple log-files specified",
              			"         previous,",argument[1],"will not be used.",
               			"         current,",argument[0],"will be used instead.",
                			"         see config-file",CON_FILE,logsetline,k); 
					CFG_ERROR(globuf);
#ifndef JUSTPARSER
				xReleaseUI(0);
#endif	
                		lpwarning = FALSE;
                	}	
                	logsetline = k;
 				} /* file is specified at all */
        		}
#endif /*!WINDOWS*/	        		
           }
     }
#ifndef WINDOWS
	if(!DEBUG && strcmp(LOGFILESTRING,"NONE"))fclose(lp);
     if(!strcmp(LOGFILESTRING,"NONE")) strcpy(LOGFILESTRING,"stderr");
#endif
	if((TARGETPORT==0 || strlen(TARGETIPNR)<7) && !strcmp(TARGETCOMSTRING,"TCP")){
          sprintf(globuf,"================================================\n");
	    CFG_ERROR(globuf);
	    sprintf(globuf,"Fatal:   You must specify where target is located.\n");
	    CFG_ERROR(globuf);
	    sprintf(globuf,"         write a line in %s according to this pattern:\n",CON_FILE);
	    CFG_ERROR(globuf);
	    sprintf(globuf,"         TARGET       111.22.3.44   17000  (computer@company)\n");
	    CFG_ERROR(globuf);
	    sprintf(globuf,"         i.e.TARGET   ip-address    port   (optional name)\n");
	    CFG_ERROR(globuf);
          sprintf(globuf,"================================================\n");
	    CFG_ERROR(globuf);
#ifndef JUSTPARSER
	    xReleaseUI(0);
#endif
	    return 0;
	}
	if(strlen(TARGETCOMSTRING)<2)strcpy(TARGETCOMSTRING,"TCP");    
	time(&curtime);
	tnow = localtime(&curtime);
	sprintf(TIMEBUF,asctime(tnow));
#ifndef WINDOWS
	tmplp = LOGFILE;	
	if(!DEBUG || LOGFILE==stderr || LOGFILE==stdout){
		j=1;
	}
	else{
		j=2;		 
	}
	if(!(LOGFILE==stdout))LOGFILE = stderr;
	for(i=0;i<j;i++){
		fprintf(LOGFILE,"\n================================================\n");
		fprintf(LOGFILE,"Simulation log started: %s",TIMEBUF);
		fprintf(LOGFILE,"TARGET: %16s  %5d  (%s)\n",TARGETIPNR,TARGETPORT,TARGETNAME);
		fprintf(LOGFILE,"HOST:	%16s  %5d  (%s)\n",HOSTIPNR,HOSTPORT,HOSTNAME);
		fprintf(LOGFILE,"DEBUG:  %s %s\n",(DEBUG)?"   on file":"is",
							(DEBUG)?LOGFILESTRING:"OFF");
	if(CHANGEPATH)fprintf(LOGFILE,"SLDPATH:   %s\n",SDLSOURCEPATH);
		fprintf(LOGFILE,"TARGETCOM: %s\n",TARGETCOMSTRING);
	if(!UseTimeout)fprintf(LOGFILE,"Timeouts on signals to target disabled, wait forever!\n");
		fprintf(LOGFILE,"================================================\n");
		LOGFILE = tmplp;
	}
#endif /*!WINDOWS*/
	fclose(fp);
PRE_EXIT
	return 1;
}

struct hostent *convertIP(char *IPNR)
{
	/* Some shitty systems like SUNOS4 cannot take a "dotted ip-addr" to gethostbyname(),
		so we have to convert it manually and try gethostbyaddr().
	[if this doesn't work we might want to connect to it anyway, it's just not in /etc/hosts] */
	struct hostent *hostp;
	char ipbuf[20];
	unsigned long ip_bin = 0;
	unsigned int ip_part[4];
	strcpy(ipbuf,IPNR);
	sscanf(ipbuf,"%u.%u.%u.%u",&ip_part[0],&ip_part[1],&ip_part[2],&ip_part[3]);
	ip_bin += (unsigned long)ip_part[0] << 24;
	ip_bin += (unsigned long)ip_part[1] << 16;
	ip_bin += (unsigned long)ip_part[2] <<  8;
	ip_bin += (unsigned long)ip_part[3];
	ip_bin = htonl(ip_bin);
	hostp = (struct hostent *)gethostbyaddr((char *)&ip_bin,4,PROTOCOL);
	return hostp;
}

#ifndef JUSTPARSER

#ifndef WINDOWS
#define ns(m)	strcpy(se_trans_buffp,m)
static char se_trans_buff[40];
static char *se_trans_buffp = se_trans_buff;
int logger(int CLIENT, int event, int from, int to, int size, char *data)
{
	char client[20];
	char frompid[8],topid[8];
	char logbuffer[DEFAULTBUFSIZE];
	int TARGETPid = -1,ret;
	memset(logbuffer,0,DEFAULTBUFSIZE);
	messNrtoStr(event);
	if(from){
		if(MSCEPid && from == MSCEPid)strcpy(frompid,"MSCE");
		else if(SIMUIPid && from == SIMUIPid)strcpy(frompid,"SIMUI");
		else if(SDLEPid && from == SDLEPid)strcpy(frompid,"SDLE");
		else if(from == TARGETPid)strcpy(frompid,"TARGET");
		else sprintf(frompid,"%d",from);
	}
	else strcpy(frompid,"       ");
	if(to){
		if(MSCEPid && to == MSCEPid)strcpy(topid,"MSCE");
		else if(SIMUIPid && to == SIMUIPid)strcpy(topid,"SIMUI");
		else if(SDLEPid && to == SDLEPid)strcpy(topid,"SDLE");
		else if(to == TARGETPid)strcpy(topid,"TARGET");
		else sprintf(topid,"%d",to);
	}
	else strcpy(topid,"       ");
	switch(CLIENT){
		case PM:
			strcpy(client,"From  PostM");
			sprintf(logbuffer,
				"%11s: event%22s (%5d), from%7s %9s size=%4d data=%s\n",
				client,se_trans_buffp,event,frompid,"",size,data);	
			break;
		case TRG:
			strcpy(client,"From TARGET");
			sprintf(logbuffer,
				"%11s: event%22s (%5d), from%7s to%7s size=%4d data=%s\n",
				client,se_trans_buffp,event,frompid,topid,size,data);		
			break;
		default:
			return FALSE;
	}
	ret = GrepFilter(logbuffer);
	if(ret)fprintf(LOGFILE,logbuffer);
	return TRUE;
}
#endif /*!WINDOWS*/

int PathChanger(char *reference)
{
	char localbuf[DEFAULTBUFSIZE],*localp = localbuf;
	char beforepath[DEFAULTBUFSIZE-150];
	char afterpath[150];
	char *bufp,*tmpp;
	memset(localbuf,0,DEFAULTBUFSIZE);
	memset(beforepath,0,DEFAULTBUFSIZE-150);
	memset(afterpath,0,150);
	strcpy(localbuf,reference);
	bufp = (char*)strstr(localbuf,"#SDTREF");
	if(bufp==NULL)return FALSE; /* signal does not contain path */
	while(*bufp!= ',')bufp++; bufp++;
	strncpy(beforepath,localbuf,(int)(bufp - localp));
	beforepath[(int)(bufp - localp)]='\0';
	tmpp = bufp;
	while(*bufp!=','){
		if((int)(bufp - localp)>strlen(localbuf))break;
		if(*bufp== '/' || *bufp== '\\')tmpp=bufp;
		bufp++;
	}
	bufp = tmpp;
      bufp[0] = PATHSEPARATOR; /*to get the right system*/
	strcpy(afterpath,bufp);
	memset(localbuf,0,DEFAULTBUFSIZE);
	strcpy(localbuf,beforepath);
	strcat(localbuf,SDLSOURCEPATH);
	strcat(localbuf,afterpath);

#ifndef WINDOWS
	strcpy(reference,localbuf);
#else
	{
      int j,k,i = strlen (localbuf);
      for (j=0,k=0;j<i;j++){
      	if(localbuf[j] ==PATHSEPARATOR){
         	reference[k] =PATHSEPARATOR; k++; }
         reference[k] = localbuf[j];
         k ++;
      }
    }
#endif
	return TRUE;
}

int xPingPM(void){
	char pingbuf[10];
	int sender,event = 0,size;
	void * data=NULL;
	int retStatus;
	int result = TRUE;
	sprintf(pingbuf,"%d",SIMUIPid);
	retStatus = SPSendToPid(SET_ORGANIZER,SEGETTOOLTYPE,
		(char *)pingbuf,strlen((char *)pingbuf)+1);
	
	do {
		if(data)free(data);
		data = NULL;
		retStatus = SPRead(3000,&sender,&event,&data,&size);
	} while( retStatus == SPOK && event != SEGETTOOLTYPEREPLY );
		
	if(retStatus==SPERROR)result = FALSE;
	if(event != SEGETTOOLTYPEREPLY && result)result = FALSE;
	if(data && result) sscanf((char*)data,"%d%d%d",&retStatus,&event,&sender);	
	if(!event && result) result = FALSE;
	if(sender != SET_SIMULATOR_UI && result) result = FALSE;
	if(data)free(data);
	return result;
}

int xPrintString(char *message){
	int sender,event,size;
	void * data=NULL;
	int retStatus;
	if(message==NULL) return FALSE;
	memcpy(indata,message,strlen(message)+1);			

	SPSendToPid(SIMUIPid,SESIMUISTRING,indata,strlen(message)+1);
	retStatus = SPRead(1000,&sender,&event,&data,&size);
	if(retStatus == SPERROR)
			retStatus = SPRead(1000,&sender,&event,&data,&size);
	if(retStatus == SPERROR)
			return SPERROR; /* SIMUI or PM is dead */
	if(event!=SESIMUISTRINGREPLY)
			return FALSE; /* we got the wrong message, send it to target */
	if(data)free(data);
	return TRUE;
}

int xGetString(char *message,int timeOut){
	int sender,event,size;
	void * data=NULL;	
	char localbuf[250],*localp=localbuf;
	int retStatus;
	if(timeOut == 0)timeOut = 3000;
	retStatus = SPRead(timeOut,&sender,&event,&data,&size);
	if(retStatus == SPERROR)
			retStatus = SPRead(timeOut,&sender,&event,&data,&size);
	if(retStatus == SPERROR)
			return SPERROR; /* SIMUI or PM or user is dead*/
	if(size>1)
		memcpy(localbuf,data,size);
	if(event!=SESIMUICOMMAND)
			return FALSE;   /* we got the wrong message, send it to target */
	strcpy(message,localp);
	if(data)free(data);
	return TRUE;
}

int xReleaseUI(int IsCommand){
	char nolla[2]="0\0";
	int sender,event,size;
	void * data=NULL;		
	int retStatus;
	if(IsCommand)		
		SPSendToPid(SIMUIPid,SESIMUICOMMANDREPLY,nolla,2);
	if(IsCommand!=SPERROR){
		SPSendToPid(SIMUIPid,SESIMUICHANGE,nolla,2);
	 	retStatus = SPRead(2000,&sender,&event,&data,&size);
	 	/* if(event!=SESIMUICHANGEREPLY) */
	    /* this should be used to check message! */
	}
	return retStatus; 	 		
}
#ifndef WINDOWS
int xShell(void){
	/* main loop for internal targetsim-host shell */
	char localbuf[200];
	char service[20];
	char argument[60];
	char outbuffer[100];
	int retStatus,done=0,i;
	FILE *tp;
	time_t	curtime;
	char TIMEBUF[100];
	struct tm *tnow;
	time(&curtime);
	tnow = localtime(&curtime);
	sprintf(TIMEBUF,asctime(tnow));
	xPrintString("\n\n==============================================================\n");
	xPrintString(": Welcome to the targetsim configuration shell\n");
	xPrintString(": To continue simulation type EXIT\n");
	xPrintString(": To get help with possible commands type HELP\n");
	xReleaseUI(1);
	xPrintString(":\n:");	
	while(!done){
		memset(localbuf,0,200);
		memset(service,0,20);
		memset(argument,0,60);
		memset(outbuffer,0,100);
		if((retStatus=xGetString(localbuf,60000))==SPERROR){
			xPrintString("\n: Shell timed out after 60 sec. Returning to simulation\n");
			xPrintString("==============================================================\n\n");			
			xReleaseUI(1);
			break;
		}
		else if(retStatus==FALSE){	/* this signal is yet not sent to target, fix that! */
			xPrintString(":\n: Got other signal. Terminating shell and continue simulation.\n");
			xPrintString("==============================================================\n\n");
			xReleaseUI(1);
			break;
		}
		else{
			sscanf(localbuf,"%s",service);
		     for (i=0; i < strlen(service); i++)
                    service[i] = (char) toupper(service[i]);
               if(!strcmp(service,"HELP")){
               	xPrintString(":\n: Following commands are available:\n");
               	xPrintString(": HELP     this text is shown\n");
               	xPrintString(": STATUS   shows current setup and simulation status\n");
               	xPrintString(": EXIT     exit shell and return to simulation\n");
               	xPrintString(": DEBUG    takes parameter ON/OFF for logging to\n");
               	xPrintString(":          stderr (default) or file specified by LOG\n");
               	xPrintString(": LOG      logfile for signal trace. default is stderr\n");
               	xPrintString(": GREP     up to 5 strings to search for in signal trace\n");
               	xPrintString(":          only signals where a GREP arg is found is logged\n");
               	xPrintString(":          to finish grep and log all, type GREP * \n");
               	xPrintString(":          a GREP arg can be inverted by typing !arg\n");
               	xPrintString(":          default is not case sensitive, if so wanted, type =arg\n");
               	xPrintString(":          example: GREP  MSCE  !SIMUI  =mydir/Filename\n");
               	sprintf(outbuffer,": OTHER COMMANDS CAN ONLY BE CHANGED ON STARTUP IN %s\n",CON_FILE);
               	xPrintString(outbuffer);
               	xPrintString(":\n:");
               	xReleaseUI(1);
               }
               else if(!strcmp(service,"EXIT")){
               /* Don't even think about it! PC SIMUI trigs on data. It will crash
               	if it gets the string exit regardless of context. */
               	xPrintString(": Terminating shell, returning to simulation\n");
				xPrintString("==============================================================\n\n");
				xReleaseUI(1);
               	break;
               }
               else if(!strcmp(service,"QUIT")){ /*from SIMUI menu (or, unf. from kbd)*/
					xReleaseUI(SPERROR);
					HostExitPM();
			}
			else if(!strcmp(service,"GREP")){
				retStatus = GrepSetup(localbuf);
				xPrintString(":\n:");
				if(retStatus == 0)
					xPrintString(" Old GREP's deleted\n");
				else if(retStatus == -8){
					xPrintString(" Grep status:\n:");
					xPrintString(localbuf); /*now containing message if ok*/
				}
				else{
					xPrintString(" Grep parsed:\n:");
					xPrintString(localbuf); /*now containing message if ok*/
				}
				xPrintString(":\n:");
               	xReleaseUI(1);
			}
            else if(!strcmp(service,"STATUS")){
               	xPrintString(":\n: Current simulation status:\n");
               	sprintf(outbuffer,": TIME %s",TIMEBUF);
               	xPrintString(outbuffer);
               	sprintf(outbuffer,": TARGET is %s on IP-addr %s port %d via %s\n",
               		(TargetReady)?"ON":"OFF",TARGETIPNR,TARGETPORT,TARGETCOMSTRING);
               	xPrintString(outbuffer);
			if(FORCEIP == TRUE){
			  xPrintString(": forced connection (FORCEIP = ON)\n");
 			}
               	if(DEBUG){
               		sprintf(outbuffer,": DEBUG is ON with LOG on %s\n",LOGFILESTRING);
               	     xPrintString(outbuffer);
               	     if(GREP){
						sprintf(outbuffer,": GREP on: %s %s %s %s %s\n",
							GREPSTRING[0],GREPSTRING[1],GREPSTRING[2],
							GREPSTRING[3],GREPSTRING[4]);
               			xPrintString(outbuffer);
               		}
               	}
               	else xPrintString(": DEBUG is OFF\n");
               	xPrintString(outbuffer);
               	if(CHANGEPATH){ 
               		sprintf(outbuffer,": SDL source files are pulled in from %s\n",	 
               				SDLSOURCEPATH);
               		xPrintString(outbuffer);
    		if(!UseTimeout)xPrintString("Timeouts on signals to target disabled, wait forever!\n");
               	xPrintString(":\n:");
               	xReleaseUI(1);
               	}
               }
               else if(!strcmp(service,"DEBUG")){
               	sscanf(localbuf,"%s%s",service,argument);
               	for (i=0; i < strlen(argument); i++)
                    	argument[i] = (char) toupper(argument[i]);
                    if(!strcmp(argument,"ON")){
                    	sprintf(outbuffer,":\n: Logging is switched ON to %s\n",LOGFILESTRING);
                    	xPrintString(outbuffer);
                    	if(!DEBUG){
                    	DEBUG = TRUE;
          		fprintf(LOGFILE,"\n================================================\n");
				fprintf(LOGFILE,"Simulation log started: %s",TIMEBUF);
				fprintf(LOGFILE,"TARGET: %16s  %5d  (%s)\n",TARGETIPNR,TARGETPORT,TARGETNAME);
				fprintf(LOGFILE,"HOST:	%16s  %5d  (%s)\n",HOSTIPNR,HOSTPORT,HOSTNAME);
				fprintf(LOGFILE,"DEBUG:  %s %s\n",(DEBUG)?"   on file":"is",
							(DEBUG)?LOGFILESTRING:"OFF");
				if(GREP)fprintf(LOGFILE,"GREP on %s %s %s %s %s\n",
					GREPSTRING[0],GREPSTRING[1],GREPSTRING[2],GREPSTRING[3],GREPSTRING[4]);
				if(CHANGEPATH)fprintf(LOGFILE,"SLDPATH:   %s\n",SDLSOURCEPATH);
				fprintf(LOGFILE,"TARGETCOM: %s\n",TARGETCOMSTRING);
				if(!UseTimeout)fprintf(LOGFILE,"Timeouts on signals to target disabled, wait forever!\n");
				fprintf(LOGFILE,"================================================\n");
                    	}
                    }
                    else if(!strcmp(argument,"OFF")){
                    	xPrintString(":\n: Logging is switched OFF\n");
                    	if(DEBUG){
                    		fprintf(LOGFILE,"================================================\n");
						fprintf(LOGFILE,"Simulation log stopped from SIMUI: %s",TIMEBUF);
						fprintf(LOGFILE,"================================================\n");
					}
                    	DEBUG = FALSE;
               	}
               	else{
               		sprintf(outbuffer,":\n: DEBUG logging is %s\n",(DEBUG)?"ON":"OFF");
                		xPrintString(outbuffer);
                	}
                	xPrintString(":\n:");
                	xReleaseUI(1);
               }
               else if(!strcmp(service,"LOG")){
               	sscanf(localbuf,"%s%s",service,argument);
               		xPrintString("\n:\n");
               	if(strlen(argument)<2){
               		if(DEBUG){
               			sprintf(outbuffer,": LOG is now on %s\n",LOGFILESTRING);
               			xPrintString(outbuffer);
               		}
               		else
               			xPrintString(": LOG is now OFF\n");
               	}
               	else if(strcmp(argument,LOGFILESTRING)){ /* not same */
               		if(!strcmp(argument,"stderr") || !strcmp(argument,"stdout")){
               			if(DEBUG){
                    		fprintf(LOGFILE,"================================================\n");
						fprintf(LOGFILE,"Simulation log stopped from SIMUI: %s",TIMEBUF);
						fprintf(LOGFILE,"and continued on %s\n",argument);
						fprintf(LOGFILE,"================================================\n");
						}
						if(LOGFILE!=stderr && LOGFILE!=stdout){
							fclose(LOGFILE);
						}
					}
					else if(!strcmp(argument,"stdin")||!strcmp(argument,"host.sct")||
						!strcmp(argument,"targetsim.cfg")){
						xPrintString(": Invalid file for logging\n");
					}
					else if((tp = fopen(argument,"a"))!=(FILE*)NULL) { /* file open ok */
					if(DEBUG){
                    		fprintf(LOGFILE,"================================================\n");
						fprintf(LOGFILE,"Simulation log stopped from SIMUI: %s",TIMEBUF);
						fprintf(LOGFILE,"and continued on %s\n",argument);
						fprintf(LOGFILE,"================================================\n");
					}
					if(LOGFILE!=stderr && LOGFILE!=stdout)
						fclose(LOGFILE);
					LOGFILE = tp;
                   	if(DEBUG){
          		fprintf(LOGFILE,"\n================================================\n");
				fprintf(LOGFILE,"Simulation log started: %s",TIMEBUF);
				fprintf(LOGFILE,"Logging continued from %s\n",LOGFILESTRING);
				fprintf(LOGFILE,"TARGET: %16s  %5d  (%s)\n",TARGETIPNR,TARGETPORT,TARGETNAME);
				fprintf(LOGFILE,"HOST:	%16s  %5d  (%s)\n",HOSTIPNR,HOSTPORT,HOSTNAME);
				fprintf(LOGFILE,"DEBUG:  %s %s\n",(DEBUG)?"   on file":"is",
							(DEBUG)?LOGFILESTRING:"OFF");
				if(GREP)fprintf(LOGFILE,"GREP on %s %s %s %s %s\n",
					GREPSTRING[0],GREPSTRING[1],GREPSTRING[2],GREPSTRING[3],GREPSTRING[4]);
				if(CHANGEPATH)fprintf(LOGFILE,"SLDPATH:   %s\n",SDLSOURCEPATH);
				fprintf(LOGFILE,"TARGETCOM: %s\n",TARGETCOMSTRING);
				if(!UseTimeout)fprintf(LOGFILE,"Timeouts on signals to target disabled, wait forever!\n");
				fprintf(LOGFILE,"================================================\n");
                    	}						
                    	strcpy(LOGFILESTRING,argument);
                    	sprintf(outbuffer,": Logging switched to %s\n",LOGFILESTRING);
					xPrintString(outbuffer);
					if(DEBUG)	
               			xPrintString(": LOG is ON\n");
               		else xPrintString(": LOG is OFF\n");
               		}
               		else{ /* file opening error */
               			xPrintString(": Specified LOG file could not be opened\n");
               		}
               	}
               	else {/* same LOGFILE as current */
               		xPrintString(": This file is already opened for logging\n");
               		if(DEBUG)	
               			xPrintString(": LOG is ON\n");
               		else xPrintString(": LOG is OFF\n");
               	}
               	xPrintString(":\n:");
				xReleaseUI(1);
               }
               else{
               	xPrintString(":\n: Unknown command, try HELP\n");
				xPrintString(":\n:");
				xReleaseUI(1);
			}
		}
		
	}
	return 0;
}
#endif /*!WINDOWS*/

int xExitMessage(void)
{
	time_t  curtime;
	char TIMEBUF[100];
	char TREASONREASON[100];
	struct tm *tnow;
	int PMOK;
	time(&curtime);
	tnow = localtime(&curtime);
	sprintf((char*)TIMEBUF,"%s",asctime(tnow));
	PMOK = xPingPM();
      if(ConfigFileOk == FALSE){
            strcpy(TREASONREASON,"Reading config file failed\n");
      }
	else if(comerror == CE_WRITEERROR || comerror == CE_CONNECTREFUSED)
		strcpy(TREASONREASON,"Connection with Target Failed\n");
	else if(!TargetReady){
   	  if(LastEvent == SESTOPNOTIFY)
      	strcpy(TREASONREASON,"Normal termination by user\n");
        else
      	strcpy(TREASONREASON,"Target has failed, sync impossible, needs restarting\n");
      }
	else if(!PMOK && LastEvent!=SESTOPNOTIFY)
		strcpy(TREASONREASON,"Lost contact with SDT PostMaster on HOST\n");
	else sprintf(TREASONREASON,"Unknown error, Last Event = %s\n",LastEvent);
#ifndef WINDOWS
	if(DEBUG){
		fprintf(LOGFILE,"\n================================================\n");
		fprintf(LOGFILE,"Simulation ended %s",TIMEBUF);
		fprintf(LOGFILE,"Cause of termination: %s",TREASONREASON);
		fprintf(LOGFILE,"================================================\n");
	}
#endif /*!WINDOWS*/
	if(!PMOK)return -1;
   sprintf(indata,"%s%s%s%s%s%s",
	"\n================================================\n",
	"Simulation ended ",TIMEBUF,"Cause of termination: ",
	TREASONREASON,"================================================\n" );
   xPrintString(indata);
   /* must do it in one string since the strings SIMUI can show 
      after the command Exit is entered is limited to two. Only PC */
	xReleaseUI(SPERROR);
	return 0;
}

int xErrorShell(int Problem)
{
	int i,done=0;
	char localbuf[60];
	char service[20];
	if(!xPingPM()) HostExitPM();
	else if(Problem == TRG_DEAD){
		xPrintString("\n================================================\n");
LBL_TARGET_DEAD_LOOP:	
		xPrintString("# No connection with target.\n");
		xPrintString("# Start Target and type INIT\n");
		xPrintString("# or type EXIT to quit simulation\n");
		xPrintString("\n");
		xPrintString("Command :");
		xPrintString(" ");
		xReleaseUI(1);
		while(!done){
			memset(localbuf,0,60);
			memset(service,0,20);
			if(xGetString(localbuf,SPWAITFOREVER)==TRUE){
				sscanf(localbuf,"%s",service); 		
		     	for (i=0; i < strlen(service); i++)
                    	service[i] = (char) toupper(service[i]);
				if(!strcmp(service,"EXIT")){
					done = 1;
				   xReleaseUI(SPERROR);
				   HostExitPM();
				}
				if(!strcmp(service,"QUIT")){ /*from SIMUI menu */
					done = 1;
					xReleaseUI(SPERROR);
					HostExitPM();
				}
				else if(!strcmp(service,"INIT")){
					if(HostInitPM(1)== -7){
						xPrintString("# still no connection.\n");
						xPrintString("# you can try again with INIT after rebooting target\n");
						xPrintString("# or quit this session with EXIT\n");
						
					} 
					else {
						xReleaseUI(1);
						return 0;
					}
				}
				else{
					xPrintString("# Unknown command. Only INIT or EXIT is valid here\n");
					
				}
			}
			xPrintString("\n");
			xReleaseUI(1);
		}
	}
		
	else if(Problem == TRG_SUSPEND){
		xPrintString("\n================================================\n");		
		xPrintString("# Target suspended or at breakpoint in debugger\n");
		xPrintString("# Wait for connection\n");
		xPrintString("# or type EXIT to quit simulation\n");
		xPrintString("\n");
		xPrintString("Command :");
		xPrintString(" ");
		xReleaseUI(1);
		while(!done){
			memset(localbuf,0,60);
			memset(service,0,20);
			if(xGetString(localbuf,1000)==TRUE){
				sscanf(localbuf,"%s",service); 		
		     	for (i=0; i < strlen(service); i++)
                    	service[i] = (char) toupper(service[i]);
				if(!strcmp(service,"EXIT")){
					done = 1;
					xReleaseUI(SPERROR);
					HostExitPM();
				}
				if(!strcmp(service,"QUIT")){ /*from SIMUI menu */
					done = 1;
					xReleaseUI(SPERROR);
					HostExitPM();
				}
				else{
					xPrintString("# Unknown command. Only EXIT is valid here\n");
				}
				xPrintString("\n");
				xReleaseUI(1);
			}
			if(HostReadTarget(1) == SPOK){
				xPrintString("\n");
				xPrintString("# Target up again, simulation continues\n");
				xReleaseUI(1);
				return 0;
			}
			else if(comerror == CE_TIMEOUT) continue;
			else if(comerror == CE_READERROR || comerror == CE_WRITEERROR)
				goto LBL_TARGET_DEAD_LOOP;
		}
	}		
	/* other problem that Target. We don't address that. */
	return -1;
}

#ifndef WINDOWS
int GrepSetup(char *InString)
{
	/* returns: -n = n too many, max 5. 0 = all deleted. +n = n added , -8 nothing done*/
	int i,j,k,g,len,added=0,toomany=0,dodelete=FALSE ,switched=0;
	char argument[5][30];
	char dummy[10];		/* buffer comes with the beginning GREP command */
	char comparenew[30];
	char compareold[30];
	char outbuffer[200];
	int oldexakt,newexakt,oldnot,newnot,newoffset,oldoffset,match=FALSE;	
	if(InString == NULL)return -8;
	for(i=0;i<5;i++)memset(argument[i],0,30);
	sscanf(InString,"%s%s%s%s%s%s",dummy,argument[0],argument[1],
						argument[2],argument[3],argument[4]);
	k = 0;
	while(argument[k][0] && k<5)k++;
	for(i=0;i<k;i++){
		while(!strcmp(argument[i],"*")&& k>i ){
			dodelete = TRUE;
			for(j=i;j<k-1;j++){
				strcpy(argument[j],argument[j+1]);
			}
			k--;
			if(!k)break;
		}
	}
	for(i=0;i<k;i++){	/* some funny guy parsing control characters ? */
		while(!strcmp(argument[i],"!")||!strcmp(argument[i],"=") && k>i){
			for(j=i;j<k-1;j++)
				strcpy(argument[j],argument[j+1]);
			k--;
			if(!k)break;
		}
	}
	if(dodelete){
		for(i=0;i<5;i++)
			memset(GREPSTRING[i],0,30);
			GREP = 0;
		if(!k)return 0;
	}
	if(!k) { /* no arguments */
		if(GREP)
			sprintf(outbuffer," Grep on %s %s %s %s %s\n",GREPSTRING[0],
				GREPSTRING[1],GREPSTRING[2],GREPSTRING[3],GREPSTRING[4]);
		else sprintf(outbuffer," Grep OFF (GREP *)\n");
		strcpy(InString,outbuffer);
		return -8;
	}
		
	for(i=0;i<k;i++){
		memset(comparenew,0,30);
		if(!(argument[i][0]=='='||argument[i][1]=='=')){ /* not case sensitive ? */
			len =  strlen(argument[i]);
			for (j=0; j <len; j++)
                    comparenew[j] = (char) toupper(argument[i][j]);
               newexakt = FALSE;
          }
          else {
               newexakt = TRUE;
               strcpy(comparenew,argument[i]);
          }
          if(argument[i][0]=='!'||argument[i][1]=='!')
               newnot = TRUE;
          else newnot = FALSE;
          newoffset = newnot + newexakt;
          if(newoffset){
               len = strlen(argument[i]);
               for(j=0; j < len; j++)
               	comparenew[j]=comparenew[j+newoffset];
          }
		if(GREP){
			/* we need to check if it is already existing */ 
               for(g=0;g<GREP;g++){
               	memset(compareold,0,30);
               	if(GREPSTRING[g][0]=='='||GREPSTRING[g][1]=='=')
               		oldexakt = TRUE;
               	else oldexakt = FALSE;
               	if(GREPSTRING[g][0]=='!'||GREPSTRING[g][1]=='!')
               		oldnot = TRUE;
               	else oldnot = FALSE;
               	oldoffset = oldnot+oldexakt;
               	strcpy(compareold,GREPSTRING[g]);
               	if(oldoffset){
               		len = strlen(compareold);
               		for(j=0; j < len; j++)
               				compareold[j]=compareold[j+oldoffset];
               	}			
               	if(!strcmp(compareold,comparenew)){
               		/* GREPSTRING is already converted toupper if not exakt specified */
               		if(oldnot != newnot){
               			memset(GREPSTRING[g],0,30);
               			/* something prev. discarded should be logged or vice versa */
               			if(newoffset){
               				for(j=0; j < newoffset; j++)
               					GREPSTRING[g][j]=argument[i][j];
               				strcat(GREPSTRING[g],comparenew);
               			}
               			else strcpy(GREPSTRING[g],comparenew);
               			switched++;
               		}
               		match = TRUE;
               		break;
               	}
               }
		}/* GREP */               		
          if(!match){
          	if(GREP<5){
          		memset(GREPSTRING[GREP],0,30);
          		if(newoffset){
               		for(j=0; j < newoffset; j++)
               			GREPSTRING[GREP][j]=argument[i][j];
               		strcat(GREPSTRING[GREP],comparenew);
               	}
               	else strcpy(GREPSTRING[GREP],comparenew);		
               	GREP ++;
               	added ++;
               }
               else toomany ++;
          }
          else match = FALSE;
     }/* for-loop for n arguments */
     /* prepare an output information string . caller must have allocated 300 bytes.*/
     sprintf(outbuffer," %s %d added, %d switched, %d too many(ignored)\n",
     	(dodelete)?"old removed,":"",added,switched,toomany);
     strcpy(InString,outbuffer);
     return GREP;
}         	
               	
int GrepFilter(char *InString)
{
	/* retruns TRUE if this string should be logged, else FALSE */
      int i,j,len,offset,exact,exclude,searchResult;
      char gbuf[30];
      char uppercase[300];
      char unchanged[300];
      if(!InString)return FALSE;
      if(!GREP)return TRUE;
      memset(uppercase,0,300);
      memset(unchanged,0,300);
      memset(gbuf,0,30);
      strcpy(uppercase,InString);
      strcpy(unchanged,InString);
      len = strlen(InString);
      for(i=0;i<len;i++)
      	uppercase[i]= (char) toupper(unchanged[i]);
      for(i=0;i<GREP;i++){
      	if(GREPSTRING[i][0]=='='||GREPSTRING[i][1]=='=')
      		exact = TRUE;
      	else exact = FALSE;
      	if(GREPSTRING[i][0]=='!'||GREPSTRING[i][1]=='!')
    			exclude = TRUE;
    		else exclude = FALSE;
    		offset = exact + exclude;
    		if(offset){
    			len = strlen(GREPSTRING[i]);
    			for(j=0;j<len;j++)
    				gbuf[j]=GREPSTRING[i][j+offset];
    		}
    		else strcpy(gbuf,GREPSTRING[i]);
    		if(exact)
    			searchResult=((char*)strstr(unchanged,gbuf) != NULL);
    		else
    			searchResult=((char*)strstr(uppercase,gbuf) != NULL);
    		if(exclude){
    			if(!searchResult) return TRUE;
    		}
    		else{
    			if(searchResult) return TRUE;
    		}
    	}
    	return FALSE;
}
    				
      	         
               
								
void messNrtoStr(int messnumber)
{
switch(messnumber){
	case SET_POST				:ns("SET_POST");break;               
	case SET_EXTERN     		:ns("SET_EXTERN");break;            
	case SET_SDT        		:ns("SET_SDT");break;        
	case SET_EDITOR     		:ns("SET_EDITOR");break;         
	case SET_ORGANIZER       	:ns("SET_ORGANIZER");break;        
	case SET_SDLE            	:ns("SET_SDLE");break;    
	case SET_MSCE            	:ns("SET_MSCE");break;    
	case SET_INFOSERVER      	:ns("SET_INFOSERVER");break;    
	case SET_TREEVIEWER      	:ns("SET_TREEVIEWER");break;    
	case SET_SIMULATOR_UI    	:ns("SET_SIMULATOR_UI");break;    
	case SET_VALIDATOR       	:ns("SET_VALIDATOR");break;    
	case SET_SIMULATOR       	:ns("SET_SIMULATOR");break;   
	case SET_SDLENV          	:ns("SET_SDLENV");break;    
	case SET_LINK            	:ns("SET_LINK");break;
	case SESTART                 	:ns("SESTART");break;
	case SESTARTREPLY       		:ns("SESTARTREPLY");break;
	case SESTOP                  	:ns("SESTOP");break;
	case SESTOPREPLY             	:ns("SESTOPREPLY");break;
	case SEGETTOOLTYPE           	:ns("SEGETTOOLTYPE");break;
	case SEGETTOOLTYPEREPLY      	:ns("SEGETTOOLTYPEREPLY");break;
	case SEGETTOOLPID            	:ns("SEGETTOOLPID");break;
	case SEGETTOOLPIDREPLY       	:ns("SEGETTOOLPIDREPLY");break;
	case SEADDTOOL               	:ns("SEADDTOOL");break;
	case SEADDTOOLREPLY          	:ns("SEADDTOOLREPLY");break;
	case SEADDTOOLSUBSCRIPTION   	:ns("SEADDTOOLSUBSCRIPTION");break;
	case SEADDTOOLSUBSCRIPTIONREPLY :ns("SEADDTOOLSUBSCRIPTIONREPLY");break;	 
	case SESTARTTRACE            	:ns("SESTARTTRACE");break;
	case SESTARTTRACEREPLY       	:ns("SESTARTTRACEREPLY");break;
	case SESTOPTRACE             	:ns("SESTOPTRACE");break;
	case SESTOPTRACEREPLY        	:ns("SESTOPTRACEREPLY");break;
	case SESHOWREF               	:ns("SESHOWREF");break;
	case SESHOWREFREPLY          	:ns("SESHOWREFREPLY");break;
	case SELISTSYSTEMFILES       	:ns("SELISTSYSTEMFILES");break;
	case SELISTSYSTEMFILESREPLY  	:ns("SELISTSYSTEMFILESREPLY");break;
	case SEOPENSYSTEM            	:ns("SEOPENSYSTEM");break;
	case SEOPENSYSTEMREPLY       	:ns("SEOPENSYSTEMREPLY");break;
	case SESAVEALL               	:ns("SESAVEALL");break;
	case SESAVEALLREPLY          	:ns("SESAVEALLREPLY");break;
	case SEOBTAINGRREF           	:ns("SEOBTAINGRREF");break;
	case SEOBTAINGRREFREPLY      	:ns("SEOBTAINGRREFREPLY");break;
	case SELOAD                  	:ns("SELOAD");break;
	case SELOADREPLY             	:ns("SELOADREPLY");break;
	case SEUNLOAD                	:ns("SEUNLOAD");break;
	case SEUNLOADREPLY           	:ns("SEUNLOADREPLY");break;
	case SESHOW                  	:ns("SESHOW");break;
	case SESHOWREPLY             	:ns("SESHOWREPLY");break;
	case SESAVE                  	:ns("SESAVE");break;
	case SESAVEREPLY             	:ns("SESAVEREPLY");break;
	case SESDLECREATEDIAGRAM      :ns("SESDLECREATEDIAGRAM");break;
	case SESDLECREATEDIAGRAMREPLY :ns("SESDLECREATEDIAGRAMREPLY");break;
	case SEMSCECREATEDIAGRAM      :ns("SEMSCECREATEDIAGRAM");break;
	case SEMSCECREATEDIAGRAMREPLY :ns("SEMSCECREATEDIAGRAMREPLY");break;
	case SESHOWOBJECT            	:ns("SESHOWOBJECT");break;
	case SESHOWOBJECTREPLY       	:ns("SESHOWOBJECTREPLY");break;
	case SESELECTOBJECT          	:ns("SESELECTOBJECT");break;
	case SESELECTOBJECTREPLY     	:ns("SESELECTOBJECTREPLY");break;
	case SEINSERTOBJECT          	:ns("SEINSERTOBJECT");break;
	case SEINSERTOBJECTREPLY     	:ns("SEINSERTOBJECTREPLY");break;
	case SESDLEINSERTOBJECT       :ns("SESDLEINSERTOBJECT");break;
	case SESDLEINSERTOBJECTREPLY  :ns("SESDLEINSERTOBJECTREPLY");break;
	case SEREMOVEOBJECT          	:ns("SEREMOVEOBJECT");break;
	case SEREMOVEOBJECTREPLY     	:ns("SEREMOVEOBJECTREPLY");break;
	case SEMENUADD               	:ns("SEMENUADD");break;
	case SEMENUADDREPLY          	:ns("SEMENUADDREPLY");break;
	case SEMENUDELETE            	:ns("SEMENUDELETE");break;
	case SEMENUDELETEREPLY       	:ns("SEMENUDELETEREPLY");break;
	case SEMENUCLEAR             	:ns("SEMENUCLEAR");break;
	case SEMENUCLEARREPLY        	:ns("SEMENUCLEARREPLY");break;
	case SEMENUADDITEM           	:ns("SEMENUADDITEM");break;
	case SEMENUADDITEMREPLY      	:ns("SEMENUADDITEMREPLY");break;
	case SEDISPLAYKEY            	:ns("SEDISPLAYKEY");break;
	case SEDISPLAYKEYREPLY       	:ns("SEDISPLAYKEYREPLY");break;
	case SELISTKEY               	:ns("SELISTKEY");break;
	case SELISTKEYREPLY          	:ns("SELISTKEYREPLY");break;
	case SECREATEATTRIBUTE       	:ns("SECREATEATTRIBUTE");break;
	case SECREATEATTRIBUTEREPLY  	:ns("SECREATEATTRIBUTEREPLY");break;
	case SEREADATTRIBUTE         	:ns("SEREADATTRIBUTE");break;
	case SEREADATTRIBUTEREPLY    	:ns("SEREADATTRIBUTEREPLY");break;
	case SEUPDATEATTRIBUTE       	:ns("SEUPDATEATTRIBUTE");break;
	case SEUPDATEATTRIBUTEREPLY  	:ns("SEUPDATEATTRIBUTEREPLY");break;
	case SEDELETEATTRIBUTE       	:ns("SEDELETEATTRIBUTE");break;
	case SEDELETEATTRIBUTEREPLY  	:ns("SEDELETEATTRIBUTEREPLY");break;
	case SELOADDEFINITIONMAP    	:ns("SELOADDEFINITIONMAP");break;
	case SELOADDEFINITIONMAPREPLY :ns("SELOADDEFINITIONMAPREPLY");break;
	case SESIMUICOMMAND          	:ns("SESIMUICOMMAND");break;
	case SESIMUICOMMANDREPLY     	:ns("SESIMUICOMMANDREPLY");break;
	case SESDLSIGNAL             	:ns("SESDLSIGNAL");break;
	case SESIMUINOTIFY           	:ns("SESIMUISTRING");break;
	case SESIMUINOTIFYREPLY      	:ns("SESIMUISTRINGREPLY");break;
	case SESIMUICHANGENOTIFY     	:ns("SESIMUICHANGENOTIFY");break;
	case SEVALCOM                	:ns("SEVALCOM");break;
	case SEVALCOMREPLY           	:ns("SEVALCOMREPLY");break;
	case SESTARTNOTIFY           	:ns("SESTARTNOTIFY");break;
	case SEOPFAILED			:ns("SEOPFAILED");break;
	case SESTOPNOTIFY            	:ns("SESTOPNOTIFY");break;
	case SESTRUCTURENOTIFY       	:ns("SESTRUCTURENOTIFY");break;
	case SEUNLOADNOTIFY         	:ns("SEUNLOADNOTIFY");break;
	case SEDIRTYNOTIFY          	:ns("SEDIRTYNOTIFY");break;
	case SESAVENOTIFY           	:ns("SESAVENOTIFY");break;
	case SESDLENEWNOTIFY          :ns("SESDLENEWNOTIFY");break;
	case SEMSCENEWNOTIFY          :ns("SEMSCENEWNOTIFY");break;
/* SDT_VERSION 31 */
	case SESIMUICHANGE         	:ns("SESIMUICHANGE");break;
	case SESIMUICHANGEREPLY 	:ns("SESIMUICHANGEREPLY");break;
	case SESDLECIFCREATEDIAGRAM        :ns("SESDLECIFCREATEDIAGRAM");break;
	case SESDLECIFCREATEDIAGRAMREPLY   :ns("SESDLECIFCREATEDIAGRAMREPLY");break;
	case SESDLECIFCREATEPAGE           :ns("SESDLECIFCREATEPAGE");break;
	case SESDLECIFCREATEPAGEREPLY      :ns("SESDLECIFCREATEPAGEREPLY");break;
	case SESDLECIFINSERTOBJECT         :ns("SESDLECIFINSERTOBJECT");break;
	case SESDLECIFINSERTOBJECTREPLY    :ns("SESDLECIFINSERTOBJECTREPLY");break;
	case SEGRPR                        :ns("SEGRPR");break;
	case SEGRPRREPLY                   :ns("SEGRPRREPLY");break;
	default: ns("*unknown*");break;
	}
}
#endif /* !JUSTPARSER */ 
#endif /* !TARGET */

#ifdef JUSTPARSER
main(){
	LoadConfigFile();
	fclose(LOGFIL);
}
#endif

#endif /*!WINDOWS*/
