/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:46 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#include <sys/types.h>
#include "post.h"
#include "sdt.h"

#define SDL_LOSE  "Lose"
#define SDL_WIN   "Win"
#define SDL_SCORE "Score"

#define NULL 0

#ifndef XNOPROTO
void Init (char * argv0)
#else
void Init (argv0)
char *argv0;
#endif
{
  int self;

  self = SPInit(SET_SDLENV, argv0);
  if (self == SPERROR)
  {
    printf("%s%s\n", "Error in SPInit: ", SPErrorString(sperrno));
    exit(1);
  }

  Init_UI(spPortNO);
}


#ifndef XNOPROTO
void Send_To_PM (char * sdl_signal_name)
#else
void Send_To_PM (sdl_signal_name)
  char * sdl_signal_name;
#endif 
{
  char buf[100];

  sprintf(buf, "%s %s %s %s %s", sdl_signal_name, "0", "0", "0", "0" );

  if (SPBroadcast(SESDLSIGNAL, buf, strlen(buf)) == SPERROR) 
    printf("%s%s\n", "Error when sending SESDLSIGNAL: ", SPErrorString(sperrno));

}


#ifndef XNOPROTO
Receive(void)
#else
Receive ()
#endif
{
  char       signal_name[80];
  char       signal_param[80];
  int        pid;
  int        message;
  char *     data;
  int        len;

  if (SPRead(SPWAITFOREVER, &pid, &message, (void*)&data, &len) == SPOK)
  {
    switch (message)
    {
      case SESDLSIGNAL:
        sscanf(data, "%s", signal_name);
        if (strcmp(signal_name, SDL_SCORE) == 0 )
        {
          sscanf(data, "%s%*s%*s%*s%*s%s", signal_name, signal_param);
          Send_To_UI(signal_name, signal_param);
	  return(1);
        }
        else if (strcmp(signal_name, SDL_LOSE) == 0 )
        {
          Send_To_UI(signal_name, NULL);
	  return(1);
        }
        else if (strcmp(signal_name, SDL_WIN) == 0 )
        {
          Send_To_UI(signal_name, NULL);
	  return(1);
        }
        break;
      case SESTOP:
        Exit_UI();
        break;
      case SEOPFAILED:
        /* Call SPDecodeErrorMessage and display information */
      default:;
    }
  }
  if (data)
    free (data);
  
  return(0);
}


#ifndef XNOPROTO
void Exit_PM (void)
#else
void Exit_PM ()
#endif
{
  if (SPBroadcast(SESTOPNOTIFY, NULL, 0) == SPERROR)
  {
    printf("%s%s\n", "Error when sending STOPNOTIFY: ", SPErrorString(sperrno));
    exit(1);
  }
  else
  {
    if (SPExit() == SPERROR)
      printf("%s%s\n", "Error in SPExit: ", SPErrorString(sperrno));
  }
}
