/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/*************************************************************/
/* TAU RTOS integration for VxWorks */

#include <time.h>
#include <timers.h>
#include "semLib.h"
#include "taskLib.h"

#ifdef __cplusplus
  extern "C" {int sysClkRateGet(void);}
#endif

typedef struct {
  SEM_ID    SignalQueueMutex;
  SEM_ID    SignalQueueCond;
  int       ThreadId;
} xThreadVars;

#define DEFAULT_STACKSIZE      800              /* must be an even integer */
#define DEFAULT_PRIO           128
#define DEFAULT_USER1            0
#define DEFAULT_USER2            0

extern SEM_ID xFreeSignalMutex;
extern SEM_ID xFreeTimerMutex;
extern SEM_ID xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  extern SEM_ID xMemoryMutex;
#endif
extern SEM_ID xInitSem;
#if !defined(USER_CFG_USE_xInEnv) && !defined(XENV)
  extern SEM_ID xMainThreadSem;
#endif

extern void xThreadInit (void);
extern void xThreadInitOneThread (struct _xSystemData *);
extern void xThreadStartThread (struct _xSystemData *, unsigned int, unsigned int,
                                unsigned int, unsigned int);
#if defined(THREADED) || defined(CFG_USED_DYNAMIC_THREADS)
  extern void xThreadStopThread (struct _xSystemData *);
#endif
extern void xThreadGo (void);
extern void xThreadLock (SEM_ID *);
extern void xThreadUnlock (SEM_ID *);
extern void xThreadWaitUnlock (struct _xSystemData *);
extern void xThreadSignalUnlock (struct _xSystemData *);
extern SDL_Time xNow (void);
#define xInitSystime()

