/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: mk_sche.h
+------------------------------------------------------------------------------+
*/
/*-MHDR*/



#ifndef __MK_SCHE_H_
#define __MK_SCHE_H_

#ifdef XSYSID
  /*
  ** If partitioning is used, then redefine function names
  ** to make them unique in the whole system (over
  ** all partitions)
  */
  #define xmk_StartProcesses                  XMAKENAME(XSYSID,StartProcesses )
  #define xmk_ProcessSignal                   XMAKENAME(XSYSID,ProcessSignal )
  #define xmk_CreateProcess                   XMAKENAME(XSYSID,CreateProcess )
  #define xmk_Handle_XMK_CREATE_SIGNALID      XMAKENAME(XSYSID,Handle_XMK_CREATE_SIGNALID )
  #define xmk_CheckSignal                     XMAKENAME(XSYSID,CheckSignal )
  #define xmk_IsAnyProcessAlive               XMAKENAME(XSYSID,IsAnyProcessAlive )
  #define xmk_IfExist                         XMAKENAME(XSYSID,IfExist )
  #define xmk_InitPreemptionVars              XMAKENAME(XSYSID,InitPreemptionVars )
  #define xmk_DisablePreemption               XMAKENAME(XSYSID,DisablePreemption )
  #define xmk_EnablePreemption                XMAKENAME(XSYSID,EnablePreemption)
  #define xmk_FetchHighestPrioLevel           XMAKENAME(XSYSID,FetchHighestPrioLevel )
  #define xmk_CheckIfSchedule                 XMAKENAME(XSYSID,CheckIfSchedule)
  #define xmk_SwitchPrioLevel                 XMAKENAME(XSYSID,SwitchPrioLevel)
  #define xmk_KillProcess                     XMAKENAME(XSYSID,KillProcess )
  #define xmk_GetProcessState                 XMAKENAME(XSYSID,GetProcessState )
  #define xmk_SetProcessState                 XMAKENAME(XSYSID,SetProcessState )
  #define xmk_GetProcessInstanceData          XMAKENAME(XSYSID,GetProcessInstanceData )
  #define xmk_StopAllProcesses                XMAKENAME(XSYSID,StopAllProcesses )
#endif /* ... XSYSID */


extern unsigned char   xmk_InterruptsDisabled;

extern  void           xmk_StartProcesses ( void );

extern  void           xmk_ProcessSignal ( void );

extern  xmk_T_INSTANCE xmk_CreateProcess ( xmk_T_PROCESS );

#ifdef XMK_USE_PREEMPTIVE
extern  void            xmk_DisablePreemption ( void );

extern  void            xmk_EnablePreemption ( void );

extern  void            xmk_SwitchPrioLevel ( xmk_T_PRIOLEVEL );

extern  xmk_T_PRIOLEVEL xmk_FetchHighestPrioLevel ( void );

extern  void            xmk_InitPreemptionVars ( void );

extern  void            xmk_CheckIfSchedule ( void );
#endif

#ifndef XMK_USE_PREEMPTIVE
  extern  xSYMBOLNR xmk_SymbolNrVar ;     /* exported by Cmicro Kernel */
#endif

#ifdef  XMK_USE_SDL_SYSTEM_STOP
  extern xmk_T_BOOL         xmk_IsAnyProcessAlive ( void );
#endif

extern   xmk_T_BOOL         xmk_KillProcess (xPID);

extern   xmk_T_BOOL         xmk_IfExist ( xPID );

#if defined(XMK_SYSTEM_INFO) || \
    (defined(XMK_ADD_CQUERY_PROCESS) && defined(XMK_USE_DEBUGGING)) || \
    (defined( XMK_USED_SAVE) && defined (XMK_USE_INTERNAL_QUEUE_HANDLING))
  extern   xmk_T_STATE        xmk_GetProcessState ( xPID );
#endif
 
#if defined(XMK_SYSTEM_INFO) || (defined(XMK_ADD_CNEXTSTATE)  && defined(XMK_USE_DEBUGGING))
  extern   xmk_OPT_INT        xmk_SetProcessState ( xPID, xmk_T_STATE );
#endif

#if defined(XMK_SYSTEM_INFO)
  extern   void xmk_RAM_ptr   xmk_GetProcessInstanceData ( xPID );
#endif

#endif

