/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __bms_small_h
#define __bms_small_h

#ifndef CODER_REMOVE_SMALLBUF

#ifdef CODER_BMS_SMALLBUF

#define BufInitBuf(c, buftype)                        SmallBufInitBuf(&c)
#define BufCloseBuf(c)                                SmallBufCloseBuf(&c)

#define BufInitBufWithMemory(c, buftype, usermemory)  SmallBufInitBufWithMemory(&c, usermemory)
#define BufCloseBufToMemory(c, usermemory)            SmallBufCloseBufToMemory(&c, usermemory)

#define BufGetBufType(c)                              bms_SmallBuffer

#define BufGetDataLen(c)                              SmallBufGetLength(c, bms_DataLength)
#define BufGetDataBitLen(c)                           SmallBufGetLength(c, bms_DataBitLength)
#define BufGetReadDataLen(c)                          SmallBufGetLength(c, bms_ReadDataLength)
#define BufGetReadDataBitLen(c)                       SmallBufGetLength(c, bms_ReadDataBitLength)
#define BufGetValueLen(c)                             SmallBufGetLength(c, bms_ValueLength)
#define BufGetValueBitLen(c)                          SmallBufGetLength(c, bms_ValueBitLength)

#define BufGetMemory(c, rlen)                         SmallBufGetMemory(c, rlen)
#define BufAppendMemory(c, len)                       SmallBufAppendMemory(c, len)

#define BufGetDataCurr(c, rbitcurr)                   SmallBufGetDataCurr(c, rbitcurr)
#define BufSetDataCurr(c, len, bitcurr)               SmallBufSetDataCurr(c, len, bitcurr)
#define BufGetDataEnd(c, rbitend)                     SmallBufGetDataEnd(c, rbitend)
#define BufSetDataEnd(c, len, bitend)                 SmallBufSetDataEnd(c, len, bitend)

#ifndef CODER_BMS_TINY

#define BufCopyBuf(dst, srs)                          SmallBufCopyBuf(dst, srs)

#define BufInitWriteMode(c)                           SmallBufInitWriteMode(c)
#define BufCloseWriteMode(c)                          SmallBufCloseWriteMode(c)

#define BufInitReadMode(c)                            SmallBufInitReadMode(c)
#define BufCloseReadMode(c)                           SmallBufCloseReadMode(c)
#define BufCloseDeleteReadMode(c)                     SmallBufCloseDeleteReadMode(c)

#define BufGetByte(c)                                 SmallBufGetByte(c)
#define BufPeekByte(c)                                SmallBufPeekByte(c)
#define BufPutByte(c, byte)                           SmallBufPutByte(c, byte)

#define BufGetSeg(c, lenPtr)                          SmallBufGetSeg(c, lenPtr)
#define BufSkipSeg(c,lenPtr)                          SmallBufSkipSeg(c, lenPtr)
#define BufPeekSeg(c,lenPtr)                          SmallBufPeekSeg(c, lenPtr)
#define BufPutSeg(c, data, len)                       SmallBufPutSeg(c, data, len)

#define BufPutBit(c, bit)                             SmallBufPutBit(c, bit)
#define BufGetBit(c)                                  SmallBufGetBit(c)
#define BufPutBits(c, bits, num)                      SmallBufPutBits(c, bits, num)
#define BufGetBits(c, num)                            SmallBufGetBits(c, num)

#define BufAlign(c)                                   SmallBufAlign(c)

#endif /* CODER_BMS_TINY */

#endif /* CODER_BMS_SMALLBUF */

#ifndef CODER_SMALLBUF_SIZE
#define CODER_SMALLBUF_SIZE  0x1000
#endif

typedef struct
{
  unsigned char* MemStart;
  unsigned char* MemEnd;
  unsigned char* DataStart;
  unsigned char* DataEnd;
  unsigned char* DataCurr;
  unsigned char  BitStart;
  unsigned char  BitEnd;
  unsigned char  BitCurr;
  unsigned char  IsAssigned;
} tBMSSmallBuffer;

int SmallBufInitBuf(tCoder** Coder);
int SmallBufCloseBuf(tCoder** Coder);

int SmallBufInitBufWithMemory(tCoder** Coder, tBMSUserMemory* UserMemory);
int SmallBufCloseBufToMemory(tCoder** Coder, tBMSUserMemory* UserMemory);

tBMSLength SmallBufGetLength(tCoder* Coder, tBMSLengthType LengthType);

unsigned char* SmallBufGetMemory(tCoder* Coder, tBMSLength* rLength);
unsigned char* SmallBufAppendMemory(tCoder* Coder, tBMSLength AppendLen);

unsigned char* SmallBufGetDataCurr(tCoder* Coder, unsigned char* rBitCurr);
void           SmallBufSetDataCurr(tCoder* Coder, tBMSLength Length, unsigned char BitCurr);
unsigned char* SmallBufGetDataEnd (tCoder* Coder, unsigned char* rBitEnd);
void           SmallBufSetDataEnd (tCoder* Coder, tBMSLength Length, unsigned char BitEnd);

#ifndef CODER_BMS_TINY

int SmallBufCopyBuf(tCoder* Dst, tCoder* Src);

int SmallBufInitWriteMode(tCoder* Coder);
int SmallBufCloseWriteMode(tCoder* Coder);

int SmallBufInitReadMode(tCoder* Coder);
int SmallBufCloseReadMode(tCoder* Coder);
int SmallBufCloseDeleteReadMode(tCoder* Coder);

unsigned char SmallBufGetByte(tCoder* Coder);
unsigned char SmallBufPeekByte(tCoder* Coder);
void          SmallBufPutByte(tCoder* Coder, unsigned char byte);

unsigned char* SmallBufGetSeg(tCoder* Coder, tBMSLength lenPtr);
void           SmallBufSkipSeg(tCoder* Coder, tBMSLength lenPtr);
unsigned char* SmallBufPeekSeg(tCoder* Coder, tBMSLength lenPtr);
void           SmallBufPutSeg(tCoder* Coder, unsigned char* data, tBMSLength len);

unsigned char SmallBufGetBit(tCoder* Coder);
void          SmallBufPutBit(tCoder* Coder, unsigned char bit);
unsigned long SmallBufGetBits(tCoder* Coder, unsigned char num);
void          SmallBufPutBits(tCoder* Coder, unsigned long bits, unsigned char num);

void SmallBufAlign(tCoder* Coder);

#endif /* CODER_BMS_TINY */

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_BUFFER)

#define SMALLBUF_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorHandler(coder, errorcode args); \
      action; \
    }
#define SMALLBUF_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorHandler(coder, errorcode args); \
    action; \
  }
#else
#define SMALLBUF_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define SMALLBUF_ERROR_HANDLER(coder, action, errorcode, args)
#endif

#endif /* !CODER_REMOVE_SMALLBUF */

#endif /* __bms_small_h */
