/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.2.22515 at Mon Nov 21 06:47:45 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "er/ber/ber_content.h"

#ifndef CODER_REMOVE_BER

/*************************************************/

#ifndef CODER_NOUSE_BOOLEAN
static void BEREncodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_INTEGER
static void BEREncodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_BIT_STRING
static void BEREncodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_OCTET_STRING
static void BEREncodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_NULL
static void BEREncodeNULL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeNULL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
static void BEREncodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_REAL
static void BEREncodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_CHARACTER_STRING
static void BEREncodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#ifndef CODER_NOUSE_ENUMERATED
static void BEREncodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
#endif

/*************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static void BEREncodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

#if !defined(CODER_NOUSE_SEQUENCE) || (!defined(CODER_NOUSE_SET) && !defined(CODER_BER_CANONICAL_OFF))
static void BERDecodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val ER_OLIST(tVMSOpenTypeList* List));
#endif

#if !defined(CODER_NOUSE_SET) && defined(CODER_BER_CANONICAL_OFF)
static void BERDecodeUCSET(tCoder* Coder, tASN1TypeInfo* Type, void* Val ER_OLIST(tVMSOpenTypeList* List));
#endif

#ifndef CODER_NOUSE_SEQUENCE_OF
static void BEREncodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void BERDecodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val ER_OLIST(tVMSOpenTypeList* List));
#endif

#ifndef CODER_NOUSE_SET_OF
static void BEREncodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void BERDecodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val ER_OLIST(tVMSOpenTypeList* List));
#endif

/*************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) && !defined (CODER_NOUSE_SEQUENCE_OF)

#define BEREncodeSEQUENCE(Coder, Type, Val, TagKind) \
   if (Type->TypeClass == type_ASN1_SEQUENCE) \
      BEREncodeStruct(Coder, Type, Val); \
   else \
      BEREncodeSEQUENCE_OF(Coder, Type, Val); \
   if (TagKind == tk_Explicit) { BERPutByte(Coder, 0x30); }

#define BERDecodeSEQUENCE(Coder, Type, Val, TagKind, List) \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x30, Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  if (Type->TypeClass == type_ASN1_SEQUENCE) \
    { \
      VMSInitSEQUENCE(Coder, Val, Type); \
      BERDecodeStruct(Coder, Type, Val ER_OLIST(List)); \
    } \
  else \
    BERDecodeSEQUENCE_OF(Coder, Type, Val ER_OLIST(List));

#elif !defined(CODER_NOUSE_SEQUENCE)

#define BEREncodeSEQUENCE(Coder, Type, Val, TagKind) \
   BEREncodeStruct(Coder, Type, Val); \
   if (TagKind == tk_Explicit) { BERPutByte(Coder, 0x30); }

#define BERDecodeSEQUENCE(Coder, Type, Val, TagKind, List) \
  VMSInitSEQUENCE(Coder, Val, Type); \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x30, Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  BERDecodeStruct(Coder, Type, Val ER_OLIST(List)); \

#elif !defined(CODER_NOUSE_SEQUENCE_OF)

#define BEREncodeSEQUENCE(Coder, Type, Val, TagKind) \
   BEREncodeSEQUENCE_OF(Coder, Type, Val); \
   if (TagKind == tk_Explicit) { BERPutByte(Coder, 0x30); }

#define BERDecodeSEQUENCE(Coder, Type, Val, TagKind, List) \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x30, Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  BERDecodeSEQUENCE_OF(Coder, Type, Val ER_OLIST(List));

#endif

/*************************************************/

#if !defined(CODER_NOUSE_SET) && !defined (CODER_NOUSE_SET_OF)

#define BEREncodeSET(Coder, Type, Val, TagKind) \
  if (Type->TypeClass == type_ASN1_SET) \
    BEREncodeStruct(Coder, Type, Val); \
  else \
    BEREncodeSET_OF(Coder, Type, Val); \
  if (TagKind == tk_Explicit) { BERPutByte(Coder, 0x31); }

#ifndef CODER_BER_CANONICAL_OFF

#define BERDecodeSET(Coder, Type, Val, TagKind, List) \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x31, \
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  if (Type->TypeClass == type_ASN1_SET) \
    { \
      VMSInitSET(Coder, Val, Type); \
      BERDecodeStruct(Coder, Type, Val ER_OLIST(List)); \
    } \
  else \
    BERDecodeSET_OF(Coder, Type, Val ER_OLIST(List));

#else

#define BERDecodeSET(Coder, Type, Val, TagKind, List) \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x31, \
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  if (Type->TypeClass == type_ASN1_SET) \
    { \
      VMSInitSET(Coder, Val, Type); \
      BERDecodeUCSET(Coder, Type, Val ER_OLIST(List)); \
    } \
  else \
    BERDecodeSET_OF(Coder, Type, Val ER_OLIST(List));

#endif

#elif !defined (CODER_NOUSE_SET)

#define BEREncodeSET(Coder, Type, Val, TagKind) \
  BEREncodeStruct(Coder, Type, Val); \
  if (TagKind == tk_Explicit) { BERPutByte(Coder, 0x31); }

#ifndef CODER_BER_CANONICAL_OFF

#define BERDecodeSET(Coder, Type, Val, TagKind, List) \
  VMSInitSET(Coder, Val, Type); \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x31, \
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  BERDecodeStruct(Coder, Type, Val ER_OLIST(List));

#else

#define BERDecodeSET(Coder, Type, Val, TagKind, List) \
  VMSInitSET(Coder, Val, Type); \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x31, \
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  BERDecodeUCSET(Coder, Type, Val ER_OLIST(List)); \

#endif

#elif !defined (CODER_NOUSE_SET_OF)

#define BEREncodeSET(Coder, Type, Val, TagKind) \
  BEREncodeSET_OF(Coder, Type, Val); \
  if (TagKind == tk_Explicit) { BERPutByte(Coder, 0x31); }

#define BERDecodeSET(Coder, Type, Val, TagKind, List) \
  if (TagKind == tk_Explicit) \
    { \
      if (Coder->ER.DataEnd == Coder->ER.DataCurr) BERAppendData(Coder, 1); \
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x31, \
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS); \
      Coder->ER.DataCurr++; \
    } \
  BERDecodeSET_OF(Coder, Type, Val ER_OLIST(List));

#endif

/*************************************************/

#ifndef CODER_NOUSE_CHOICE
static void BEREncodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind
                            ER_OLIST(tVMSOpenTypeList* List));

static void BERGetCHOICEAlternative(tCoder* Coder, tASN1Choice* Type, tBERTag* Tag, tASN1Alternative** AltInfo);
#endif

/*************************************************/

static void BEREncodeDEFINED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeDEFINED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind
                             ER_OLIST(tVMSOpenTypeList* List));

/*************************************************/

static void BEREncodeTAGGED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeTAGGED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind
                            ER_OLIST(tVMSOpenTypeList* List));

/*************************************************/

#ifndef CODER_NOUSE_OPEN
#define BEREncodeOPEN_ID(Coder, Type, Val, TagKind) BEREncVal(Coder, ((tASN1OpenId*)Type)->BaseType, Val, TagKind)
static void BERDecodeOPEN_ID(tCoder* Coder, tASN1TypeInfo* Type, void* vOpenId, tASN1TagKind TagKind, tVMSOpenTypeList* List);
static void BEREncodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind);
static void BERDecodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind, tVMSOpenTypeList* List);

static void BERDecodeSkipedValues(tCoder* Coder, tVMSOpenTypeList* List);
static unsigned char BERIsOPENTypeObject(tCoder* Coder, tASN1Open* Type, tBERTag* Tag);
#endif

/*************************************************/
/*************************************************/
/*************************************************/

#if !defined(CODER_NOUSE_CHARACTER_STRING) || !defined(CODER_NOUSE_BIT_STRING) || !defined(CODER_NOUSE_OCTET_STRING)
#if defined(CODER_BER_CONSTRUCTED)
static void BEREncodeConsSTRING(tCoder* Coder, tASN1TypeInfo* Type, tBERStringInfo* Info, tVMSString* String);
#endif
static void BERDecodeConsSTRING(tCoder* Coder, tASN1TypeInfo* Type, tBERStringInfo* Info, tVMSString* vString);
#endif

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_OPEN)
static void BERSkipValue(tCoder* Coder);
#endif

/*************************************************/
/******************* MAIN ************************/
/*************************************************/

/**************************************************
 * NAME: BEREncVal
 *       
 *
 */
void
BEREncVal(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tASN1TypeInfo* tmpType = Coder->VMS.Type;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncVal\n");
#endif

  Coder->VMS.Type = Type;
  switch (Type->TypeClass & 0x1F)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      BEREncodeBOOLEAN(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      BEREncodeINTEGER(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      BEREncodeBIT_STRING(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      BEREncodeOCTET_STRING(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      BEREncodeNULL(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      BEREncodeOBJECT_IDENTIFIER(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      BEREncodeREAL(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
    case type_ASN1_PrintableString:
    case type_ASN1_IA5String:
    case type_ASN1_VisibleString:
    case type_ASN1_UTCTime:
    case type_ASN1_GeneralizedTime:
      BEREncodeCHARACTER_STRING(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      BEREncodeENUMERATED(Coder, Type, Val, TagKind);
      break;
#endif

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SEQUENCE_OF)
    case type_ASN1_SEQUENCE:
      BEREncodeSEQUENCE(Coder, Type, Val, TagKind);
      break;
#endif

#if !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_SET_OF)
    case type_ASN1_SET:
      BEREncodeSET(Coder, Type, Val, TagKind);
      break;
#endif

    default:
      switch (Type->TypeClass)
        {
#ifndef CODER_NOUSE_CHOICE
        case type_ASN1_CHOICE:
          BEREncodeCHOICE(Coder, Type, Val, TagKind);
          break;
#endif

        case type_ASN1_DEFINED:
          BEREncodeDEFINED(Coder, Type, Val, TagKind);
          break;
        case type_ASN1_TAGGED:
          BEREncodeTAGGED(Coder, Type, Val, TagKind);
          break;

#ifndef CODER_NOUSE_OPEN
        case type_ASN1_OPEN_ID:
          BEREncodeOPEN_ID(Coder, Type, Val, TagKind);
          break;
        case type_ASN1_OPEN:
          BEREncodeOPEN(Coder, Type, Val, TagKind);
          break;
#endif
        default:
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_UnsupportedType, NO_ARGS);
        }
    }
  Coder->VMS.Type = tmpType;
}

/**************************************************
 * NAME: BERDecVal
 *       
 *
 */
void
BERDecVal(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1TypeInfo* tmpType = Coder->VMS.Type;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecVal\n");
#endif

  Coder->VMS.Type = Type;
  switch(Type->TypeClass & 0x1F)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      BERDecodeBOOLEAN(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      BERDecodeINTEGER(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      BERDecodeBIT_STRING(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      BERDecodeOCTET_STRING(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      BERDecodeNULL(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      BERDecodeOBJECT_IDENTIFIER(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      BERDecodeREAL(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
    case type_ASN1_PrintableString:
    case type_ASN1_IA5String:
    case type_ASN1_VisibleString:
    case type_ASN1_UTCTime:
    case type_ASN1_GeneralizedTime:
      BERDecodeCHARACTER_STRING(Coder, Type, Val, TagKind);
      break;
#endif

#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      BERDecodeENUMERATED(Coder, Type, Val, TagKind);
      break;
#endif

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SEQUENCE_OF)
    case type_ASN1_SEQUENCE:
      BERDecodeSEQUENCE(Coder, Type, Val, TagKind, List);
      break;
#endif

#if !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_SET_OF)
    case type_ASN1_SET:
      BERDecodeSET(Coder, Type, Val, TagKind, List);
      break;
#endif
    default:
      switch (Type->TypeClass)
        {
#ifndef CODER_NOUSE_CHOICE
        case type_ASN1_CHOICE:
          BERDecodeCHOICE(Coder, Type, Val, TagKind ER_OLIST(List));
          break;
#endif

        case type_ASN1_DEFINED:
          BERDecodeDEFINED(Coder, Type, Val, TagKind ER_OLIST(List));
          break;
        case type_ASN1_TAGGED:
          BERDecodeTAGGED(Coder, Type, Val, TagKind ER_OLIST(List));
          break;

#ifndef CODER_NOUSE_OPEN
        case type_ASN1_OPEN_ID:
          BERDecodeOPEN_ID(Coder, Type, Val, TagKind, List);
          break;
        case type_ASN1_OPEN:
          BERDecodeOPEN(Coder, Type, Val, TagKind, List);
          break;
#endif

        default:
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_UnsupportedType, NO_ARGS);
        }
    }
  Coder->VMS.Type = tmpType;
}

#ifndef CODER_NOUSE_BOOLEAN
/*************************************************/
/******************* BOOLEAN *********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeBOOLEAN
 *       
 *
 */

static void
BEREncodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSBoolean vBool;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeBOOLEAN\n");
#endif

  VMSGetBOOLEAN(Coder, Val, Type, vBool);
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < 2)
        BERAppendMemory(Coder, 2 - (Coder->ER.DataCurr - Coder->ER.DataEnd));
      *(Coder->ER.DataCurr) = (unsigned char)(vBool > 0 ? CODER_BER_BOOLEAN_VALUE : 0);
      *(Coder->ER.DataCurr - 1) = 0x01;
      *(Coder->ER.DataCurr - 2) = 0x01;
      Coder->ER.DataCurr -= 3;
    }
  else
    {
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < 1)
        BERAppendMemory(Coder, 1 - (Coder->ER.DataCurr - Coder->ER.DataEnd));
      *(Coder->ER.DataCurr) = (unsigned char)(vBool > 0 ? CODER_BER_BOOLEAN_VALUE : 0);
      *(Coder->ER.DataCurr - 1) = 0x01;
      Coder->ER.DataCurr -= 2;
    }
}

/**************************************************
 * NAME: BERDecodeBOOLEAN
 *       
 *
 */

static void
BERDecodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeBOOLEAN\n");
#endif

  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 3)
        BERAppendData(Coder, 3 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x01,
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      DECODING_ERROR_HANDLER_EXP(*(Coder->ER.DataCurr + 1) != 1,
                                 Coder, ec_DEC_WrongLength, NO_ARGS);
      VMSSetBOOLEAN(Coder, Val, Type, (tVMSBoolean)*(Coder->ER.DataCurr + 2));
      Coder->ER.DataCurr += 3;
    }
  else
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
        BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 1,
                                 Coder, ec_DEC_WrongLength, NO_ARGS);
      VMSSetBOOLEAN(Coder, Val, Type, (tVMSBoolean)*(Coder->ER.DataCurr + 1));
      Coder->ER.DataCurr += 2;
    }
}
#endif /* CODER_NOUSE_BOOLEAN */

#ifndef CODER_NOUSE_INTEGER
/*************************************************/
/******************* INTEGER *********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeINTEGER
 *       
 *
 */
static void
BEREncodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSILen Len;
  tVMSULong vUInt, vOInt;
  tVMSULong FreeMem = (Coder->ER.DataCurr - Coder->ER.DataEnd) - 1;
#ifndef CODER_NOUSE_BIG_INTEGER
  tVMSUInteger vInt;
#endif

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeINTEGER\n");
#endif

#ifndef CODER_NOUSE_BIG_INTEGER
  {
    VMSGetINTEGER(Coder, Val, Type, vInt);
    CUCFCheckINTEGER(Coder, Type, &vInt);
    if (vInt.Sign)
      {
        vUInt = vInt.Number - 1;
        vOInt = (0xFFFFFFFF - vInt.Number) + 1;
      }
    else
      vUInt = vOInt = vInt.Number;
  }
#else
  {
    VMSGetINTEGER(Coder, Val, Type, vUInt);
    CUCFCheckINTEGER(Coder, Type, (tVMSInteger*)&vUInt);

    if ((tVMSInteger)vUInt < 0)
      {
        vOInt = vUInt;
        vUInt = (unsigned int)(-(tVMSInteger)(vUInt + 1));
      }    
    else
      vOInt = vUInt;
  }
#endif

  Len = 1;
  if ((vUInt & 0xFFFFFF80) != 0)
    {
      Len = 2;
      if ((vUInt & 0xFFFF8000) != 0)
        {
          Len = 3;
          if ((vUInt & 0xFF800000) != 0)
            {
              Len = 4;
#ifndef CODER_NOUSE_BIG_INTEGER
              if ((vUInt & 0x80000000) != 0)
                {
                  Len = 5;
                  if (FreeMem < Len)
                    BERAppendMemory(Coder, Len - FreeMem);
                  *(Coder->ER.DataCurr - 4) = vInt.Sign ? 0xFF : 0x00;
                }
              else
#endif
              if (FreeMem < Len)
                BERAppendMemory(Coder, Len - FreeMem);

              *(Coder->ER.DataCurr - 3) = (unsigned char)(vOInt >> 24);
            }
          else
          if (FreeMem < Len)
            BERAppendMemory(Coder, Len - FreeMem);

          *(Coder->ER.DataCurr - 2) = (unsigned char)(vOInt >> 16);
        }
      else
      if (FreeMem < Len)
        BERAppendMemory(Coder, Len - FreeMem);

      *(Coder->ER.DataCurr - 1) = (unsigned char)(vOInt >> 8);
    }
  else
  if (FreeMem < Len)
    BERAppendMemory(Coder, Len - FreeMem);

  *(Coder->ER.DataCurr) = (unsigned char)vOInt;
  
  *(Coder->ER.DataCurr - Len) = Len;
  Coder->ER.DataCurr -= Len + 1;
  if (TagKind == tk_Explicit)
    { BERPutByte(Coder, 0x02); }
}

/**************************************************
 * NAME: BERDecodeINTEGER
 *       
 *
 */
static void
BERDecodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSILen Len, i;
  tVMSUInteger vUInt;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeINTEGERn");
#endif

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
        BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x02,
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      Len = *(Coder->ER.DataCurr + 1);
      Coder->ER.DataCurr += 2;
    }
  else
    {
      if (Coder->ER.DataEnd == Coder->ER.DataCurr)
        BERAppendData(Coder, 1);
      Len = *(Coder->ER.DataCurr);
      Coder->ER.DataCurr++;
    }

#ifndef CODER_NOUSE_BIG_INTEGER
  DECODING_ERROR_HANDLER_EXP((Len == 0) || (Len > sizeof(unsigned int) + 1), Coder, ec_DEC_WrongLength, NO_ARGS);
#else
  DECODING_ERROR_HANDLER_EXP((Len == 0) || (Len > sizeof(int)), Coder, ec_DEC_WrongLength, NO_ARGS);
#endif

  if (Coder->ER.DataEnd - Coder->ER.DataCurr < Len)
    BERAppendData(Coder, Len - (Coder->ER.DataEnd - Coder->ER.DataCurr));

  /* Content */
  if (*(Coder->ER.DataCurr) & 0x80) 
    {
#ifndef CODER_NOUSE_BIG_INTEGER
      vUInt.Sign = 1;
#endif
      vUInt.Number = 0xFFFFFF00 | *(Coder->ER.DataCurr);
    }
  else 
    {
#ifndef CODER_NOUSE_BIG_INTEGER
      vUInt.Sign = 0;
#endif
      vUInt.Number = *(Coder->ER.DataCurr);
    }

  for (i = 1; i < Len; i++)
    {
      vUInt.Number <<= 8;
      vUInt.Number |= *(Coder->ER.DataCurr + i);
    }
  Coder->ER.DataCurr += Len;

#ifndef CODER_NOUSE_BIG_INTEGER
  if (vUInt.Sign) vUInt.Number = (unsigned int)(-(int)(vUInt.Number));
  VMSSetINTEGER(Coder, Val, Type, vUInt);
  CUCFCheckINTEGER(Coder, Type, &vUInt);
#else
  VMSSetINTEGER(Coder, Val, Type, ((int)(vUInt.Number)));
  CUCFCheckINTEGER(Coder, Type, (tVMSInteger*)(&(vUInt.Number)));
#endif
}
#endif /* CODER_NOUSE_INTEGER */

#if !defined(CODER_NOUSE_CHARACTER_STRING) || !defined(CODER_NOUSE_BIT_STRING) || !defined(CODER_NOUSE_OCTET_STRING)
/**************************************************/
/************ SHARED STRINGs FUNCTIONS ************/
/**************************************************/

#ifdef CODER_BER_CONSTRUCTED
/**************************************************
 * NAME: BEREncodeConsSTRING
 *       
 *
 */

static void
BEREncodeConsSTRING(tCoder* Coder, tASN1TypeInfo* Type, tBERStringInfo* Info, tVMSString* vString)
{
  tVMSULong BlkLength       = CODER_BER_CONSTRUCTED_LENGTH;
  tVMSULong TmpLength       = vString->Length % BlkLength;
  tVMSString_Value CurrSymb = vString->Value + (vString->Length - TmpLength);
  tVMSULong i;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeConsSTRING\n");
#endif
  
  if (TmpLength > 0)
    {
      /* Content & Length */
      Info->EncPrim(Coder, TmpLength, CurrSymb);

      /* Identifier octet */
      BERPutByte(Coder, Info->TypeClass);
    }
  for (i = 0, TmpLength = vString->Length / BlkLength; i < TmpLength; i++)
    {
      CurrSymb -= BlkLength;

      /* Content & Length */
      Info->EncPrim(Coder, BlkLength, CurrSymb);

      /* Identifier octet */
      BERPutByte(Coder, Info->TypeClass);
    }
}
#endif /* CODER_BER_CONSTRUCTED */

/**************************************************
 * NAME: BERDecodeConsSTRING
 *       
 *
 */

static void
BERDecodeConsSTRING(tCoder* Coder, tASN1TypeInfo* Type, tBERStringInfo* Info, tVMSString* vString)
{
  tVMSULong Length;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeConsSTRING\n");
#endif

  if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
    {
      vString->Length = 0;
      while(!BERIsEOC(Coder))
        {
          DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != Info->TypeClass, Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
          Coder->ER.DataCurr++;

          if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
            DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);

          if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)Length)
            BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

          if (Length > 0)
            Info->DecPrim(Coder, Length, vString);
          else
            DECODING_ERROR_HANDLER_EXP(Info->TypeClass == 0x03, Coder, ec_DEC_WrongLength, NO_ARGS);
        }
      BERDecodeEOC(Coder);
    }
  else
    {
      tVMSULong CurrLen = Length;

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)CurrLen)
        BERAppendData(Coder, CurrLen - (Coder->ER.DataEnd - Coder->ER.DataCurr));

      while (CurrLen > 0)
        {
          unsigned char Bytes;

          DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != Info->TypeClass, Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
          Coder->ER.DataCurr++;
          Bytes = BERDecodeDefiniteLength(Coder, &Length);
          CurrLen -= Bytes + 1;
          if (((Bytes == 1) && (Length == 0x80)) || (Length > CurrLen))
            DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);
          
          if (Length > 0)
            {
              Info->DecPrim(Coder, Length, vString);
              CurrLen -= Length;
            }
          else
            DECODING_ERROR_HANDLER_EXP(Info->TypeClass == 0x03, Coder, ec_DEC_WrongLength, NO_ARGS);
        }
    }
}

#endif /* !(CODER_NOUSE_CHARACTER_STRING) || !(CODER_NOUSE_BIT_STRING) || !(CODER_NOUSE_OCTET_STRING) */

#ifndef CODER_NOUSE_BIT_STRING
/*************************************************/
/***************** BIT STRING ********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodePrimBIT_STRING
 *       
 *
 */

static void
BEREncodePrimBIT_STRING(tCoder* Coder, tVMSULong Length, tVMSString_Value vBitString)
{
  tVMSULong CurrLength     = Length >> 3;                                 /* Current length in bytes */
  unsigned char UnusedBits = (unsigned char)((8 - (Length & 0x7)) & 0x7); /* Number of unused bits */  
  tVMSULong EncLength      = CurrLength + 1 + (UnusedBits > 0 ? 1 : 0);
  unsigned char *CurrByte, *CurrStrPtr = vBitString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodePrimBIT_STRING\n");
#endif

  if (Coder->ER.DataCurr - Coder->ER.DataEnd < (long)EncLength)
    BERAppendMemory(Coder, EncLength - (Coder->ER.DataCurr - Coder->ER.DataEnd));
  Coder->ER.DataCurr -= EncLength;
  CurrByte = Coder->ER.DataCurr + 1;
  *CurrByte = UnusedBits; CurrByte++;
  for (; Length > 7; Length -= 8, CurrByte++)
    VMSGetOctetBIT_STRING(Coder, CurrStrPtr, 8, *CurrByte);
  if (Length > 0)
    VMSGetOctetBIT_STRING(Coder, CurrStrPtr, Length, *CurrByte);
  BEREncodeDefiniteLength(Coder, EncLength);
}

/**************************************************
 * NAME: BERDecodePrimBIT_STRING
 *       
 *
 */

static void
BERDecodePrimBIT_STRING(tCoder* Coder, tVMSULong Length, tVMSString* vBitString)
{
  unsigned char UnusedBits;
  unsigned char* CurrStrVal;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodePrimBIT_STRING\n");
#endif

  UnusedBits = *(Coder->ER.DataCurr); Coder->ER.DataCurr++;
  DECODING_ERROR_HANDLER_EXP(((Length == 1) && (UnusedBits != 0)) || (UnusedBits > 7), Coder, ec_DEC_WrongUnusedBits, NO_ARGS);
  Length--;

  Length = (Length << 3) - UnusedBits;
  if (Length > 0) 
    {
      VMSAllocBIT_STRING(Coder, (*vBitString), CurrStrVal, Length);

      for (; Length > 7; Length -= 8, Coder->ER.DataCurr++)
        VMSPutOctetBIT_STRING(Coder, CurrStrVal, *(Coder->ER.DataCurr), 8);
      if (Length > 0)
        { 
          VMSPutOctetBIT_STRING(Coder, CurrStrVal, *(Coder->ER.DataCurr), Length); 
          Coder->ER.DataCurr++;
        }
    }
}

#ifdef CODER_BER_CONSTRUCTED
/**************************************************
 * NAME: BEREncodeConsBIT_STRING
 *       
 *
 */

static void
BEREncodeConsBIT_STRING(tCoder* Coder, tVMSString* vString)
{
  tVMSULong BlkLength       = ((CODER_BER_CONSTRUCTED_LENGTH - 1) << 3);
  tVMSULong TmpLength       = vString->Length % BlkLength;
  tVMSString_Value CurrSymb = vString->Value + (vString->Length - TmpLength);
  tVMSULong i;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeConsBIT_STRING\n");
#endif
  
  if (TmpLength > 0)
    {
      /* Content & Length */
      BEREncodePrimBIT_STRING(Coder, TmpLength, CurrSymb);

      /* Identifier octet */
      BERPutByte(Coder, 0x03);
    }
  for (i = 0, TmpLength = vString->Length / BlkLength; i < TmpLength; i++)
    {
      CurrSymb -= BlkLength;

      /* Content & Length */
      BEREncodePrimBIT_STRING(Coder, BlkLength, CurrSymb);

      /* Identifier octet */
      BERPutByte(Coder, 0x03);
    }
}
#endif /* CODER_BER_CONSTRUCTED */

/**************************************************
 * struct BitStringInfo
 *       
 *
 */

static tBERStringInfo BitStringInfo =
{
  (tBEREncodePrimStringFunc) BEREncodePrimBIT_STRING, /* EncPrim */
  (tBERDecodePrimStringFunc) BERDecodePrimBIT_STRING,  /* DecPrim */
  0x03
};

/**************************************************
 * NAME: BEREncodeBIT_STRING
 *       
 *
 */

static void
BEREncodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSString vBitString;  

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeBIT_STRING\n");
#endif

  VMSGetBIT_STRING(Coder, Val, Type, vBitString);
  CUCFCheckBIT_STRING(Coder, Type, vBitString.Length);

#ifdef CODER_BER_CONSTRUCTED
  if (vBitString.Length > ((CODER_BER_CONSTRUCTED_LENGTH - 1) << 3))
    {
      /* CONSTRUCTED ENCODING FORM */
      if (Coder->ER.Rule & er_Definite)
        {
          tVMSULong Length = Coder->ER.MemEnd - Coder->ER.DataCurr;

          /* Content */
          BEREncodeConsBIT_STRING(Coder, &vBitString);

          /* Length */
          Length = (Coder->ER.MemEnd - Coder->ER.DataCurr) - Length;
          BEREncodeDefiniteLength(Coder, Length);
        }
      else
        {
          /* End of content */
          BEREncodeEOC(Coder);

          /* Content */
          BEREncodeConsBIT_STRING(Coder, &vBitString);

          /* Start of content */
          BERPutByte(Coder, 0x80);
        }

      /* Identifier octet */
      if (TagKind == tk_Explicit)
        { BERPutByte(Coder, 0x23); }
    }
  else
#endif

    {
      /* PRIMITIVE ENCODING FORM */

      /* Content & Length */
      BEREncodePrimBIT_STRING(Coder, vBitString.Length, vBitString.Value);

      /* Identifier octet */
      if (TagKind == tk_Explicit)
        { BERPutByte(Coder, 0x03); }
    }
  VMSFreeBitString(Coder, vBitString);
}

/**************************************************
 * NAME: BERDecodeBIT_STRING
 *       
 *
 */

static void
BERDecodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSString vBitString;
  unsigned char EncForm;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeBIT_STRING\n");
#endif

  VMSInitString(vBitString);

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      BERGetByte(Coder, EncForm);
      DECODING_ERROR_HANDLER_EXP((EncForm != 0x23) && (EncForm != 0x03),
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      EncForm &= 0x20;
    }
  else
    EncForm = (unsigned char)(TagKind & 0x20);
  if (EncForm == bef_Constructed)
    {
      /* CONSTRUCTED ENCODING FORM */
      /* Length & Content */
      BERDecodeConsSTRING(Coder, Type, &BitStringInfo, &vBitString);
    }
  else
    {      
      /* PRIMITIVE ENCODING FORM */
      tVMSULong Length;

      /* Length */
      if (((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80)) || (Length == 0))
        DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)Length)
        BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

      /* Content */
      BERDecodePrimBIT_STRING(Coder, Length, &vBitString);
    }
  VMSSetBIT_STRING(Coder, Val, Type, vBitString);
  CUCFCheckBIT_STRING(Coder, Type, vBitString.Length);

  VMSFreeBitString(Coder, vBitString);
}
#endif /* CODER_NOUSE_BIT_STRING */

#if !defined(CODER_NOUSE_OCTET_STRING) || !defined(CODER_NOUSE_CHARACTER_STRING)
/*************************************************/
/**************** OCTET STRING *******************/
/*************************************************/

static void
BEREncodePrimOCTET_STRING(tCoder* Coder, tVMSULong Length, tVMSString_Value vOctetString)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodePrimOCTET_STRING\n");
#endif

  if (Length > 0)
    {
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < (long)Length)
        BERAppendMemory(Coder, Length - (Coder->ER.DataCurr - Coder->ER.DataEnd));
      Coder->ER.DataCurr -= Length;
      memcpy(Coder->ER.DataCurr + 1, (unsigned char*)vOctetString, Length);
    }
  BEREncodeDefiniteLength(Coder, Length);
}
#endif

#ifndef CODER_NOUSE_OCTET_STRING
/**************************************************
 * NAME: BERDecodePrimOCTET_STRING
 *       
 *
 */

static void
BERDecodePrimOCTET_STRING(tCoder* Coder, tVMSULong Length, tVMSString* vOctetString)
{
  unsigned char* CurrStrVal;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodePrimOCTET_STRING\n");
#endif
  
  VMSAllocOCTET_STRING(Coder, (*vOctetString), CurrStrVal, Length);
  memcpy(CurrStrVal, Coder->ER.DataCurr, Length);
  Coder->ER.DataCurr += Length;
}

/**************************************************
 * struct OctetStringInfo
 *       
 *
 */

static tBERStringInfo OctetStringInfo =
{
  (tBEREncodePrimStringFunc) BEREncodePrimOCTET_STRING, /* EncPrim */
  (tBERDecodePrimStringFunc) BERDecodePrimOCTET_STRING, /* DecPrim */
  0x04
};

/**************************************************
 * NAME: BEREncodeOCTET_STRING
 *       
 *
 */

static void
BEREncodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSString vOctetString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeOCTET_STRING\n");
#endif

  VMSGetOCTET_STRING(Coder, Val, Type, vOctetString);
  CUCFCheckOCTET_STRING(Coder, Type, vOctetString.Length);

#ifdef CODER_BER_CONSTRUCTED
  if (vOctetString.Length > (CODER_BER_CONSTRUCTED_LENGTH << 1))
    {
      /* CONSTRUCTED ENCODING FORM */
      if (Coder->ER.Rule & er_Definite)
        {         
          tVMSULong Length = Coder->ER.MemEnd - Coder->ER.DataCurr;
          /* Content */
          BEREncodeConsSTRING(Coder, Type, &OctetStringInfo, &vOctetString);

          /* Length */
          Length = (Coder->ER.MemEnd - Coder->ER.DataCurr) - Length;
          BEREncodeDefiniteLength(Coder, Length);
        }
      else
        {
          /* End of content */
          BEREncodeEOC(Coder);

          /* Content */
          BEREncodeConsSTRING(Coder, Type, &OctetStringInfo, &vOctetString);

          /* Start of content */
          BERPutByte(Coder, 0x80);
        }

      /* Identifier octet */
      if (TagKind == tk_Explicit)
        { BERPutByte(Coder, 0x24); }
    }
  else
#endif

    {
      /* PRIMITIVE ENCODING FORM */
      /* Content & Length */
      BEREncodePrimOCTET_STRING(Coder, vOctetString.Length, vOctetString.Value); 

      /* Identifier octet */
      if (TagKind == tk_Explicit)
        { BERPutByte(Coder, 0x04); }
    }
  VMSFreeOctetString(Coder, vOctetString);
}

/**************************************************
 * NAME: BERDecodeOCTET_STRING
 *       
 *
 */

static void
BERDecodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSString vOctetString;
  unsigned char EncForm;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeOCTET_STRING\n");
#endif

  VMSInitString(vOctetString);

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      BERGetByte(Coder, EncForm);
      DECODING_ERROR_HANDLER_EXP((EncForm != 0x24) && (EncForm != 0x04),
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      EncForm &= 0x20;
    }
  else
    EncForm = (unsigned char)(TagKind & 0x20);
  if (EncForm == bef_Constructed)
    {
      /* CONSTRUCTED ENCODING FORM */
      /* Length & Content */
      BERDecodeConsSTRING(Coder, Type, &OctetStringInfo, &vOctetString);
    }
  else
    {
      /* PRIMITIVE ENCODING FORM */
      tVMSULong Length;

      /* Length */
      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)Length)
        BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

      /* Content */
      if (Length > 0)
        BERDecodePrimOCTET_STRING(Coder, Length, &vOctetString);
    }

  VMSSetOCTET_STRING(Coder, Val, Type, vOctetString);
  CUCFCheckOCTET_STRING(Coder, Type, vOctetString.Length);
  VMSFreeOctetString(Coder, vOctetString);
}
#endif /* CODER_NOUSE_OCTET_STRING */

#ifndef CODER_NOUSE_NULL
/*************************************************/
/********************** NULL *********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeNULL
 *       
 *
 */

static void
BEREncodeNULL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeNULL\n");
#endif                          
  
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < 1)
        BERAppendMemory(Coder, 1 - (Coder->ER.DataCurr - Coder->ER.DataEnd));

      *(Coder->ER.DataCurr) = 0;
      *(Coder->ER.DataCurr - 1) = 0x05;
      Coder->ER.DataCurr -= 2;
    }
  else
    { BERPutByte(Coder, 0); }
}

/**************************************************
 * NAME: BERDecodeNULL
 *       
 *
 */

static void
BERDecodeNULL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeNULL\n");
#endif                          
  
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
        BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x05,
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      DECODING_ERROR_HANDLER_EXP(*(Coder->ER.DataCurr + 1) != 0,
                                 Coder, ec_DEC_WrongLength, NO_ARGS);
      Coder->ER.DataCurr += 2;
    }
  else
    {
      if (Coder->ER.DataEnd == Coder->ER.DataCurr)
        BERAppendData(Coder, 1);
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0,
                                 Coder, ec_DEC_WrongLength, NO_ARGS);
      Coder->ER.DataCurr++;
    }
  VMSSetNULL(Coder, Val, Type, NOTHING);
}
#endif /* CODER_NOUSE_NULL */

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
/*************************************************/
/************* OBJECT IDENTIFIER *****************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeOBJECT_IDENTIFIER
 *       
 *
 */

static void
BEREncodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSULong NumOfComp;           /* Number of components */
  tVMSObjId_Component CurrComp;  /* Current component */
  tVMSULong SubIdent = 0;        /* SubIdentifier */
  tVMSULong Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeOBJECT_IDENTIFIER\n");
#endif                                                                                  

  /* Content */
  Length = Coder->ER.MemEnd - Coder->ER.DataCurr;
  VMSGetSizeOBJECT_IDENTIFIER(Coder, Val, Type, NumOfComp);

  CurrComp = NumOfComp - 1;
  while (CurrComp > 1)
    {
      unsigned char SILen = 1;
      long FreeMem = Coder->ER.DataCurr + 1 - Coder->ER.DataEnd;

      VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, CurrComp, SubIdent);
      if (SubIdent & 0xFFFFFF80)
        {
          SILen = 2;
          if (SubIdent & 0xFFFFC000)
            {
              SILen = 3;
              if (SubIdent & 0xFFE00000)
                {
                  SILen = 4;
                  if (SubIdent & 0xF0000000)
                    {
                      SILen = 5;
                      if (FreeMem < SILen)
                        BERAppendMemory(Coder, SILen - FreeMem);
                      *(Coder->ER.DataCurr - 4) = (unsigned char)((SubIdent >> 28) | 0x80);
                    }
                  else
                  if (FreeMem < SILen)
                    BERAppendMemory(Coder, SILen - FreeMem);
                  *(Coder->ER.DataCurr - 3) = (unsigned char)((SubIdent >> 21) | 0x80);
                }
              else
              if (FreeMem < SILen)
                BERAppendMemory(Coder, SILen - FreeMem);
              *(Coder->ER.DataCurr - 2) = (unsigned char)((SubIdent >> 14) | 0x80);
            }
          else
          if (FreeMem < SILen)
            BERAppendMemory(Coder, SILen - FreeMem);
          *(Coder->ER.DataCurr - 1) = (unsigned char)((SubIdent >> 7) | 0x80);
        }
      else
      if (FreeMem < SILen)
        BERAppendMemory(Coder, SILen - FreeMem);
      *(Coder->ER.DataCurr) = (unsigned char)(SubIdent & 0x7F);

      Coder->ER.DataCurr -= SILen;
      CurrComp--;
    }

  VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, 0, CurrComp);
  SubIdent = CurrComp * 40;
  VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, 1, CurrComp);
  SubIdent += CurrComp;
  VALUE_ERROR_HANDLER_EXP(SubIdent & 0xFFFFFF80, Coder, ec_DEC_TooBigSubIdent, NO_ARGS);

  if (Coder->ER.DataCurr < Coder->ER.DataEnd)
    BERAppendMemory(Coder, Coder->ER.DataEnd - Coder->ER.DataCurr);
  *(Coder->ER.DataCurr) = (unsigned char)(SubIdent & 0x7F);

  Coder->ER.DataCurr--;
  Length = (Coder->ER.MemEnd - Coder->ER.DataCurr) - Length;
  /* Length */
  BEREncodeDefiniteLength(Coder, Length);
  /* Identifer octet */
  if (TagKind == tk_Explicit)
    { BERPutByte(Coder, 0x06); }
}

/**************************************************
 * NAME: BERDecodeOBJECT_IDENTIFIER
 *       
 *
 */

static void
BERDecodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSULong SubIdent;                    /* Subidentifier */
  tVMSULong Length;                      /* Lenght of encoded data */

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeOBJECT_IDENTIFIER\n");
#endif

  VMSInitOBJECT_IDENTIFIER(Coder, Val, Type);

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataEnd == Coder->ER.DataCurr)
        BERAppendData(Coder, 1);
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x06,
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      Coder->ER.DataCurr++;
    }
  
  /* Length */
  BERDecodeDefiniteLength(Coder, &Length);
  DECODING_ERROR_HANDLER_EXP(Length == 0, Coder, ec_DEC_WrongLength, NO_ARGS);

  if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)Length)
    BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

  /* Content */
  SubIdent = *(Coder->ER.DataCurr);
  DECODING_ERROR_HANDLER_EXP(SubIdent & 0x80, Coder, ec_DEC_TooBigSubIdent, NO_ARGS);
  Length--;
  Coder->ER.DataCurr++;

  VMSSetComponentOBJECT_IDENTIFIER(Coder, Val, Type, SubIdent / 40);
  VMSSetComponentOBJECT_IDENTIFIER(Coder, Val, Type, SubIdent % 40);

  while (Length > 0)
    {
      unsigned char Len = 0;
      SubIdent = (*(Coder->ER.DataCurr) & 0x7F);
      Len++;
      while ((*(Coder->ER.DataCurr) & 0x80) && (Len < 6))
        {
          Coder->ER.DataCurr++;
          SubIdent <<= 7;
          SubIdent |= (*(Coder->ER.DataCurr) & 0x7F);
          Len++;
        }
      Length -= Len;
      Coder->ER.DataCurr++;
      DECODING_ERROR_HANDLER_EXP(Len > 5,
                                 Coder, ec_DEC_TooBigSubIdent, NO_ARGS);
      VMSSetComponentOBJECT_IDENTIFIER(Coder, Val, Type, SubIdent);
    }
}
#endif /* CODER_NOUSE_OBJECT_IDENTIFIER */

#ifndef CODER_NOUSE_REAL
/*************************************************/
/******************** REAL ***********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeREAL
 *       
 *
 */

static void
BEREncodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSReal vReal;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeREAL\n");
#endif
 
  VMSGetREAL(Coder, Val, Type, vReal);

  if (vReal.Kind == rk_Zero)
    {
      BERPutByte(Coder, 0x00);
    }
  else
  if (vReal.Kind == rk_MINUS_INFINITY)
    {
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < 1)
        BERAppendMemory(Coder, 1 - (Coder->ER.DataCurr - Coder->ER.DataEnd));
      *(Coder->ER.DataCurr) = 0x41;
      *(Coder->ER.DataCurr - 1) = 0x01;

      Coder->ER.DataCurr -= 2;
    }
  else
  if (vReal.Kind == rk_PLUS_INFINITY)
    {
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < 1)
        BERAppendMemory(Coder, 1 - (Coder->ER.DataCurr - Coder->ER.DataEnd));
      *(Coder->ER.DataCurr) = 0x40;
      *(Coder->ER.DataCurr - 1) = 0x01;

      Coder->ER.DataCurr -= 2;
    }
  else
    {
      tVMSReal_Mantissa Mantissa = vReal.Mantissa;
      int TmpVal;
      unsigned char FirstOctet = 0, TmpLen, ExpLen;
      tVMSULong Length = Coder->ER.MemEnd - Coder->ER.DataCurr;
      unsigned long MASK = 0x7F800000;

      if (Mantissa < 0)
        {
          FirstOctet |= 0xC0;
          Mantissa = -Mantissa;
        }
      else
        FirstOctet |= 0x80;
      switch (vReal.Base)
        {
        case 2:
          break;
        case 8:
          FirstOctet |= 0x10;
          break;
        case 16:
          FirstOctet |= 0x20;
          break;
        case 10:
        default:
          VALUE_ERROR_HANDLER(Coder, ec_VAL_IllegalRealBase, NO_ARGS);
        }

      /* SFACTOR */
      TmpLen = (unsigned char)((Mantissa & 0x1) ? 0 : (Mantissa & 0x2) ? 1 : (Mantissa & 0x4) ? 2 : 3);
      TmpLen = (unsigned char)((TmpLen <= CUCF_BER_REAL_FACTOR) ? TmpLen : CUCF_BER_REAL_FACTOR);
      FirstOctet |= (TmpLen << 2);
      Mantissa >>= TmpLen;

      ExpLen = 4;
      if (vReal.Exponent < 0)
        for (; (ExpLen > 1) && ((vReal.Exponent & MASK) == MASK); ExpLen--, MASK >>= 8);
      else
        for (; (ExpLen > 1) && ((vReal.Exponent & MASK) == 0); ExpLen--, MASK >>= 8);

      if (ExpLen > 3)
        {
          FirstOctet |= 0x3;
          TmpLen = 1;
        }
      else
        {
          FirstOctet |= (ExpLen - 1);
          TmpLen = 0;
        }

      for (TmpLen = (unsigned char)(TmpLen + ExpLen + 1), TmpVal = Mantissa; TmpVal > 0; TmpVal >>= 8, TmpLen++);
      if (Coder->ER.DataCurr - Coder->ER.DataEnd < TmpLen)
        BERAppendMemory(Coder, TmpLen - (Coder->ER.DataCurr - Coder->ER.DataEnd) + 1);
      for (; Mantissa > 0; Mantissa >>= 8, Coder->ER.DataCurr--)
        *(Coder->ER.DataCurr) = (unsigned char)Mantissa;
      for (TmpLen = 0, TmpVal = vReal.Exponent; TmpLen < ExpLen; TmpVal >>= 8, TmpLen++, Coder->ER.DataCurr--)
        *(Coder->ER.DataCurr) = (unsigned char)TmpVal;
      if (ExpLen > 3)
        {
          *(Coder->ER.DataCurr) = ExpLen;
          Coder->ER.DataCurr--;
        }
      *(Coder->ER.DataCurr) = FirstOctet;
      Coder->ER.DataCurr--;

      *(Coder->ER.DataCurr) = (unsigned char)((Coder->ER.MemEnd - Coder->ER.DataCurr) - Length);
      Coder->ER.DataCurr--;
    }

  if (TagKind == tk_Explicit)
    { BERPutByte (Coder, 0x09); }
}

/**************************************************
 * NAME: BERDecodeREAL
 *       
 *
 */

static void
BERDecodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSReal vReal;
  unsigned char Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeREAL\n");
#endif

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
        BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x09,
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      Length = *(Coder->ER.DataCurr + 1);
      Coder->ER.DataCurr += 2;
    }
  else
    {
      if (Coder->ER.DataEnd == Coder->ER.DataCurr)
        BERAppendData(Coder, 1);
      Length = *(Coder->ER.DataCurr);
      Coder->ER.DataCurr++;
    }

  /* Length */
  if (Coder->ER.DataEnd - Coder->ER.DataCurr < Length)
    BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

  /* Content */
  if (Length == 0)
    vReal.Kind = rk_Zero;
  else
  if (Length == 1)
    {
      if (*(Coder->ER.DataCurr) == 0x40)
        vReal.Kind = rk_PLUS_INFINITY;
      else
      if (*(Coder->ER.DataCurr) == 0x41)
        vReal.Kind = rk_MINUS_INFINITY;
      else
        DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongRealPrefix, NO_ARGS);
      Coder->ER.DataCurr++;
    }
  else
    {
      unsigned char FirstOctet, ExpLen;
      tVMSReal_Exponent Exponent;
      tVMSReal_Mantissa Mantissa;
  
      vReal.Kind = rk_Value;

      FirstOctet = *(Coder->ER.DataCurr);
      Coder->ER.DataCurr++;
      Length--;
      if (FirstOctet & 0x80)
        {
          ExpLen = (unsigned char)((FirstOctet & 0x03) + 1);
          if (ExpLen == 4)
            {
              ExpLen = *(Coder->ER.DataCurr);
              Coder->ER.DataCurr++;              
              Length--;
            }
          if (*(Coder->ER.DataCurr) & 0x80) Exponent = ~0L;
          else Exponent = 0;
          for (; ExpLen > 0; Coder->ER.DataCurr++, ExpLen--, Length--)
            Exponent = ((Exponent << 8) | *(Coder->ER.DataCurr));
          for (Mantissa = 0; Length > 0; Length--, Coder->ER.DataCurr++)
            Mantissa = ((Mantissa << 8) | *(Coder->ER.DataCurr));
          Mantissa <<= ((FirstOctet & 0x0C) >> 2);

          if (FirstOctet & 0x40) vReal.Mantissa = -Mantissa;
          else vReal.Mantissa = Mantissa;
          vReal.Exponent = Exponent;

          switch (FirstOctet & 0x30)
            {
            case 0x00:
              vReal.Base = 2;
              break;
            case 0x10:
              vReal.Base = 8;
              break;
            case 0x20:
              vReal.Base = 16;
              break;
            default:
              vReal.Base = 0;
              DECODING_ERROR_HANDLER(Coder, ec_DEC_UnsupportedRealBase, NO_ARGS);
            }
        }
      else
        {
          DECODING_ERROR_HANDLER(Coder, ec_DEC_UnsupportedRealDecimalEncoding, NO_ARGS);
        }
    }
  VMSSetREAL(Coder, Val, Type, vReal);
}
#endif /* CODER_NOUSE_REAL */

#ifndef CODER_NOUSE_CHARACTER_STRING
/**************************************************/
/*************** CHARACTER STRING *****************/
/**************************************************/

#define BEREncodePrimCHARACTER_STRING(coder, length, val) BEREncodePrimOCTET_STRING(coder, length, val)

/**************************************************
 * NAME: BERDecodePrimCHARACTER_STRING
 *       
 *
 */

static void
BERDecodePrimCHARACTER_STRING(tCoder* Coder, tVMSULong Length, tVMSString* vCharString)
{
  unsigned char* CurrStrVal;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodePrimCHARACTER_STRING\n");
#endif

  VMSAllocCHARACTER_STRING(Coder, (*vCharString), CurrStrVal, Length);
  memcpy(CurrStrVal, Coder->ER.DataCurr, Length);
  Coder->ER.DataCurr += Length;
}

/**************************************************
 * struct CharStringInfo
 *       
 *
 */

static tBERStringInfo CharStringInfo =
{
  (tBEREncodePrimStringFunc) BEREncodePrimOCTET_STRING, /* EncPrim */
  (tBERDecodePrimStringFunc) BERDecodePrimCHARACTER_STRING, /* DecPrim */
  0x04
};

/**************************************************
 * NAME: BEREncodeCHARCTER_STRING
 *       
 *
 */

static void
BEREncodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSString vCharString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeCHARACTER_STRING\n");
#endif

  switch (Type->TypeClass & 0x1F)
    {
    case type_ASN1_NumericString:
      VMSGetNumericString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_PrintableString:
      VMSGetPrintableString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_IA5String:
      VMSGetIA5String(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_VisibleString:
      VMSGetVisibleString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_GeneralizedTime:
      VMSGetGeneralizedTime(Coder, Val, Type, vCharString);
      break;
    default: /* type_ASN1_UTCTime */
      VMSGetUTCTime(Coder, Val, Type, vCharString);
      break;
    }
  CUCFCheckCHARACTER_STRING(Coder, Type, &vCharString);

#ifdef CODER_BER_CONSTRUCTED
  if (vCharString.Length > CODER_BER_CONSTRUCTED_LENGTH)
    {
      /* CONSTRUCTED ENCODING FORM */
      if (Coder->ER.Rule & er_Definite)
        {
          tVMSULong Length = Coder->ER.MemEnd - Coder->ER.DataCurr;
          /* Content */
          BEREncodeConsSTRING(Coder, Type, &CharStringInfo, &vCharString);
          Length = (Coder->ER.MemEnd - Coder->ER.DataCurr) - Length;

          /* Length */
          BEREncodeDefiniteLength(Coder, Length);
        }
      else
        {
          /* End of content */
          BEREncodeEOC(Coder);

          /* Content */
          BEREncodeConsSTRING(Coder, Type, &CharStringInfo, &vCharString);

          /* Start of content */
          BERPutByte(Coder, 0x80);
        }      

      /* Identifier octet */
      if (TagKind == tk_Explicit)
        { BERPutByte(Coder, (unsigned char)(0x20 | (Type->TypeClass & 0x1F))); }
    }
  else
#endif

    {
      /* PRIMITIVE ENCODING FORM */
      /* Content & Length */
      BEREncodePrimCHARACTER_STRING(Coder, vCharString.Length, vCharString.Value);

      /* Identifier octet */
      if (TagKind == tk_Explicit)
        { BERPutByte(Coder, (Type->TypeClass & 0x1F)); }
    }
  VMSFreeCharString(Coder, vCharString);
}

/**************************************************
 * NAME: BERDecodeCHARACTER_STRING
 *       
 *
 */

static void
BERDecodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSString vCharString;
  unsigned char EncForm;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeCHARACTER_STRING\n");
#endif

  VMSInitString(vCharString);

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      BERGetByte(Coder, EncForm);
      DECODING_ERROR_HANDLER_EXP((EncForm != (0x20 | (Type->TypeClass & 0x1F))) && (EncForm != (Type->TypeClass & 0x1F)),
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      EncForm &= 0x20;
    }
  else
    EncForm = (unsigned char)(TagKind & 0x20);
  if (EncForm == bef_Constructed)
    {
      /* CONSTRUCTED ENCODING FORM */
      /* Length & Content */
      BERDecodeConsSTRING(Coder, Type, &CharStringInfo, &vCharString);
    }
  else
    {
      /* PRIMITIVE ENCODING FORM */
      tVMSULong Length;

      /* Length */
      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < (long)Length)
        BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

      /* Content */
      if (Length > 0)
        BERDecodePrimCHARACTER_STRING(Coder, Length, &vCharString);
    }
  switch (Type->TypeClass & 0x1F)
    {
    case type_ASN1_NumericString:
      VMSSetNumericString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_PrintableString:
      VMSSetPrintableString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_IA5String:
      VMSSetIA5String(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_VisibleString:
      VMSSetVisibleString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_GeneralizedTime:
      VMSSetGeneralizedTime(Coder, Val, Type, vCharString);
      break;
    default: /* type_ASN1_UTCTime */
      VMSSetUTCTime(Coder, Val, Type, vCharString);
      break;
    }
  CUCFCheckCHARACTER_STRING(Coder, Type, &vCharString);
  VMSFreeCharString(Coder, vCharString);
}

#endif /* CODER_NOUSE_CHARACTER_STRING */

#ifndef CODER_NOUSE_ENUMERATED
/*************************************************/
/***************** ENUMERATED ********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeENUMERATED
 *       
 *
 */

static void
BEREncodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSILen Len;
  tVMSULong FreeMem = (Coder->ER.DataCurr - Coder->ER.DataEnd) - 1;
  tVMSULong vUEnum, vOEnum;
#ifndef CODER_NOUSE_BIG_INTEGER
  tVMSUInteger vEnum;
#endif

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeENUMERATED\n");
#endif

#ifdef CODER_NOUSE_ENUMERATED_ITEMS
  VMSGetIndexENUMERATED(Coder, Val, Type, vUEnum);
  vOEnum = vUEnum;
#else

#ifndef CODER_NOUSE_BIG_INTEGER
  VMSGetValueENUMERATED(Coder, Val, Type, vEnum);
  if (vEnum.Sign)
    {
      vUEnum = vEnum.Number - 1;
      vOEnum = (0xFFFFFFFF - vEnum.Number) + 1;
    }
  else
    vUEnum = vOEnum = vEnum.Number;
#else
  VMSGetValueENUMERATED(Coder, Val, Type, *((tVMSInteger*)&vUEnum));
  if ((tVMSEnumerated_Value)vUEnum < 0)
    {
      vOEnum = vUEnum;
      vUEnum = (unsigned int)(-(tVMSInteger)(vUEnum + 1));
    }
  else
    vOEnum = vUEnum;
#endif

#endif
  
  Len = 1;
  if ((vUEnum & 0xFFFFFF80) != 0)
    {
      Len = 2;
      if ((vUEnum & 0xFFFF8000) != 0)
        {
          Len = 3;
          if ((vUEnum & 0xFF800000) != 0)
            {
              Len = 4;
#ifndef CODER_NOUSE_BIG_INTEGER
              if ((vUEnum & 0x80000000) != 0)
                {
                  Len = 5;
                  if (FreeMem < Len)
                    BERAppendMemory(Coder, Len - FreeMem);
                  *(Coder->ER.DataCurr - 4) = vEnum.Sign ? 0xFF : 0x00;
                }
              else
#endif
              if (FreeMem < Len)
                BERAppendMemory(Coder, Len - FreeMem);

              *(Coder->ER.DataCurr - 3) = (unsigned char)(vOEnum >> 24);
            }
          else
          if (FreeMem < Len)
            BERAppendMemory(Coder, Len - FreeMem);

          *(Coder->ER.DataCurr - 2) = (unsigned char)(vOEnum >> 16);
        }
      else
      if (FreeMem < Len)
        BERAppendMemory(Coder, Len - FreeMem);

      *(Coder->ER.DataCurr - 1) = (unsigned char)(vOEnum >> 8);
    }
  else
  if (FreeMem < Len)
     BERAppendMemory(Coder, Len - FreeMem);

  *(Coder->ER.DataCurr) = (unsigned char)vOEnum;

  *(Coder->ER.DataCurr - Len) = Len;
  Coder->ER.DataCurr -= Len + 1;
  if (TagKind == tk_Explicit)
    { BERPutByte(Coder, 0x0A); }
}

/**************************************************
 * NAME: BERDecodeENUMERATED
 *       
 *
 */

static void
BERDecodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tVMSILen Len, i;
  tVMSUInteger vUEnum; 

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeENUMERATED\n");
#endif

  /* Identifier octet */
  if (TagKind == tk_Explicit)
    {
      if (Coder->ER.DataEnd - Coder->ER.DataCurr < 2)
        BERAppendData(Coder, 2 - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      DECODING_ERROR_HANDLER_EXP(*Coder->ER.DataCurr != 0x0A,
                                 Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
      Len = *(Coder->ER.DataCurr + 1);
      Coder->ER.DataCurr += 2;
    }
  else
    {
      if (Coder->ER.DataEnd == Coder->ER.DataCurr)
        BERAppendData(Coder, 1);
      Len = *(Coder->ER.DataCurr); 
      Coder->ER.DataCurr++;
    }

#ifndef CODER_NOUSE_BIG_INTEGER
  DECODING_ERROR_HANDLER_EXP((Len == 0) || (Len > sizeof(unsigned int) + 1), Coder, ec_DEC_WrongLength, NO_ARGS);
#else
  DECODING_ERROR_HANDLER_EXP((Len == 0) || (Len > sizeof(int)), Coder, ec_DEC_WrongLength, NO_ARGS);
#endif

  if (Coder->ER.DataEnd - Coder->ER.DataCurr < Len)
    BERAppendData(Coder, Len - (Coder->ER.DataEnd - Coder->ER.DataCurr));

  /* Content */
  if (*(Coder->ER.DataCurr) & 0x80) 
    {
#ifndef CODER_NOUSE_BIG_INTEGER
      vUEnum.Sign = 1;
#endif
      vUEnum.Number = 0xFFFFFF00 | *(Coder->ER.DataCurr);
    }
  else 
    {
#ifndef CODER_NOUSE_BIG_INTEGER
      vUEnum.Sign = 0;
#endif
      vUEnum.Number = *(Coder->ER.DataCurr);
    }

  for (i = 1; i < Len; i++)
    {
      vUEnum.Number <<= 8;
      vUEnum.Number |= *(Coder->ER.DataCurr + i);
    }
  Coder->ER.DataCurr += Len;

#ifdef CODER_NOUSE_ENUMERATED_ITEMS
  VMSSetIndexENUMERATED(Coder, Val, Type, vUEnum.Number);
  CUCFCheckENUMERATEDIndex(Coder, Type, vUEnum.Number);
#else
#ifndef CODER_NOUSE_BIG_INTEGER
  if (vUEnum.Sign) vUEnum.Number = (unsigned int)(-(int)(vUEnum.Number));
  VMSSetValueENUMERATED(Coder, Val, Type, vUEnum);
  CUCFCheckENUMERATEDValue(Coder, Type, &vUEnum);
#else
  VMSSetValueENUMERATED(Coder, Val, Type, ((int)(vUEnum.Number)));
  CUCFCheckENUMERATEDValue(Coder, Type, (tVMSULong*)(&(vUEnum.Number)));
#endif
#endif
}
#endif /* CODER_NOUSE_ENUMERATED */

#if !defined(CODER_NOUSE_SET) && defined(CODER_BER_CANONICAL_OFF)
/*************************************************/
/********************* SET ***********************/
/*************************************************/

/**************************************************
 * NAME: BERGetSETComponent
 *       
 *
 */

static void
BERGetSETComponent(tCoder* Coder, tASN1Struct* Type, tVMSStructMask* SetMask, tASN1Component** Component)
{
  tASN1Component* CurrComp;
  CODER_NumOf_TYPE NumOfComps;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERGetIndexSETComponents\n");
#endif

  CurrComp = Type->RootComps1;
  NumOfComps = Type->NumOfRC1;
  while (NumOfComps > 0)
    {
      if (VMSMaskGetBit((*SetMask), CurrComp->Index) != 1)
        {
          tASN1TypeInfo* CurrType = CurrComp->TypeInfo;

#ifndef CODER_NOUSE_OPEN
          while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
#else
          while (CurrType->TypeClass == type_ASN1_DEFINED)
#endif
            CurrType = ((tASN1Defined*)CurrType)->BaseType;
          if (CurrType->TypeClass & 0x1F)
            {
              if (Coder->ER.DataEnd == Coder->ER.DataCurr)
                BERAppendData(Coder, 1);
              if (((*(Coder->ER.DataCurr) & 0xC0) == tc_UT) && 
                  ((*(Coder->ER.DataCurr) & 0x1F) == (CurrType->TypeClass & 0x1F)))
                {
                  *Component = CurrComp;
                  return;
                }
            }
          else
            {
              tBERTag EncTag;
              unsigned char EncForm;

              BERPeekIdentifierOctet(Coder, &EncForm, &EncTag);
              if (CurrType->TypeClass == type_ASN1_TAGGED)
                {
                  if ((((tASN1Tagged*)CurrType)->Tags->Class == EncTag.Class) && 
                      (((tASN1Tagged*)CurrType)->Tags->Number == EncTag.Number))
                    {
                      *Component = CurrComp;
                      return;
                    }
                }
#ifndef CODER_NOUSE_CHOICE
              else
              if (CurrType->TypeClass == type_ASN1_CHOICE)
                {
                  tASN1Alternative* AltInfo = NULL;

                  BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, &EncTag, &AltInfo);
                  if (AltInfo != NULL)
                    {
                      *Component = CurrComp;
                      return;
                    }
                }
#endif
#ifndef CODER_NOUSE_OPEN
              else
              if (CurrType->TypeClass == type_ASN1_OPEN)
                {
                  if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, Tag) == 1)
                    {
                      *Component = CurrComp;
                      return;
                    }
                }
#endif
            }
        }
      CurrComp++;
      NumOfComps--;
    }

#ifndef CODER_NOUSE_EXT
  CurrComp = Type->ExtAddComps;
  NumOfComps = Type->NumOfEAC;
  while (NumOfComps > 0)
    {
      if ((CurrComp->Type != ct_Group) && (VMSMaskGetBit((*SetMask), CurrComp->Index) != 1))
        {
          tASN1TypeInfo* CurrType = CurrComp->TypeInfo;


#ifndef CODER_NOUSE_OPEN
          while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
#else
          while (CurrType->TypeClass == type_ASN1_DEFINED)
#endif
            CurrType = ((tASN1Defined*)CurrType)->BaseType;
          if (CurrType->TypeClass & 0x1F)
            {
              if (Coder->ER.DataEnd == Coder->ER.DataCurr)
                BERAppendData(Coder, 1);
              if (((*(Coder->ER.DataCurr) & 0xC0) == tc_UT) && 
                  ((*(Coder->ER.DataCurr) & 0x1F) == (CurrType->TypeClass & 0x1F)))
                {
                  *Component = CurrComp;
                  return;
                }
            }
          else
            {
              tBERTag EncTag;
              unsigned char EncForm;

              BERPeekIdentifierOctet(Coder, &EncForm, &EncTag);
              if (CurrType->TypeClass == type_ASN1_TAGGED)
                {
                  if ((((tASN1Tagged*)CurrType)->Tags->Class == EncTag.Class) && 
                      (((tASN1Tagged*)CurrType)->Tags->Number == EncTag.Number))
                    {
                      *Component = CurrComp;
                      return;
                    }
                }
#ifndef CODER_NOUSE_CHOICE
              else
              if (CurrType->TypeClass == type_ASN1_CHOICE)
                {
                  tASN1Alternative* AltInfo = NULL;

                  BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, &EncTag, &AltInfo);
                  if (AltInfo != NULL)
                    {
                      *Component = CurrComp;
                      return;
                    }
                }
#endif
#ifndef CODER_NOUSE_OPEN
              else
              if (CurrType->TypeClass == type_ASN1_OPEN)
                {
                  if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, Tag) == 1)
                    {
                      *Component = CurrComp;
                      return;
                    }
                }
#endif
            }
        }
      CurrComp++;
      NumOfComps--;
    }
#endif /* CODER_NOUSE_EXT */

  *Component = NULL;
}

/**************************************************
 * NAME: BERDecodeSETComponents
 *       
 *
 */

static void
BERDecodeSETComponents(tCoder* Coder, tASN1Struct* Type, void* vSet ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1Component* CurrComp;
  tVMSStructMask  SetMask;
  unsigned char   StaticMaskValue[16];
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeSETComponents\n");
#endif

  if (Type->NumOfRC1 <= 0x80)
    { VMSAssignMask(SetMask, StaticMaskValue, Type->NumOfRC1); }
  else
    { VMSInitMask(Coder, SetMask, Type->NumOfRC1); }
  CurrComp = Type->RootComps1;
  if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
    {
      while (!BERIsEOC(Coder))
        {
          BERGetSETComponent(Coder, Type, &SetMask, &CurrComp);
          
          if (CurrComp != NULL)
            {
              if (CurrComp->Type != ct_Absent)
                {
                  void* CurrField;

                  VMSGetComponentSET(Coder, vSet, Type, CurrComp, CurrField);

                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  VMSMaskPutBit(SetMask, CurrComp->Index, 1);
                }
              else
                DECODING_ERROR_HANDLER(Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
            }
          else
            DECODING_ERROR_HANDLER(Coder, ec_DEC_UnknownComponent, NO_ARGS);
        }
      BERDecodeEOC(Coder);
    }
  else
    {
      unsigned char* CurrByte = Coder->ER.DataCurr;
      
      while (Length > 0)
        {
          BERGetSETComponent(Coder, Type, &SetMask, &CurrComp);
          if (CurrComp != NULL)
            {
              if (CurrComp->Type != ct_Absent)
                {
                  void* CurrField;
                  
                  VMSGetComponentSET(Coder, vSet, Type, CurrComp, CurrField);

                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  VMSMaskPutBit(SetMask, CurrComp->Index, 1);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                DECODING_ERROR_HANDLER(Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
            }
          else
            DECODING_ERROR_HANDLER(Coder, ec_DEC_UnknownComponent, NO_ARGS);
        }
    }
  CurrComp = Type->RootComps1;
  Length = Type->NumOfRC1;
  while (Length > 0)
    {
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
            DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
          break;
        case ct_Optional:
          if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
            {
              VMSInitAbsentOptionalComponentSET(Coder, vSet, Type, CurrComp);
            }
          else
            {
              VMSInitPresentOptionalComponentSET(Coder, vSet, Type, CurrComp);
            }
          break;
        case ct_Default:
          if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
            {
              VMSInitAbsentDefaultComponentSET(Coder, vSet, Type, CurrComp);
            }
          else
            {
              VMSInitPresentDefaultComponentSET(Coder, vSet, Type, CurrComp);
            }
          break;
        case ct_Absent:
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
      CurrComp++;
      Length--;
    }
  if (Type->NumOfRC1 > 0x80)
    { VMSReleaseMask(Coder, SetMask); }
}

/**************************************************
 * NAME: BERDecodeSETComponentsWithExtAdd
 *       
 *
 */

static void
BERDecodeSETComponentsWithExtAdd(tCoder* Coder, tASN1Struct* Type, void* vSet ER_OLIST(tVMSOpenTypeList* List))
{
  CODER_NumOf_TYPE NumOfComps = 0;     /* Number of components */
  tASN1Component* CurrComp;            /* Current component */
  tVMSStructMask SetMask;              /* Components mask */
  unsigned char   StaticMaskValue[16]; /* Static value for components mask */
  tVMSULong Length = 0;      

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeSETComponentsWithExtGroups\n");
#endif

  for (CurrComp = Type->RootComps1; CurrComp->Type != ct_Last; NumOfComps++, CurrComp++);
  for (CurrComp = Type->ExtAddComps; CurrComp->Type != ct_Last; CurrComp++)
    if (CurrComp->Type != ct_Group)
        NumOfComps++;
  if (NumOfComps <= 0x80)
    { VMSAssignMask(SetMask, StaticMaskValue, NumOfComps); }
  else
    { VMSInitMask(Coder, SetMask, NumOfComps); }
  if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
    {
      while (!BERIsEOC(Coder))
        {
          BERGetSETComponent(Coder, Type, &SetMask, &CurrComp);
          if (CurrComp != NULL)
            {
              if (CurrComp->Type != ct_Absent)
                {
                  void* CurrField;
                  
                  VMSGetComponentSET(Coder, vSet, Type, CurrComp, CurrField);

                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  VMSMaskPutBit(SetMask, CurrComp->Index, 1);
                }
              else
                DECODING_ERROR_HANDLER(Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
            }
          else
            {
              if (Type->ExtAddComps == NULL)
                BERSkipValue(Coder);
              else
#ifndef CODER_NOUSE_EXT
                BERSkipValue(Coder);
#else
              DECODING_ERROR_HANDLER(Coder, ec_DEC_UnknownComponent, NO_ARGS);
#endif
            }
        }
      BERDecodeEOC(Coder);
    }
  else
    {
      unsigned char* CurrByte = Coder->ER.DataCurr;
     
      while (Length > 0)
        {
          BERGetSETComponent(Coder, Type, &SetMask, &CurrComp);
          if (CurrComp != NULL)
            {
              if (CurrComp->Type != ct_Absent)
                {
                  void* CurrField;
                  
                  VMSGetComponentSET(Coder, vSet, Type, CurrComp, CurrField);

                  EPSetFiels(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  VMSMaskPutBit(SetMask, CurrComp->Index, 1);
                }
              else
                DECODING_ERROR_HANDLER(Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
            }
          else
            {
              if (Type->ExtAddComps == NULL)
                BERSkipValue(Coder);
              else
#ifndef CODER_NOUSE_EXT
                BERSkipValue(Coder);
#else
              DECODING_ERROR_HANDLER(Coder, ec_DEC_UnknownComponent, NO_ARGS);
#endif
            }
          Length -= Coder->ER.DataCurr - CurrByte;
          CurrByte = Coder->ER.DataCurr;
        }
    }
  CurrComp = Type->RootComps1;
  NumOfComps = Type->NumOfRC1;
  while (NumOfComps > 0)
    {
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
            DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
          break;
        case ct_Optional:
          if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
            {
              VMSInitAbsentOptionalComponentSET(Coder, vSet, Type, CurrComp);
            }
          else
            {
              VMSInitPresentOptionalComponentSET(Coder, vSet, Type, CurrComp);
            }
          break;
        case ct_Default:
          if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
            {
              VMSInitAbsentDefaultComponentSET(Coder, vSet, Type, CurrComp);
            }
          else
            {
              VMSInitPresentDefaultComponentSET(Coder, vSet, Type, CurrComp);
            }
          break;
        case ct_Absent:
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                 ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
      CurrComp++;
      NumOfComps--;
    }
  if (Type->NumOfEAC > 0)
    {
      CODER_NumOf_TYPE UER, DEOD;
      CODER_NumOf_TYPE UGR, DGOD;
      CODER_NumOf_TYPE i, GrpComp;

      CurrComp = Type->ExtAddComps;
      NumOfComps = Type->NumOfEAC;
      UER = DEOD = UGR = DGOD = 0;
      i = GrpComp = 0;
      
      while (NumOfComps > 0)
        {
          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
                {
                  VMSInitAbsentOptionalComponentSET(Coder, vSet, Type, CurrComp);
                  if (GrpComp != 0)
                    {
                      UGR++;                  
                      i++;
                    }
                  else
                    UER++;
                }
              else
                {
                  VMSInitPresentOptionalComponentSET(Coder, vSet, Type, CurrComp);
                }
              break;
            case ct_Optional:
              if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
                {
                  VMSInitAbsentOptionalComponentSET(Coder, vSet, Type, CurrComp);
                }
              else
                {
                  VMSInitPresentOptionalComponentSET(Coder, vSet, Type, CurrComp);
                  if (GrpComp != 0)
                    {
                      DGOD++;
                      i++;
                    }
                  else
                    DEOD++;
                }
              break;
            case ct_Default:
              if (VMSMaskGetBit(SetMask, CurrComp->Index) != 1)
                {
                  VMSInitAbsentDefaultComponentSET(Coder, vSet, Type, CurrComp);
                }
              else
                {
                  VMSInitPresentDefaultComponentSET(Coder, vSet, Type, CurrComp);
                  if (GrpComp != 0)
                    {
                      DGOD++;
                      i++;
                    }
                  else
                    DEOD++;
                }
              break;
            case ct_Absent:
              break;
            case ct_Group:
              GrpComp = CurrComp->Index;
              i = 0;
              UGR = DGOD = 0;
              break;
          default:
            INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
          }
          if (i == GrpComp)
            {
              DECODING_ERROR_HANDLER_EXP((UGR != 0) && (DGOD != 0),
                                         Coder, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);
              GrpComp = 0;
            }
          CurrComp++;
          NumOfComps--;
        }
      DECODING_ERROR_HANDLER_EXP((UER != 0) && (DEOD != 0),
                                 Coder, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);
    }
  if (SetMask.Size > 0x80)
    { VMSReleaseMask(Coder, SetMask); }
}
  
/**************************************************
 * NAME: BERDecodeSET
 *       
 *
 */

static void
BERDecodeUCSET(tCoder* Coder, tASN1TypeInfo* Type, void* Val ER_OLIST(tVMSOpenTypeList* List))
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeUCSET\n");
#endif

#ifndef CODER_NOUSE_OPEN
  /* Initialization of Open type list (if current SET is root for Open type) */
  if (((tASN1Set*)Type)->RootExtFlags & 0x10)
    {
      tVMSOpenTypeList LList;
      
      LList.Bodies = NULL;
      if (List != NULL)
        LList.Ids = List->Ids;
      else
        LList.Ids = NULL;

      /* Length & Content */
      if (((tASN1Struct*)Type)->RootExtFlags & 0x01)
        BERDecodeSETComponentsWithExtAdd(Coder, (tASN1Struct*)Type, Val, &LList);
      else
        BERDecodeSETComponents(Coder, (tASN1Struct*)Type, Val, &LList);

      /* Processing of Open type list */
      if (LList.Bodies != NULL)
        BERDecodeSkipedValues(Coder, &LList);
      
      if (List != NULL)
        {
          if (LList.Bodies != NULL)
            {
              if (List->Bodies != NULL)
                {
                  tVMSOpenBodyList* LastBody = List->Bodies;

                  while (LastBody->Next != NULL)
                    LastBody = LastBody->Next;

                  LastBody->Next = LList.Bodies;
                }
              else
                List->Bodies = LList.Bodies;
            }
          
          if (List->Ids == NULL)
            List->Ids = LList.Ids;
        }
      else
        {
          DECODING_ERROR_HANDLER_EXP(LList.Bodies != NULL,
                                     Coder, ec_DEC_NoOpenId, NO_ARGS);
          while (LList.Ids != NULL)
            {
              tVMSOpenIdList* CurrId = LList.Ids;
              LList.Ids = CurrId->Next;
              CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
            }
        }
    }
  else
#endif /* CODER_NOUSE_OPEN */

  if (((tASN1Struct*)Type)->RootExtFlags & 0x10)
    BERDecodeSETComponentsWithExtAdd(Coder, (tASN1Struct*)Type, Val ER_OLIST(List));
  else
    BERDecodeSETComponents(Coder, (tASN1Struct*)Type, Val ER_OLIST(List));
}
#endif /* !defined(CODER_NOUSE_SET) && defined(CODER_BER_CANONICAL_OFF) */


#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_OPEN)
/**************************************************/
/***************** Struct Value *******************/
/**************************************************/

/**************************************************
 * NAME: BERSkipValue
 *       
 *
 */

static void
BERSkipValue(tCoder* Coder)
{
  tBERTag EncTag;
  unsigned char EncForm = 0;
  tVMSULong EncLength, DecLength;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERSkipValue\n");
#endif

  BERDecodeIdentifierOctet(Coder, &EncForm, &EncTag);
  DecLength = BERDecodeDefiniteLength(Coder, &EncLength);
  if (EncForm == bef_Constructed)
    {
      if ((EncLength == 0x80) && (DecLength == 1))
        {
          while (!BERIsEOC(Coder)) 
            BERSkipValue(Coder);
          BERDecodeEOC(Coder);
        }
      else
        BERSkipSeg(Coder, EncLength);
    } 
  else 
    { 
      DECODING_ERROR_HANDLER_EXP((EncLength == 0x80) && (DecLength == 1),
                                 Coder, ec_DEC_WrongLength, NO_ARGS);
      BERSkipSeg(Coder, EncLength);
    }
}
#endif /* !defined(CODER_NOUSE_SEQUENCE) && !defined(CODER_NOUSE_SET) && !defined(CODER_NOUSE_OPEN) */

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
/*************************************************/
/******************** STRUCT *********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeStructComponents
 *       
 *
 */

static void
BEREncodeStructComponents(tCoder* Coder, tASN1Struct* Type, void* Val)
{
  tASN1Component* CurrComp;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeStructComponents\n");
#endif

#ifndef CODER_NOUSE_SEQUENCE
  if (Type->NumOfRC2 > 0)
    {
      CurrComp = Type->RootComps2 + Type->NumOfRC2;
      
      do
        {
          void* CurrField;

          CurrComp--;
          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
              EPDelField(Coder);
              break;
            case ct_Optional:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Default:
              VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Absent:
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
        }
      while (CurrComp != Type->RootComps2);
    }
#endif

#ifndef CODER_NOUSE_EXT
  if (Type->NumOfEAC > 0)
    {
      CurrComp = Type->ExtAddComps + Type->NumOfEAC;

      do
        {
          void* CurrField;

          CurrComp--;
          switch(CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Optional:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Default:
              VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);          
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Absent:
            case ct_Group:
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
        }
      while (CurrComp != Type->ExtAddComps);
    }
#endif /* CODER_NOUSE_EXT */

  if (Type->NumOfRC1 > 0)
    {
      CurrComp = Type->RootComps1 + Type->NumOfRC1;

      do
        {
          void* CurrField;

          CurrComp--;
          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
              EPDelField(Coder);
              break;
            case ct_Optional:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);          
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Default:
              VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  EPSetField(Coder, CurrComp);
                  BEREncVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit);
                  EPDelField(Coder);
                }
              break;
            case ct_Absent:
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
        }
      while (CurrComp != Type->RootComps1);
    }
}

/**************************************************
 * NAME: BEREncodeStruct
 *       
 *
 */

void
BEREncodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeStruct\n");
#endif

  if (Coder->ER.Rule & er_Definite) 
    {
      tVMSULong Start = Coder->ER.MemEnd - Coder->ER.DataCurr;
      /* Content */
      BEREncodeStructComponents(Coder, (tASN1Struct*)Type, Val);
      /* Length */
      BEREncodeDefiniteLength(Coder, (Coder->ER.MemEnd - Coder->ER.DataCurr) - Start);
    }
  else
    {
      /* End of content */
      BEREncodeEOC(Coder);

      BEREncodeStructComponents(Coder, (tASN1Struct*)Type, Val);

      /* Start of content */
      BERPutByte(Coder, 0x80);
    }
}
#endif /* !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) */

#if !defined(CODER_NOUSE_SEQUENCE) || (!defined(CODER_NOUSE_SET) && !defined(CODER_BER_CANONICAL_OFF))

/**************************************************
 * NAME: BERIsSpecifiedComponent
 *
 *
 */

static unsigned char
BERIsSpecifiedComponent(tCoder* Coder, tASN1Component* Comp)
{
  tASN1TypeInfo* CurrType = Comp->TypeInfo;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERIsSpecifiedComponent\n");
#endif              

#ifndef CODER_NOUSE_OPEN
  while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
#else
  while (CurrType->TypeClass == type_ASN1_DEFINED)
#endif
    CurrType = ((tASN1Defined*)CurrType)->BaseType;

  if (CurrType->TypeClass & 0x1F)
    {
      if (((*(Coder->ER.DataCurr) & 0xC0) == tc_UT) && ((*(Coder->ER.DataCurr) & 0x1F) == (CurrType->TypeClass & 0x1F)))
        return 1;
    }
  else
    {
      tBERTag EncTag;
      unsigned char EncForm = 0;

      BERPeekIdentifierOctet(Coder, &EncForm, &EncTag);
      if (CurrType->TypeClass == type_ASN1_TAGGED)
        {
          if ((((tASN1Tagged*)CurrType)->Tags->Class == EncTag.Class) && 
              (((tASN1Tagged*)CurrType)->Tags->Number == EncTag.Number))
            return 1;
        }
#ifndef CODER_NOUSE_CHOICE
      else
      if (CurrType->TypeClass == type_ASN1_CHOICE)
        {
          tASN1Alternative* AltInfo = NULL;
          
          BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, &EncTag, &AltInfo);
          if (AltInfo != NULL)
            return 1;
        }      
#endif
#ifndef CODER_NOUSE_OPEN
      else
      if (CurrType->TypeClass == type_ASN1_OPEN)
        {
          if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, &EncTag) == 1)
            return 1;
        }
#endif
    }
  return 0;
}

/**************************************************
 * NAME: BERDecodeStructComponents
 *       
 *
 */

static void
BERDecodeStructComponents(tCoder* Coder, tASN1Struct* Type, void* Val ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1Component* CurrComp = Type->RootComps1;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeStructComponents\n");
#endif

  if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
    {
      while (!BERIsEOC(Coder))
        {
          void *CurrField;

          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
              EPDelField(Coder);
              break;
            case ct_Optional:             
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                { 
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:             
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          CurrComp++;
        }
      BERDecodeEOC(Coder);
    }
  else
    {
      unsigned char* CurrByte = Coder->ER.DataCurr;

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < Length)
        BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));
         
      while (Length > 0)
        {
          void *CurrField;

          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
              EPDelField(Coder);

              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
              break;
            case ct_Optional:             
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:           
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);                  
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          CurrComp++;
        }
    }
  Length = CurrComp - Type->RootComps1;
  while (Length < (tVMSULong)(Type->NumOfRC1))
    {
      switch(CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
        case ct_Optional:
          VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Default:
          VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Absent:
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
      CurrComp++;
      Length++;
    }
}

/**************************************************
 * NAME: BERSkipStructExtAdd
 *       
 *
 */

static void
BERSkipStructExtAdd(tCoder* Coder, tASN1Struct* Type, tVMSULong* Length, unsigned long EncType)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERSkipStructExtAdd\n");
#endif

  if (EncType == er_Definite)
    {  
      unsigned char* CurrByte = Coder->ER.DataCurr;
      
      if (Type->NumOfRC2 == 0)
        {
          while (*Length > 0)
            {
              BERSkipValue(Coder);
              *Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
            }
        }
      else
        {
          tASN1Component* LastComp = Type->RootComps2;
          CODER_NumOf_TYPE i = 0;

          for (; (LastComp->Type > 1) && (i < Type->NumOfRC2); LastComp++, i++ );

          while (*Length > 0)
            {
              tASN1Component* CurrComp = Type->RootComps2;
              do
                {
                  tASN1TypeInfo* CurrType = CurrComp->TypeInfo;

#ifndef CODER_NOUSE_OPEN
                  while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
#else
                  while (CurrType->TypeClass == type_ASN1_DEFINED)
#endif
                    CurrType = ((tASN1Defined*)CurrType)->BaseType;

                  if (CurrType->TypeClass & 0x1F)
                    {
                      if (((*(Coder->ER.DataCurr) & 0xC0) == tc_UT) && 
                          ((*(Coder->ER.DataCurr) & 0x1F) == (CurrType->TypeClass & 0x1F)))
                        return;
                    }
                  else
                    {
                      tBERTag EncTag;
                      unsigned char EncForm = 0;

                      BERPeekIdentifierOctet(Coder, &EncForm, &EncTag);
                      if (CurrType->TypeClass == type_ASN1_TAGGED)
                        {
                          if ((((tASN1Tagged*)CurrType)->Tags->Class == EncTag.Class) && 
                              (((tASN1Tagged*)CurrType)->Tags->Number == EncTag.Number))
                            return;
                        }
#ifndef CODER_NOUSE_CHOICE
                      else
                      if (CurrType->TypeClass == type_ASN1_CHOICE)
                        {
                          tASN1Alternative* AltInfo = NULL;
                          
                          BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, &EncTag, &AltInfo);
                          if (AltInfo != NULL)
                            return;
                        }
#endif
#ifndef CODER_NOUSE_OPEN
                      else
                      if (CurrType->TypeClass == type_ASN1_OPEN)
                        {
                          if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, &EncTag) == 1)
                            return;
                        }
#endif
                    }
                  CurrComp++;
                }
              while (CurrComp <= LastComp);
              BERSkipValue(Coder);
              *Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
            }
        }
    }
  else
    {
      if (Type->NumOfRC2 == 0)
        {                       
          while (!BERIsEOC(Coder))
            BERSkipValue(Coder);
        }
      else
        {
          tASN1Component* LastComp = Type->RootComps2;
          CODER_NumOf_TYPE i = 0;

          for (; (LastComp->Type > 1) && (i < Type->NumOfRC2); LastComp++, i++ );

          while (!BERIsEOC(Coder))
            {
              tASN1Component* CurrComp = Type->RootComps2;
              do
                {
                  tASN1TypeInfo* CurrType = CurrComp->TypeInfo;

#ifndef CODER_NOUSE_OPEN
                  while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
#else
                  while (CurrType->TypeClass == type_ASN1_DEFINED)
#endif
                    CurrType = ((tASN1Defined*)CurrType)->BaseType;
                  if (CurrType->TypeClass & 0x1F)
                    {
                      if (((*(Coder->ER.DataCurr) & 0xC0) == tc_UT) && 
                          ((*(Coder->ER.DataCurr) & 0x1F) == (CurrType->TypeClass & 0x1F)))
                        return;
                    }
                  else
                    {
                      tBERTag EncTag;
                      unsigned char EncForm = 0;

                      BERPeekIdentifierOctet(Coder, &EncForm, &EncTag);
                      if (CurrType->TypeClass == type_ASN1_TAGGED)
                        {
                          if ((((tASN1Tagged*)CurrType)->Tags->Class == EncTag.Class) && 
                              (((tASN1Tagged*)CurrType)->Tags->Number == EncTag.Number))
                            return;
                        }
#ifndef CODER_NOUSE_CHOICE
                      else
                      if (CurrType->TypeClass == type_ASN1_CHOICE)
                        {
                          tASN1Alternative* AltInfo = NULL;

                          BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, &EncTag, &AltInfo);
                          if (AltInfo != NULL)
                            return;
                        }
#endif
#ifndef CODER_NOUSE_OPEN
                      else
                      if (CurrType->TypeClass == type_ASN1_OPEN)
                        {
                          if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, &EncTag) == 1)
                            return;
                        }
#endif
                    }
                  CurrComp++;
                }
              while (CurrComp <= LastComp);
              BERSkipValue(Coder);
            }
        }
    }
}

#ifndef CODER_NOUSE_EXT
/**************************************************
 * NAME: BERDecodeStructExtGroup
 *       
 *
 */
static unsigned char
BERDecodeStructExtGroup(tCoder* Coder, tVMSULong* Length, tASN1Struct* Type, tASN1Component** Current, void* Val
                        ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1Component* CurrComp = *Current;
  CODER_NumOf_TYPE UR, DOD;
  CODER_NumOf_TYPE NumOfUndec, i;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeStructExtGroup\n");
#endif

  UR = DOD = NumOfUndec = i = 0;
  if (Length == NULL)
    {
      while ((i < (*Current)->Index) && (!BERIsEOC(Coder)))
        {
          void* CurrField;

          CurrComp++;
          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                {
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  UR++;
                  NumOfUndec++;
                }
              break;
            case ct_Optional:         
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  DOD++;
                }
              else
                {
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  NumOfUndec++;
                }
              break;
            case ct_Default:         
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  DOD++;
                }
              else
                {
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  NumOfUndec++;
                }
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          i++;
        }
    }
  else
    {
      tVMSULong CLength = *Length;
      unsigned char* CurrByte = Coder->ER.DataCurr;

      while ((i < (*Current)->Index) && (CLength > 0))
        {
          void* CurrField;

          CurrComp++;
          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  CLength -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                {
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  UR++;
                  NumOfUndec++;
                }
              break;
            case ct_Optional:         
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  DOD++;

                  CLength -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                {
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  NumOfUndec++;
                }
              break;
            case ct_Default:         
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                  DOD++;

                  CLength -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                {
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  NumOfUndec++;
                }
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          i++;
        }
    }
  while (i < (*Current)->Index)
    {
      CurrComp++; i++;
      
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          UR++;
          NumOfUndec++;
          break;
        case ct_Optional:         
          VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          NumOfUndec++;
          break;
        case ct_Default:         
          VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
          NumOfUndec++;
          break;
        case ct_Absent:
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                 ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
    }
  DECODING_ERROR_HANDLER_EXP((UR != 0) && (DOD != 0),
                             Coder, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);
  if (NumOfUndec == (*Current)->Index)
    {
      *Current = CurrComp;
      return 0;
    }
  *Current = CurrComp;
  return 1;
}
#endif /* CODER_NOUSE_EXT */


/**************************************************
 * NAME: BERDecodeStructComponentsWithExtAdd
 *       
 *
 */

static void
BERDecodeStructComponentsWithExtAdd(tCoder* Coder, tASN1Struct* Type, void* Val ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1Component* CurrComp;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeStructComponentsWithExtAdd\n");
#endif

  if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
    {
      Length = Type->NumOfRC1;
      /* Root 1 */
      CurrComp = Type->RootComps1;
      while (!BERIsEOC(Coder) && (Length > 0))
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
              EPDelField(Coder);
              break;
            case ct_Optional:                
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:                 
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          CurrComp++;
          Length--;
        }
      if (BERIsEOC(Coder))
        {
          while (Length > 0)
            {    
              switch(CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                  DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
                case ct_Optional:
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              Length--;
            }
        }

      /* Ext. Add. */
      CurrComp = Type->ExtAddComps;
      Length = Type->NumOfEAC;
      if (Length > 0)
        {
#ifndef CODER_NOUSE_EXT
          CODER_NumOf_TYPE UR = 0, DOD = 0;

          while (!BERIsEOC(Coder) && (Length > 0))
            {
              void* CurrField;

              switch (CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                  if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                    {
                      VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                      VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      EPSetField(Coder, CurrComp);
                      BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                      EPDelField(Coder);
                    }
                  else
                    {
                      VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      UR++;
                    }
                  break;
                case ct_Optional:                 
                  if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                    {
                      VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                      VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      EPSetField(Coder, CurrComp);
                      BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                      EPDelField(Coder);
                      DOD++;
                    }
                  else
                    VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:                 
                  if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                    {
                      VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                      VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      EPSetField(Coder, CurrComp);
                      BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                      EPDelField(Coder);
                      DOD++;
                    }
                  else
                    VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                  DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                             Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
                  break;
                case ct_Group:
                  Length -= CurrComp->Index;
                  if (BERDecodeStructExtGroup(Coder, NULL, Type, &CurrComp, Val ER_OLIST(List)) == 1)
                    DOD++;
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              Length--;
            }
          DECODING_ERROR_HANDLER_EXP((UR != 0) && (DOD != 0), Coder, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);
#endif /* CODER_NOUSE_EXT */
        }
      
      if (Length > 0)
        {
          do
            {    
              switch(CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                case ct_Optional:
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                case ct_Group:
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              Length--;
            }
          while (Length > 0);
        }
      else
      if (!BERIsEOC(Coder))
        BERSkipStructExtAdd(Coder, Type, &Length, er_Indefinite);

      CurrComp = Type->RootComps2;
      Length = Type->NumOfRC2;
      while (!BERIsEOC(Coder) && (Length > 0))
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
              EPDelField(Coder);
              break;
            case ct_Optional:                 
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:                 
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          CurrComp++;
          Length--;
        }
      if (BERIsEOC(Coder))
        {
          while (Length > 0)
            {    
              switch(CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                  DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
                case ct_Optional:
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              Length--;
            }
        }
      BERDecodeEOC(Coder);
    }
  else /* er_Definite */
    {
      CODER_NumOf_TYPE NumOfComps;
      unsigned char* CurrByte = Coder->ER.DataCurr;

      if (Coder->ER.DataEnd - Coder->ER.DataCurr < Length)
        BERAppendData(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));

      CurrComp = Type->RootComps1;
      NumOfComps = Type->NumOfRC1;
      while((Length > 0) && (NumOfComps > 0))
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
              EPDelField(Coder);

              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
              break;
            case ct_Optional:                
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:                 
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          CurrComp++;
          NumOfComps--;
        }
      if (Length == 0)
        {
          while (NumOfComps > 0)
            {    
              switch(CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                  DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
                case ct_Optional:
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              NumOfComps--;
              CurrComp++;
            }
        }
      NumOfComps = Type->NumOfEAC;
      CurrComp = Type->ExtAddComps;
      if (NumOfComps > 0)
        {
#ifndef CODER_NOUSE_EXT
          CODER_NumOf_TYPE UR = 0, DOD = 0;

          while ((Length > 0) && (NumOfComps > 0))
            {
              void* CurrField;

              switch (CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                  if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                    {
                      VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                      VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      EPSetField(Coder, CurrComp);
                      BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                      EPDelField(Coder);

                      Length -= Coder->ER.DataCurr - CurrByte;
                      CurrByte = Coder->ER.DataCurr;
                    }
                  else
                    {
                      VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      UR++;
                    }
                  break;
                case ct_Optional:                 
                  if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                    {
                      VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                      VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      EPSetField(Coder, CurrComp);
                      BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                      EPDelField(Coder);
                      DOD++;

                      Length -= Coder->ER.DataCurr - CurrByte;
                      CurrByte = Coder->ER.DataCurr;
                    }
                  else
                    VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:                 
                  if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                    {
                      VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                      VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                      EPSetField(Coder, CurrComp);
                      BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                      EPDelField(Coder);
                      DOD++;

                      Length -= Coder->ER.DataCurr - CurrByte;
                      CurrByte = Coder->ER.DataCurr;
                    }
                  else
                    VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                  DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                             Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
                  break;
                case ct_Group:
                  NumOfComps = (CODER_NumOf_TYPE)(NumOfComps - CurrComp->Index);
                  if (BERDecodeStructExtGroup(Coder, &Length, Type, &CurrComp, Val ER_OLIST(List)) == 1)
                    {
                      DOD++;
                      Length -= Coder->ER.DataCurr - CurrByte;
                      CurrByte = Coder->ER.DataCurr;
                    }
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              NumOfComps--;
            }
          DECODING_ERROR_HANDLER_EXP((UR != 0) && (DOD != 0), Coder, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);
#endif /* CODER_NOUSE_EXT */
        }

      if (NumOfComps > 0)
        {    
          do
            {
              switch(CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                case ct_Optional:
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                case ct_Group:
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              NumOfComps--;
            }
          while (NumOfComps > 0);
        }
      else
      if (Length > 0)
        {
          BERSkipStructExtAdd(Coder, Type, &Length, er_Definite);
          CurrByte = Coder->ER.DataCurr;
        }

      CurrComp = Type->RootComps2;
      NumOfComps = Type->NumOfRC2;
      while ((Length > 0) && (NumOfComps > 0))
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Required:
            case ct_Present:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);

              EPSetField(Coder, CurrComp);
              BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
              EPDelField(Coder);

              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
              break;
            case ct_Optional:                 
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:                 
              if (BERIsSpecifiedComponent(Coder, CurrComp) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  EPSetField(Coder, CurrComp);
                  BERDecVal(Coder, CurrComp->TypeInfo, CurrField, tk_Explicit ER_OLIST(List));
                  EPDelField(Coder);

                  Length -= Coder->ER.DataCurr - CurrByte;
                  CurrByte = Coder->ER.DataCurr;
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              DECODING_ERROR_HANDLER_EXP(BERIsSpecifiedComponent(Coder, CurrComp) == 1,
                                         Coder, ec_DEC_AbsentComponentIsPresent, NO_ARGS);
              break;
            default:
              INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                     ERR_ARG(__FILE__) ERR_ARG(__LINE__));
            }
          CurrComp++;
          NumOfComps--;
        }
      if (Length == 0)
        {
          while (NumOfComps > 0)
            {    
              switch(CurrComp->Type)
                {
                case ct_Required:
                case ct_Present:
                  DECODING_ERROR_HANDLER(Coder, ec_DEC_RequiredComponentIsAbsent, NO_ARGS);
                case ct_Optional:
                  VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Default:
                  VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                  break;
                case ct_Absent:
                  break;
                default:
                  INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError,
                                         ERR_ARG(__FILE__) ERR_ARG(__LINE__));
                }
              CurrComp++;
              NumOfComps--;
            }
        }
      else
        {
          DECODING_ERROR_HANDLER(Coder, ec_DEC_WrongLength, NO_ARGS);
        }
    }      
}

/**************************************************
 * NAME: BERDecodeStruct
 *       
 *
 */

static void
BERDecodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val ER_OLIST(tVMSOpenTypeList* List))
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeStruct\n");
#endif

  /* Initialization of Open type list (if current SEQUENCE/SET is root for Open type) */
#ifndef CODER_NOUSE_OPEN
  if (((tASN1Struct*)Type)->RootExtFlags & 0x10)
    {
      tVMSOpenTypeList LList;
     
      LList.Bodies = NULL;
      if (List != NULL)
        LList.Ids = List->Ids;
      else
        LList.Ids = NULL;

      /* Length & Content */
      if (((tASN1Struct*)Type)->RootExtFlags & 0x01)
        BERDecodeStructComponentsWithExtAdd(Coder, (tASN1Struct*)Type, Val, &LList);
      else
        BERDecodeStructComponents(Coder, (tASN1Struct*)Type, Val, &LList);

      /* Processing of Open type list */
      if (LList.Bodies != NULL)
        BERDecodeSkipedValues(Coder, &LList);

      if (List != NULL)
        {
          if (LList.Bodies != NULL)
            {
              if (List->Bodies != NULL)
                {
                  tVMSOpenBodyList* LastBody = List->Bodies;

                  while (LastBody->Next != NULL)
                    LastBody = LastBody->Next;
                  LastBody->Next = LList.Bodies;
                }
              else
                List->Bodies = LList.Bodies;
            }
          if (List->Ids == NULL)
            List->Ids = LList.Ids;
        }
      else
        {
          DECODING_ERROR_HANDLER_EXP(LList.Bodies != NULL,
                                     Coder, ec_DEC_NoOpenId, NO_ARGS);
          while (LList.Ids != NULL)
            {
              tVMSOpenIdList* CurrId = LList.Ids;
              LList.Ids = CurrId->Next;

              CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
            }
        }
    }
  else
#endif /* CODER_NOUSE_OPEN */
  if (((tASN1Struct*)Type)->RootExtFlags & 0x01)
    BERDecodeStructComponentsWithExtAdd(Coder, (tASN1Struct*)Type, Val ER_OLIST(List));
  else
    BERDecodeStructComponents(Coder, (tASN1Struct*)Type, Val ER_OLIST(List));
}
#endif /* !defined(CODER_NOUSE_SEQUENCE) || (!defined(CODER_NOUSE_SET) && !defined(CODER_BER_CANONICAL_OFF)) */


#ifndef CODER_NOUSE_SEQUENCE_OF
/*************************************************/
/***************** SEQUENCE OF *******************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeSEQUENCE_OF
 *       
 *
 */

static void
BEREncodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSeqOf/*, tASN1TagKind TagKind*/)
{
  tVMSULong SeqOfSize = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeSEQUENCE_OF\n");
#endif

  VMSGetSizeSEQUENCE_OF(Coder, vSeqOf, Type, SeqOfSize);
  CUCFCheckSEQUENCE_OF(Coder, Type, SeqOfSize);

  if (Coder->ER.Rule & er_Definite)
    {
      tVMSULong Start = Coder->ER.MemEnd - Coder->ER.DataCurr;
  
      /* Content */
      EPSetField(Coder, &SeqOfSize);
      while (SeqOfSize > 0)
        {
          void* CurrElem = NULL;
          
          SeqOfSize--;
          VMSGetComponentSEQUENCE_OF(Coder, vSeqOf, Type, SeqOfSize, CurrElem);
          BEREncVal(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrElem, tk_Explicit);
        }
      EPDelField(Coder);

      /* Length */
      BEREncodeDefiniteLength(Coder, (Coder->ER.MemEnd - Coder->ER.DataCurr) - Start);
    }
  else
    {
      /* End of content */
      BEREncodeEOC(Coder);
      
      /* Content */
      EPSetField(Coder, &SeqOfSize);
      while (SeqOfSize > 0)
        {
          void* CurrElem = NULL;
          
          SeqOfSize--;
          VMSGetComponentSEQUENCE_OF(Coder, vSeqOf, Type, SeqOfSize, CurrElem);
          BEREncVal(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrElem, tk_Explicit);
        }
      EPDelField(Coder);

      /* Start of content */
      BERPutByte(Coder, 0x80);
    }
}


/**************************************************
 * NAME: BERDecodeSEQUENCE_OF
 *       
 *
 */

static void
BERDecodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSeqOf ER_OLIST(tVMSOpenTypeList* List))
{
  void* CurrElem = NULL;
  tVMSULong Length = 0;
  tVMSULong Index = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeSEQUENCE_OF\n");
#endif

  VMSInitSEQUENCE_OF(Coder, vSeqOf, Type);

#ifndef CODER_NOUSE_OPEN
  if (List != NULL)
    {
      tVMSOpenTypeList LList;

      LList.Bodies = NULL;
      LList.Ids = List->Ids;

      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        { 
          EPSetField(Coder, &Index);
          while (!BERIsEOC(Coder))
            {
              VMSInitComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              BERDecVal(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrElem, tk_Explicit, &LList);

              VMSSetComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              while (LList.Ids != List->Ids)
                {
                  tVMSOpenIdList* CurrId = LList.Ids;
                  
                  LList.Ids = CurrId->Next;
                  CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
                }
              Index++;
            }
          EPDelField(Coder);

          BERDecodeEOC(Coder);
        }
      else
        {
          unsigned char* CurrByte = Coder->ER.DataCurr;

          EPSetField(Coder, &Index);
          while (Length > 0)
            {
              VMSInitComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              BERDecVal(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrElem, tk_Explicit, &LList);

              VMSSetComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              while (LList.Ids != List->Ids)
                {
                  tVMSOpenIdList* CurrId = LList.Ids;
                  
                  LList.Ids = CurrId->Next;
                  CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0); /* !!!!! */
                }
              Index++;
              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
            }
          EPDelField(Coder);
        }

      if (LList.Bodies != NULL)
        {
          if (List->Bodies != NULL)
            {
              tVMSOpenBodyList* LastBody = List->Bodies;
              
              while (LastBody->Next != NULL)
                LastBody = LastBody->Next;
              LastBody->Next = LList.Bodies;
            }
          else
            List->Bodies = LList.Bodies;
        }
    }
  else
#endif /* CODER_NOUSE_OPEN */
    {
      /* Content */
      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        { 
          EPSetField(Coder, &Index);
          while (!BERIsEOC(Coder))
            {
              VMSInitComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              BERDecVal(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrElem, tk_Explicit ER_OLIST(List));

              VMSSetComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              Index++;
            }
          EPDelField(Coder);
          BERDecodeEOC(Coder);
        }
      else
        {
          unsigned char* CurrByte = Coder->ER.DataCurr;
          
          EPSetField(Coder, &Index);
          while (Length > 0)
            {
              VMSInitComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              BERDecVal(Coder, ((tASN1SequenceOf*)Type)->BaseType, CurrElem, tk_Explicit ER_OLIST(NULL));

              VMSSetComponentSEQUENCE_OF(Coder, vSeqOf, Type, Index, CurrElem);
              Index++;
              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
            }
          EPDelField(Coder);
        }
    }
  CUCFCheckSEQUENCE_OF(Coder, Type, Index);
}
#endif /* CODER_NOUSE_SEQUENCE_OF */


#ifndef CODER_NOUSE_SET_OF
/*************************************************/
/******************* SET OF **********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeSET_OF
 *       
 *
 */

static void
BEREncodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSetOf/*, tASN1TagKind TagKind*/)
{
  tVMSULong SetOfSize;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeSET_OF\n");
#endif

  VMSGetSizeSET_OF(Coder, vSetOf, Type, SetOfSize);
  CUCFCheckSET_OF(Coder, Type, SetOfSize);

  if (Coder->ER.Rule & er_Definite)
    {
      tVMSULong Start = Coder->ER.MemEnd - Coder->ER.DataCurr;

      /* Content */
      EPSetField(Coder, &SetOfSize);
      while (SetOfSize > 0)
        {
          void* CurrElem = NULL;

          SetOfSize--;
          VMSGetComponentSET_OF(Coder, vSetOf, Type, SetOfSize, CurrElem);
          BEREncVal(Coder, ((tASN1SetOf*)Type)->BaseType, CurrElem, tk_Explicit);
        }
      EPDelField(Coder);
      /* Length */
      BEREncodeDefiniteLength(Coder, (Coder->ER.MemEnd - Coder->ER.DataCurr) - Start);
    }
  else
    {
      /* End of content */
      BEREncodeEOC(Coder);
      
      /* Content */
      EPSetField(Coder, &SetOfSize);
      while (SetOfSize > 0)
        {
          void* CurrElem = NULL;

          SetOfSize--;
          VMSGetComponentSET_OF(Coder, vSetOf, Type, SetOfSize, CurrElem);
          BEREncVal(Coder, ((tASN1SetOf*)Type)->BaseType, CurrElem, tk_Explicit);
        }
      EPDelField(Coder);

      /* Start of content */
      BERPutByte(Coder, 0x80);
    }
}

/**************************************************
 * NAME: BERDecodeSET_OF
 *       
 *
 */

static void
BERDecodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSetOf ER_OLIST(tVMSOpenTypeList* List))
{
  void* CurrElem;
  tVMSULong Length = 0;
  tVMSULong Index = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeSET_OF\n");
#endif

  VMSInitSET_OF(Coder, vSetOf, Type);

#ifndef CODER_NOUSE_OPEN
  if (List != NULL)
    {
      tVMSOpenTypeList LList;

      LList.Bodies = NULL;
      LList.Ids = List->Ids;

      /* Content */
      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        {
          EPSetField(Coder, &Index);
          while (!BERIsEOC(Coder))
            {
              VMSInitComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              BERDecVal(Coder, ((tASN1SetOf*)Type)->BaseType, CurrElem, tk_Explicit, &LList);

              VMSSetComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              Index++;
              while (LList.Ids != List->Ids)
                {
                  tVMSOpenIdList* CurrId = LList.Ids;
                  
                  LList.Ids = CurrId->Next;
                  CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
                }
            }
          EPDelField(Coder);
          BERDecodeEOC(Coder);
        }
      else
        {
          unsigned char* CurrByte = Coder->ER.DataCurr;

          EPSetField(Coder, &Index);
          while (Length > 0)
            {
              VMSInitComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              BERDecVal(Coder, ((tASN1SetOf*)Type)->BaseType, CurrElem, tk_Explicit, &LList);

              VMSSetComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              Index++;
              while (LList.Ids != List->Ids)
                {
                  tVMSOpenIdList* CurrId = LList.Ids;
                  
                  LList.Ids = CurrId->Next;
                  CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
                }            
              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
            }
          EPDelField(Coder);
        }
      if (LList.Bodies != NULL)
        {
          if (List->Bodies != NULL)
            {
              tVMSOpenBodyList* LastBody = List->Bodies;
              
              while (LastBody->Next != NULL)
                LastBody = LastBody->Next;
              LastBody->Next = LList.Bodies;
            }
          else
            List->Bodies = LList.Bodies;
        }
    }
  else
#endif /* CODER_NOUSE_OPEN */
    {
      /* Content */
      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        {
          EPSetField(Coder, &Index);
          while (!BERIsEOC(Coder))
            {
              VMSInitComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              BERDecVal(Coder, ((tASN1SetOf*)Type)->BaseType, CurrElem, tk_Explicit ER_OLIST(NULL));

              VMSSetComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              Index++;
            }
          EPDelField(Coder);
          BERDecodeEOC(Coder);
        }
      else
        {
          unsigned char* CurrByte = Coder->ER.DataCurr;

          EPSetField(Coder, &Index);
          while (Length > 0)
            {
              VMSInitComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              BERDecVal(Coder, ((tASN1SetOf*)Type)->BaseType, CurrElem, tk_Explicit ER_OLIST(NULL));

              VMSSetComponentSET_OF(Coder, vSetOf, Type, CurrElem);
              Length -= Coder->ER.DataCurr - CurrByte;
              CurrByte = Coder->ER.DataCurr;
              Index++;
            }
          EPDelField(Coder);
        }
    }
  CUCFCheckSET_OF(Coder, Type, Index);
}
#endif /* CODER_NOUSE_SEQUENCE */

#ifndef CODER_NOUSE_CHOICE
/*************************************************/
/******************* CHOICE **********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeCHOICE
 *       
 *
 */

static void
BEREncodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  void*             AltVal;
  tASN1Alternative* AltInfo = NULL;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeCHOICE\n");
#endif

  VMSGetAlternativeCHOICE(Coder, Val, Type, AltInfo, AltVal);

  if (TagKind == tk_Explicit)
    {
      EPSetField(Coder, AltInfo);
      BEREncVal(Coder, AltInfo->TypeInfo, AltVal, tk_Explicit);
      EPDelField(Coder);
    }
  else
    {
      if (Coder->ER.Rule & er_Definite)
        {
          tVMSULong Start = Coder->ER.MemEnd - Coder->ER.DataCurr;
          
          EPSetField(Coder, AltInfo);
          BEREncVal(Coder, AltInfo->TypeInfo, AltVal, tk_Explicit);
          EPDelField(Coder);
          
          BEREncodeDefiniteLength(Coder, (Coder->ER.MemEnd - Coder->ER.DataCurr) - Start);
        }
      else
        {
          BEREncodeEOC(Coder);
          
          EPSetField(Coder, AltInfo);
          BEREncVal(Coder, AltInfo->TypeInfo, AltVal, tk_Explicit);
          EPDelField(Coder);
          
          BERPutByte(Coder, 0x80);
        }
    }
}

/**************************************************
 * NAME: BERGetCHOICEAlternative
 *       
 *
 */

static void
BERGetCHOICEAlternative(tCoder* Coder, tASN1Choice* Type, tBERTag* Tag, tASN1Alternative** AltInfo)
{
  tASN1Alternative* CurrAlt = Type->Alternatives;
  CODER_NumOf_TYPE  NumOfAlts = Type->NumOfAlts;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERGetCHOICEAlternative\n");
#endif

  *AltInfo = NULL;
  while (NumOfAlts > 0)
    {
      tASN1TypeInfo* CurrType = CurrAlt->TypeInfo;

#ifndef CODER_NOUSE_OPEN
      while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
#else
      while (CurrType->TypeClass == type_ASN1_DEFINED)
#endif
        CurrType = ((tASN1Defined*)CurrType)->BaseType;
      if (CurrType->TypeClass & 0x1F)
        {
          if ((Tag->Class == tc_UT) && (Tag->Number == (tASN1TagClassNumber)(CurrType->TypeClass & 0x1F)))
            {
              *AltInfo = CurrAlt;
              return;
            }
        }
      else
      if (CurrType->TypeClass == type_ASN1_TAGGED)
        {
          if ((((tASN1Tagged*)CurrType)->Tags->Class == Tag->Class) && 
              (((tASN1Tagged*)CurrType)->Tags->Number == Tag->Number))
            {
              *AltInfo = CurrAlt;
              return;
            }
        }
      else
      if (CurrType->TypeClass == type_ASN1_CHOICE)
        {
          BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, Tag, AltInfo);
          if (*AltInfo != NULL)
            {
              *AltInfo = CurrAlt;
              return;
            }
        }
#ifndef CODER_NOUSE_OPEN
      else
      if (CurrType->TypeClass == type_ASN1_OPEN)
        {
          if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, Tag) == 1)
            {
              *AltInfo = CurrAlt;
              return;
            }
        }
#endif

      CurrAlt++;
      NumOfAlts--;
    }
}

/**************************************************
 * NAME: BERDecodeCHOICE
 *       
 *
 */

static void
BERDecodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind ER_OLIST(tVMSOpenTypeList* List))
{
  void* AltVal;
  tASN1Alternative* AltInfo = NULL;
  tBERTag EncTag;
  unsigned char EncForm;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeCHOICE\n");
#endif

  VMSInitCHOICE(Coder, Val, Type);
  BERPeekIdentifierOctet(Coder, &EncForm, &EncTag);
  BERGetCHOICEAlternative(Coder, (tASN1Choice*)Type, &EncTag, &AltInfo);
  DECODING_ERROR_HANDLER_EXP(AltInfo == NULL,
                             Coder, ec_DEC_UnknownAlternative, NO_ARGS);

  VMSSetAlternativeCHOICE(Coder, Val, Type, AltInfo, AltVal);

  EPSetField(Coder, AltInfo);
  BERDecVal(Coder, AltInfo->TypeInfo, AltVal, tk_Explicit ER_OLIST(List));
  EPDelField(Coder);
}
#endif

/*************************************************/
/******************* DEFINED *********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeDEFINED
 *       
 *
 */

static void
BEREncodeDEFINED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  tASN1TypeInfo* NextType = ((tASN1Defined*)Type)->BaseType;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeDEFINED\n");
#endif

#ifndef CODER_NOUSE_OPEN
  while ((NextType->TypeClass == type_ASN1_DEFINED) || (NextType->TypeClass == type_ASN1_OPEN_ID))
#else
  while (NextType->TypeClass == type_ASN1_DEFINED)
#endif
    NextType = ((tASN1Defined*)NextType)->BaseType;
  BEREncVal(Coder, NextType, Val, TagKind);
}
  
 /**************************************************
 * NAME: BERDecodeDEFINED
 *       
 *
 */

static void
BERDecodeDEFINED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1TypeInfo* NextType = ((tASN1Defined*)Type)->BaseType;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeDEFINED\n");
#endif

  while (NextType->TypeClass == type_ASN1_DEFINED)
    NextType = ((tASN1Defined*)NextType)->BaseType;
  BERDecVal(Coder, NextType, Val, TagKind ER_OLIST(List));
}

/*************************************************/
/******************* TAGGED **********************/
/*************************************************/

/**************************************************/
/***************** Encoding Form ******************/
/**************************************************/

#ifdef CODER_BER_CONSTRUCTED
#define CBC_PARAM(Val) ,Val
#else
#define CBC_PARAM(Val)
#endif

/**************************************************
 * NAME: BERGetEncForm
 *       
 *
 */
static unsigned char
BERGetEncForm(tCoder* Coder, tASN1TypeInfo* Type CBC_PARAM(void* Val))
{
#ifdef CODER_BER_CONSTRUCTED
  tVMSString vString;
#endif

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERGetEncForm\n");
#endif

  switch (Type->TypeClass & 0x1F)
    {
#ifdef CODER_BER_CONSTRUCTED
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      VMSGetLengthBIT_STRING(Coder, Val, Type, vString);
      if (vString.Length > ((CODER_BER_CONSTRUCTED_LENGTH - 1) << 3))
        return bef_Constructed;
      else
        return bef_Primitive;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      VMSGetLengthOCTET_STRING(Coder, Val, Type, vString);
      if (vString.Length > (CODER_BER_CONSTRUCTED_LENGTH << 1))
        return bef_Constructed;
      else
        return bef_Primitive;
#endif      
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
      VMSGetLengthNumericString(Coder, Val, Type, vString);
      if (vString.Length > CODER_BER_CONSTRUCTED_LENGTH)
        return bef_Constructed;
      else
        return bef_Primitive;
    case type_ASN1_PrintableString:
      VMSGetLengthPrintableString(Coder, Val, Type, vString);
      if (vString.Length > CODER_BER_CONSTRUCTED_LENGTH)
        return bef_Constructed;
      else
        return bef_Primitive;
    case type_ASN1_IA5String:
      VMSGetLengthIA5String(Coder, Val, Type, vString);
      if (vString.Length > CODER_BER_CONSTRUCTED_LENGTH)
        return bef_Constructed;
      else
        return bef_Primitive;
    case type_ASN1_VisibleString:
      VMSGetLengthVisibleString(Coder, Val, Type, vString);
      if (vString.Length > CODER_BER_CONSTRUCTED_LENGTH)
        return bef_Constructed;
      else
        return bef_Primitive;
    case type_ASN1_UTCTime:
      VMSGetLengthUTCTime(Coder, Val, Type, vString);
      if (vString.Length > CODER_BER_CONSTRUCTED_LENGTH)
        return bef_Constructed;
      else
        return bef_Primitive;
    case type_ASN1_GeneralizedTime:
      VMSGetLengthGeneralizedTime(Coder, Val, Type, vString);
      if (vString.Length > CODER_BER_CONSTRUCTED_LENGTH)
        return bef_Constructed;
      else
        return bef_Primitive;
#endif
#endif /* CODER_BER_CONSTRUCTED */

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SEQUENCE_OF)
    case type_ASN1_SEQUENCE: /* SEQUENCE_OF */
      return bef_Constructed;
#endif

#if !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_SET_OF)
    case type_ASN1_SET: /* SET_OF */
      return bef_Constructed;
#endif
    default:
      switch (Type->TypeClass)
        {
#ifndef CODER_NOUSE_CHOICE
        case  type_ASN1_CHOICE:
          return bef_Constructed;
#endif

#ifndef CODER_NOUSE_OPEN
        case type_ASN1_OPEN:
          return bef_Constructed;
        case type_ASN1_OPEN_ID:
#endif

        case type_ASN1_TAGGED:
        case type_ASN1_DEFINED:
          return BERGetEncForm (Coder, ((tASN1Defined*)Type)->BaseType CBC_PARAM(Val));

        default:
          break;
        }
    }
  return bef_Primitive;
}

/**************************************************
 * NAME: BEREncodeTAGGED
 *       
 *
 */

static void
BEREncodeTAGGED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind)
{
  unsigned char EncForm;
  tASN1TypeInfo* NextType = ((tASN1Tagged*)Type)->BaseType;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeTAGGED\n");
#endif

  while ((NextType->TypeClass == type_ASN1_DEFINED) || (NextType->TypeClass == type_ASN1_TAGGED)
#ifndef CODER_NOUSE_OPEN
         || (NextType->TypeClass == type_ASN1_OPEN_ID)
#endif         
         )
    NextType = ((tASN1Defined*)NextType)->BaseType;
  EncForm = BERGetEncForm(Coder, NextType CBC_PARAM(Val));
  if (Coder->ER.Rule & er_Definite)
    {
      tVMSULong Start = Coder->ER.MemEnd - Coder->ER.DataCurr;

      BEREncVal(Coder, NextType, Val, tk_Implicit);

      if (((tASN1Tagged*)Type)->NumOfTags > 1)
        {
          tVMSULong Counter = ((tASN1Tagged*)Type)->NumOfTags - 1;
          tASN1Tag* CurrTag = ((tASN1Tagged*)Type)->Tags + Counter;

          BEREncodeIdentifierOctet(Coder, EncForm, CurrTag);
          CurrTag--;
          while (Counter > 0)
            {
              BEREncodeDefiniteLength(Coder, (Coder->ER.MemEnd - Coder->ER.DataCurr) - Start);
              BEREncodeIdentifierOctet(Coder, bef_Constructed, CurrTag);
              CurrTag--;
              Counter--;
            }
        }
      else
        BEREncodeIdentifierOctet(Coder, EncForm, ((tASN1Tagged*)Type)->Tags);
    }
  else
    {
      if (((tASN1Tagged*)Type)->NumOfTags > 1)
        {
          tVMSULong Counter = ((tASN1Tagged*)Type)->NumOfTags - 1;
          tASN1Tag* CurrTag = ((tASN1Tagged*)Type)->Tags + Counter;

          while (Counter > 0)
            {
              BEREncodeEOC(Coder);
              Counter--;
            }

          BEREncVal(Coder, NextType, Val, tk_Implicit);

          Counter = ((tASN1Tagged*)Type)->NumOfTags - 1;
          BEREncodeIdentifierOctet(Coder, EncForm, CurrTag);
          CurrTag--;
          while (Counter > 0)
            {
              BERPutByte(Coder, 0x80);
              BEREncodeIdentifierOctet(Coder, bef_Constructed, CurrTag);
              CurrTag--;
              Counter--;
            }
        }
      else
        {
          BEREncVal(Coder, NextType, Val, tk_Implicit);

          BEREncodeIdentifierOctet(Coder, EncForm, ((tASN1Tagged*)Type)->Tags);
        }
    }
}

/**************************************************
 * NAME: BERDecodeTAGGED
 *       
 *
 */

static void
BERDecodeTAGGED(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind ER_OLIST(tVMSOpenTypeList* List))
{
  tASN1TypeInfo* NextType = ((tASN1Tagged*)Type)->BaseType;
  unsigned char EncForm = 0;
  tVMSULong NumOfEOC = 0;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeTAGGED\n");
#endif

  while ((NextType->TypeClass == type_ASN1_DEFINED) || (NextType->TypeClass == type_ASN1_TAGGED))
    NextType = ((tASN1Defined*)NextType)->BaseType;
  if (TagKind == tk_Explicit)
    {
      tBERTag EncTag;

      BERDecodeIdentifierOctet(Coder, &EncForm, &EncTag);
      if (((tASN1Tagged*)Type)->NumOfTags > 1)
        {
          tVMSULong Counter = ((tASN1Tagged*)Type)->NumOfTags - 1;
          tASN1Tag* CurrTag = ((tASN1Tagged*)Type)->Tags;
          DECODING_ERROR_HANDLER_EXP((EncTag.Number != CurrTag->Number) || (EncTag.Class != CurrTag->Class),
                                     Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
          if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
            {
              NumOfEOC++;
              CurrTag++;
              while (Counter > 1)
                {
                  BERDecodeIdentifierOctet(Coder, &EncForm, &EncTag);
                  DECODING_ERROR_HANDLER_EXP((EncTag.Number != CurrTag->Number) || (EncTag.Class != CurrTag->Class),
                                             Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
                  CurrTag++;
                  if (Coder->ER.DataEnd == Coder->ER.DataCurr)
                    BERAppendData(Coder, 1);
                  Coder->ER.DataCurr++;
                  NumOfEOC++;
                  Counter--;
                }
            }
          else
            {
              CurrTag++;
              while (Counter > 1)
                {
                  BERDecodeIdentifierOctet(Coder, &EncForm, &EncTag);
                  DECODING_ERROR_HANDLER_EXP((EncTag.Number != CurrTag->Number) || (EncTag.Class != CurrTag->Class),
                                             Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
                  CurrTag++;
                  BERDecodeDefiniteLength(Coder, &Length);
                  Counter--;
                }
            }
          BERDecodeIdentifierOctet(Coder, &EncForm, &EncTag);
          DECODING_ERROR_HANDLER_EXP((EncTag.Number != CurrTag->Number) || (EncTag.Class != CurrTag->Class),
                                     Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
        }
      else
        {
          DECODING_ERROR_HANDLER_EXP((EncTag.Number != ((tASN1Tagged*)Type)->Tags->Number) ||
                                     (EncTag.Class != ((tASN1Tagged*)Type)->Tags->Class),
                                     Coder, ec_DEC_WrongIdentifierOctet, NO_ARGS);
        }
    }

#if !defined(CODER_NOUSE_CHOICE) || !defined(CODER_NOUSE_OPEN)
  if ((NextType->TypeClass == type_ASN1_CHOICE) || (NextType->TypeClass == type_ASN1_OPEN))
    {
      if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
        NumOfEOC++;
    }
#ifndef CODER_NOUSE_OPEN
  else
  if (NextType->TypeClass == type_ASN1_OPEN_ID)
    {
      tASN1TypeInfo* BaseType = ((tASN1OpenId*)NextType)->BaseType;

      while (BaseType->TypeClass == type_ASN1_DEFINED)
        BaseType = ((tASN1Defined*)BaseType)->BaseType;

      if ((BaseType->TypeClass == type_ASN1_CHOICE) || (BaseType->TypeClass == type_ASN1_OPEN))
        {
          if ((BERDecodeDefiniteLength(Coder, &Length) == 1) && (Length == 0x80))
            NumOfEOC++;
        }
    }
#endif /* CODER_NOUSE_OPEN */
#endif /* !defined(CODER_NOUSE_CHOICE) || !defined(CODER_NOUSE_OPEN) */

  BERDecVal(Coder, NextType, Val, (unsigned char)(EncForm | tk_Implicit) ER_OLIST(List));

  while (NumOfEOC > 0)
    {
      BERDecodeEOC(Coder);
      NumOfEOC--;
    }
}


#ifndef CODER_NOUSE_OPEN
/*************************************************/
/******************* OPEN ID *********************/
/*************************************************/

/**************************************************
 * NAME: BERDecodeOPEN_ID
 *       
 *
 */

static void
BERDecodeOPEN_ID(tCoder* Coder, tASN1TypeInfo* Type, void* vOpenId, tASN1TagKind TagKind, tVMSOpenTypeList* List)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeOPEN_ID\n");
#endif

  BERDecVal(Coder, ((tASN1OpenId*)Type)->BaseType, vOpenId, TagKind, NULL);
  BERPutOpenId(Coder, Type, vOpenId, List);
}

/*************************************************/
/******************** OPEN ***********************/
/*************************************************/

/**************************************************
 * NAME: BEREncodeOPEN
 *       
 *
 */

static void
BEREncodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* vOpen, tASN1TagKind TagKind)
{
  void* Object;
  tASN1Object* ObjectInfo = NULL;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncodeOPEN\n");
#endif

  VMSGetObjectOPEN(Coder, vOpen, Type, ObjectInfo, Object);

  if (TagKind == tk_Explicit)
    {
      EPSetField(Coder, ObjectInfo);
      BEREncVal(Coder, ObjectInfo->TypeInfo, Object, tk_Explicit);
      EPDelField(Coder);
    }
  else
    {
      if (Coder->ER.Rule & er_Definite)
        {
          tVMSULong Start = Coder->ER.MemEnd - Coder->ER.DataCurr;
          
          EPSetField(Coder, ObjectInfo);
          BEREncVal(Coder, ObjectInfo->TypeInfo, Object, tk_Explicit);
          EPDelField(Coder);
          BEREncodeDefiniteLength(Coder, (Coder->ER.MemEnd - Coder->ER.DataCurr) - Start);
        }
      else
        {
          BEREncodeEOC(Coder);
          
          EPSetField(Coder, ObjectInfo);
          BEREncVal(Coder, ObjectInfo->TypeInfo, Object, tk_Explicit);
          EPDelField(Coder);
          BERPutByte(Coder, 0x80);
        }
    }
}

/**************************************************
 * NAME: BERIsOPENTypeObject
 *       
 *
 */
static unsigned char
BERIsOPENTypeObject(tCoder* Coder, tASN1Open* Type, tBERTag* Tag)
{
  tASN1Object* CurrObj = Type->Objects;
  CODER_NumOf_TYPE  NumOfObjs = Type->NumOfObjects;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERIsOPENTypeObject\n");
#endif

  while (NumOfObjs > 0)
    {
      tASN1TypeInfo* CurrType = CurrObj->TypeInfo;

      while ((CurrType->TypeClass == type_ASN1_DEFINED) || (CurrType->TypeClass == type_ASN1_OPEN_ID))
        CurrType = ((tASN1Defined*)CurrType)->BaseType;

      if (CurrType->TypeClass & 0x1F)
        {
          if ((Tag->Class == tc_UT) && (Tag->Number == (tASN1TagClassNumber)(CurrType->TypeClass & 0x1F)))
            return 1;
        }
      else
      if (CurrType->TypeClass == type_ASN1_TAGGED)
        {
          if ((((tASN1Tagged*)CurrType)->Tags->Class == Tag->Class) && 
              (((tASN1Tagged*)CurrType)->Tags->Number == Tag->Number))
            return 1;
          }
      else
#ifndef CODER_NOUSE_CHOICE
      if (CurrType->TypeClass == type_ASN1_CHOICE)
        {
          tASN1Alternative* AltInfo = NULL;
          BERGetCHOICEAlternative(Coder, (tASN1Choice*)CurrType, Tag, &AltInfo);
          if (AltInfo != NULL)
            return 1;
        }
      else
#endif
      if (CurrType->TypeClass == type_ASN1_OPEN)
        {
          if (BERIsOPENTypeObject(Coder, (tASN1Open*)CurrType, Tag) == 1)
            return 1;
        }
      CurrObj++;
      NumOfObjs--;
    }
  return 0;
}


/**************************************************
 * NAME: BERDecodeOPEN
 *       
 *
 */
static void
BERDecodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tASN1TagKind TagKind, tVMSOpenTypeList* List)
{
  tVMSOpenIdList* CurrId = List->Ids;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeOPEN\n");
#endif

  VMSInitOPEN(Coder, Val, Type);
  
  while (CurrId != NULL)
    {
      tASN1TypeInfo* CType = ((tASN1Open*)Type)->OpenIdType;

      while (CType->TypeClass == type_ASN1_DEFINED)
        CType = ((tASN1Defined*)CType)->BaseType;
      if ((void*)CType == CurrId->Type)
        {
          tASN1Object* ObjectInfo;
          tVMSULong ObjIndex = 0;

          ObjectInfo = BERGetOpenTypeObject(Coder, Type, CurrId->Val, &ObjIndex);
          if (ObjectInfo != NULL)
            {
              void* ObjectVal;

              VMSSetObjectOPEN(Coder, Val, Type, ObjectInfo, ObjectVal);
              EPSetField(Coder, ObjectInfo);
              BERDecVal(Coder, ObjectInfo->TypeInfo, ObjectVal, tk_Explicit, NULL);
              EPDelField(Coder);
            }
          else
            DECODING_ERROR_HANDLER(Coder, ec_DEC_UnknownObject, NO_ARGS);
          break;
        }
      CurrId = CurrId->Next;
    }
  if (CurrId == NULL)
    {
      tVMSOpenTypeInfo Info;
      
      Info.DataPtr = Coder->ER.DataCurr;

      BERPutOpenBody(Coder, Type, Val, List, &Info);
      BERSkipValue(Coder);
    }
}

/**************************************************
 * NAME: BERDecodeBodies
 *       
 *
 */

static void
BERDecodeBodies(tCoder* Coder, char* Changes, tVMSOpenTypeList* List)
{
  tVMSOpenBodyList *PrevBody, *CurrBody = List->Bodies;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeBodies\n");
#endif
  
  PrevBody = CurrBody;

  while (CurrBody != NULL)
    {
      tVMSOpenIdList* CurrId = List->Ids;
      tASN1TypeInfo* Type = ((tASN1Open*)(CurrBody->Type))->OpenIdType;

      while (Type->TypeClass == type_ASN1_DEFINED)
        Type = ((tASN1Defined*)Type)->BaseType;      
      while (CurrId != NULL)
        {
          if ((void*)Type == CurrId->Type)
            {
              /* Ok! We have decoded id! */
              tVMSULong ObjIndex = 0;
              tASN1Object* ObjectInfo = BERGetOpenTypeObject(Coder, (tASN1TypeInfo*)CurrBody->Type, CurrId->Val, &ObjIndex);

              if (ObjectInfo != NULL)
                {
                  void* ObjectVal;
                  unsigned char* CurrByte = Coder->ER.DataCurr;

                  Coder->ER.DataCurr = (unsigned char*)CurrBody->DataPtr;
                  VMSSetObjectOPEN(Coder, CurrBody->Val, CurrBody->Type, ObjectInfo, ObjectVal);
                  EPSetField(Coder, ObjectInfo);
                  BERDecVal(Coder, ObjectInfo->TypeInfo, ObjectVal, tk_Explicit, NULL);
                  EPDelField(Coder);
                  Coder->ER.DataCurr = CurrByte;
                  CurrBody->DataPtr = NULL;
                  break;
                }
              else
                DECODING_ERROR_HANDLER(Coder, ec_DEC_UnknownObject, NO_ARGS);
            }
          CurrId = CurrId->Next;
        }
      if (CurrBody->DataPtr == NULL)
        {
          /* We have decoded body. Lets free unused memory */
          (*Changes) |= 1; /* Changes in List */
          if (CurrBody == List->Bodies)
            {
              /* First element */
              List->Bodies = CurrBody->Next;
              CUCFFree(Coder, CurrBody, sizeof(tVMSOpenBodyList), 0);
              CurrBody = PrevBody = List->Bodies;
            }
          else
            {
              PrevBody->Next = CurrBody->Next;
              CUCFFree(Coder, CurrBody, sizeof(tVMSOpenBodyList), 0);
              CurrBody = PrevBody->Next;
            }
        }
      else
        {
          PrevBody = CurrBody;
          CurrBody = CurrBody->Next;
        }
    }
}

/**************************************************
 * NAME: BERDecodeSkipedValues
 *       
 *
 */

static void
BERDecodeSkipedValues(tCoder* Coder, tVMSOpenTypeList* List)
{
  char Changes = 0;  /* 1 - Changes are presents, 0 - no any changes */
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecodeSkipedValues\n");
#endif

  for (;;)
    {
      if (List->Bodies != NULL)
        BERDecodeBodies(Coder, &Changes, List);
      if (Changes == 0)
        break;
      Changes = 0;
    }
}
#endif /* CODER_NOUSE_OPEN */

#endif /* !CODER_REMOVE_BER */
